{
 "metadata": {
  "name": "NLP15 HW1 Example"
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": "Fetching and Cleaning HTML Text"
    },
    {
     "cell_type": "heading",
     "level": 3,
     "metadata": {},
     "source": "NLP 2015 - HW1"
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "November 2014 - [NLP15](http://www.cs.bgu.ac.il/~elhadad/nlp15.html)"
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "We will compare two different methods to clean raw HTML text into text.\nHTML pages contain many \"non textual\" elements, in the form of HTML tags, jscript code, lots of advertisement and in general repetitive content which we will refer to as \"boilerplate\" content (menus, navigation etc).\n\nWe are intersted in extracting from a random HTML page the non-boilerplate textual content.\n\nWe will compare two libraries that achieve this.\n\nFirst, let us get raw HTML from a URL:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "import urllib2\n\nurl = \"http://www.bbc.com/news/technology-26415021\"\nhtml = urllib2.urlopen(url).read()",
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 1
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Let us inspect the resulting raw HTML string we obtained:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "print html[:200].replace(",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML+RDFa 1.0//EN\" \"http://www.w3.org/MarkUp/DTD/xhtml-rdfa-1.dtd\">\n\n\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xmlns:og=\"http://opengraphprotocol.org/schema/\" xml\n"
      }
     ],
     "prompt_number": 3
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Too many white spaces and empty lines, let us clean it up a bit:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "import re\n\nhtml = re.sub(\"[\\r\\n]+\", \"\\n\", html)\nhtml = re.sub(\"[\\n]+\", \"\\n\", html)\nhtml = re.sub(\"[\\t, ]+\",\" \", html)\n",
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 6
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "html",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "pyout",
       "prompt_number": 7,
       "text": "'<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML+RDFa 1.0//EN\" \"http://www.w3.org/MarkUp/DTD/xhtml-rdfa-1.dtd\">\\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xmlns:og=\"http://opengraphprotocol.org/schema/\" xmlns:rnews=\"http://iptc.org/std/rNews/2011-10-07#\" xml:lang=\"en\" >\\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n<!-- THIS FILE CONFIGURES SHARED HIGHWEB STATIC ASSETS -->\\n<!-- mapping_news.inc -->\\n<!-- THIS FILE CONFIGURES NEWS STATIC ASSETS -->\\n<!-- THIS FILE CONFIGURES VOTE 2012 STATIC ASSETS -->\\n <!-- hi/shared/head_initial.inc -->\\n <!-- IGOR News -->\\n \\n \\n \\n \\n<!-- set CPS_HTTP_HOST_DOMAIN for news and ww1 -->\\n \\n \\n \\n <head profile=\"http://dublincore.org/documents/dcq-html/\" resource=\"http://www.bbc.co.uk/news/technology-26415021\" typeof=\"rnews:NewsItem\">\\n <meta http-equiv=\"X-UA-Compatible\" content=\"IE=8\" />\\n <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\\n <title>BBC News - An hour to catch the coding bug</title>\\n <meta name=\"Description\" content=\"Is it possible to get children interested in computer programming in just 60 minutes? The Hour of Code has been designed to do just that.\"/>\\n <meta property=\"rnews:description\" content=\"Is it possible to get children interested in computer programming in just 60 minutes? The Hour of Code has been designed to do just that.\"/>\\n <meta name=\"OriginalPublicationDate\" content=\"2014/03/03 10:22:55\"/>\\n <meta property=\"rnews:datePublished\" content=\"2014/03/03 10:22:55\"/>\\n <meta name=\"UKFS_URL\" content=\"/news/technology-26415021\"/>\\n <meta name=\"THUMBNAIL_URL\" content=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325446_hourofcode.jpg\"/>\\n <meta property=\"rnews:thumbnailUrl\" content=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325446_hourofcode.jpg\"/>\\n <meta name=\"Headline\" content=\"How to get your children coding\"/>\\n <meta property=\"rnews:headline\" content=\"How to get your children coding\"/>\\n <meta name=\"IFS_URL\" content=\"/news/technology-26415021\"/>\\n <meta name=\"Section\" content=\"Technology\"/>\\n <meta name=\"contentFlavor\" content=\"STORY\"/>\\n <meta name=\"CPS_ID\" content=\"26415021\" />\\n <meta name=\"CPS_SITE_NAME\" content=\"BBC News\" />\\n <meta name=\"CPS_SECTION_PATH\" content=\"Technology\" />\\n <meta name=\"CPS_ASSET_TYPE\" content=\"STY\" />\\n <meta name=\"CPS_PLATFORM\" content=\"HighWeb\" />\\n <meta name=\"CPS_AUDIENCE\" content=\"International\" />\\n <meta property=\"rnews:creator\" content=\"http://www.bbc.co.uk#org\"/>\\n <meta property=\"og:title\" content=\"How to get your children coding\"/>\\n <meta property=\"og:type\" content=\"article\"/>\\n <meta property=\"og:url\" content=\"http://www.bbc.com/news/technology-26415021\"/>\\n <meta property=\"og:site_name\" content=\"BBC News\"/>\\n <meta property=\"og:image\" content=\"http://newsimg.bbc.co.uk/media/images/67373000/jpg/_67373987_09f1654a-e583-4b5f-bfc4-f05850c6d3ce.jpg\"/>\\n \\n <meta name=\"bbcsearch_noindex\" content=\"atom\"/>\\n \\n \\n <link rel=\"canonical\" href=\"http://www.bbc.com/news/technology-26415021\" />\\n<link rel=\"alternate\" hreflang=\"en\" href=\"http://www.bbc.com/news/technology-26415021\" />\\n<link rel=\"alternate\" hreflang=\"en-gb\" href=\"http://www.bbc.co.uk/news/technology-26415021\" />\\n \\n \\n \\n <!-- hi/news/head_first.inc -->\\n<!-- Chartbeat Web Analytics code - start -->\\n<script type=\"text/javascript\">var _sf_startpt=(new Date()).getTime()</script>\\n<!-- Chartbeat Web Analytics code - end -->\\n<meta name=\"application-name\" content=\"BBC News\" />\\n<meta name=\"msapplication-TileImage\" content=\"/img/1_0_3/cream/hi/news/bbc-news-pin.png\" />\\n<meta name=\"msapplication-TileColor\" content=\"#CC0101\" />\\n<meta name=\"twitter:card\" value=\"summary\" />\\n <!-- Project IGOR - Barlesque redirection logic - START -->\\n <script>\\n /*<![CDATA[*/\\n window.bbcredirection = {\\n \\n device: true \\n geo: true\\n \\n }\\n /*]]>*/\\n </script>\\n<!-- Project IGOR - Barlesque redirection logic - END -->\\n<!-- PULSE_ENABLED:yes -->\\n<!-- vars inc blq_cachebust_journalism 1.21.19 -->\\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n \\n <meta http-equiv=\"X-UA-Compatible\" content=\"IE=8\" /> \\n <link rel=\"schema.dcterms\" href=\"http://purl.org/dc/terms/\" /> <link rel=\"index\" href=\"http://www.bbc.co.uk/a-z/\" title=\"A to Z\" /> <link rel=\"copyright\" href=\"http://www.bbc.co.uk/terms/\" title=\"Terms of Use\" /> <link rel=\"icon\" href=\"http://www.bbc.co.uk/favicon.ico\" type=\"image/x-icon\" /> <meta name=\"viewport\" content=\"width = 996\" /> \\n<script type=\"text/javascript\">window.orb = window.orb || {};</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n(function(){window.fig=window.fig||{};window.fig.manager={include:function(a){a=a||window;var e=a.document g=e.cookie b=g.match(/(?:^|; ?)ckns_orb_fig=([^;]+)/);if(!b&&g.indexOf(\"ckns_orb_nofig=1\")>-1){this.setFig(a {no:1})}else{if(b){b=this.deserialise(decodeURIComponent(RegExp.$1));this.setFig(a b)}e.write(\\'<script src=\"https://ssl.bbc.co.uk/frameworks/fig/1/fig.js\"><\\'+\"/script>\")}} confirm:function(a){a=a||window;if(a.orb&&a.orb.fig&&a.orb.fig(\"no\")){this.setNoFigCookie(a)}if(a.orb===undefined||a.orb.fig===undefined){this.setFig(a {no:1});this.setNoFigCookie(a)}} setNoFigCookie:function(a){a.document.cookie=\"ckns_orb_nofig=1; expires=\"+new Date(new Date().getTime()+1000*60*10).toGMTString()+\";\"} setFig:function(a b){(function(){var c=b;a.orb=a.orb||{};a.orb.fig=function(d){return(arguments.length)?c[d]:c}})()} deserialise:function(b){var a={};b.replace(/([a-z]{2}):([0-9]+)/g function(){a[RegExp.$1]=+RegExp.$2});return a}}})();fig.manager.include();/*]]>*/</script>\\n<script type=\"text/javascript\"> fig.manager.confirm(); </script>\\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/style/main.css\" /> <script type=\"text/javascript\">/*<![CDATA[*/ (function(undefined){if(!window.bbc){window.bbc={}}var ROLLING_PERIOD_DAYS=30;window.bbc.Mandolin=function(id segments opts){var now=new Date().getTime() storedItem DEFAULT_START=now DEFAULT_RATE=1 COOKIE_NAME=\"ckpf_mandolin\";opts=opts||{};this._id=id;this._segmentSet=segments;this._store=new window.window.bbc.Mandolin.Storage(COOKIE_NAME);this._opts=opts;this._rate=(opts.rate!==undefined)?+opts.rate:DEFAULT_RATE;this._startTs=(opts.start!==undefined)?new Date(opts.start).getTime():new Date(DEFAULT_START).getTime();this._endTs=(opts.end!==undefined)?new Date(opts.end).getTime():daysFromNow(ROLLING_PERIOD_DAYS);this._signupEndTs=(opts.signupEnd!==undefined)?new Date(opts.signupEnd).getTime():this._endTs;this._segment=null;if(typeof id!==\"string\"){throw new Error(\"Invalid Argument: id must be defined and be a string\")}if(Object.prototype.toString.call(segments)!==\"[object Array]\"){throw new Error(\"Invalid Argument: Segments are required.\")}if(opts.rate!==undefined&&(opts.rate<0||opts.rate>1)){throw new Error(\"Invalid Argument: Rate must be between 0 and 1.\")}if(this._startTs>this._endTs){throw new Error(\"Invalid Argument: end date must occur after start date.\")}if(!(this._startTs<this._signupEndTs&&this._signupEndTs<=this._endTs)){throw new Error(\"Invalid Argument: SignupEnd must be between start and end date\")}removeExpired.call(this now);var overrides=window.bbccookies.get().match(/ckns_mandolin_setSegments=([^;]+)/);if(overrides!==null){eval(\"overrides = \"+decodeURIComponent(RegExp.$1)+\";\");if(overrides[this._id]&&this._segmentSet.indexOf(overrides[this._id])==-1){throw new Error(\"Invalid Override: overridden segment should exist in segments array\")}}if(overrides!==null&&overrides[this._id]){this._segment=overrides[this._id]}else{if((storedItem=this._store.getItem(this._id))){this._segment=storedItem.segment}else{if(this._startTs<=now&&now<this._signupEndTs&&now<=this._endTs&&this._store.isEnabled()===true){this._segment=pick(segments this._rate);if(opts.end===undefined){this._store.setItem(this._id {segment:this._segment})}else{this._store.setItem(this._id {segment:this._segment end:this._endTs})}log.call(this \"mandolin_segment\")}}}log.call(this \"mandolin_view\")};window.bbc.Mandolin.prototype.getSegment=function(){return this._segment};function log(actionType params){var that=this;require([\"istats-1\"] function(istats){istats.log(actionType that._id+\":\"+that._segment params?params:{})})}function removeExpired(expires){var items=this._store.getItems() expiresInt=+expires;for(var key in items){if(items[key].end!==undefined&&+items[key].end<expiresInt){this._store.removeItem(key)}}}function getLastExpirationDate(data){var winner=0 rollingExpire=daysFromNow(ROLLING_PERIOD_DAYS);for(var key in data){if(data[key].end===undefined&&rollingExpire>winner){winner=rollingExpire}else{if(+data[key].end>winner){winner=+data[key].end}}}return(winner)?new Date(winner):new Date(rollingExpire)}window.bbc.Mandolin.prototype.log=function(params){log.call(this \"mandolin_log\" params)};window.bbc.Mandolin.prototype.convert=function(params){log.call(this \"mandolin_convert\" params);this.convert=function(){}};function daysFromNow(n){var endDate;endDate=new Date().getTime()+(n*60*60*24)*1000;return endDate}function pick(segments rate){var picked min=0 max=segments.length-1;if(typeof rate===\"number\"&&Math.random()>rate){return null}do{picked=Math.floor(Math.random()*(max-min+1))+min}while(picked>max);return segments[picked]}window.bbc.Mandolin.Storage=function(name){validateCookieName(name);this._cookieName=name;this._isEnabled=(bbccookies.isAllowed(this._cookieName)===true&&bbccookies.cookiesEnabled()===true)};window.bbc.Mandolin.Storage.prototype.setItem=function(key value){var storeData=this.getItems();storeData[key]=value;this.save(storeData);return value};window.bbc.Mandolin.Storage.prototype.isEnabled=function(){return this._isEnabled};window.bbc.Mandolin.Storage.prototype.getItem=function(key){var storeData=this.getItems();return storeData[key]};window.bbc.Mandolin.Storage.prototype.removeItem=function(key){var storeData=this.getItems();delete storeData[key];this.save(storeData)};window.bbc.Mandolin.Storage.prototype.getItems=function(){return deserialise(this.readCookie(this._cookieName)||\"\")};window.bbc.Mandolin.Storage.prototype.save=function(data){window.bbccookies.set(this._cookieName+\"=\"+encodeURIComponent(serialise(data))+\"; expires=\"+getLastExpirationDate(data).toUTCString()+\";\")};window.bbc.Mandolin.Storage.prototype.readCookie=function(name){var nameEq=name+\"=\" ca=window.bbccookies.get().split(\"; \") i c;validateCookieName(name);for(i=0;i<ca.length;i++){c=ca[i];if(c.indexOf(nameEq)===0){return decodeURIComponent(c.substring(nameEq.length c.length))}}return null};function serialise(o){var str=\"\";for(var p in o){if(o.hasOwnProperty(p)){str+=\\'\"\\'+p+\\'\"\\'+\":\"+(typeof o[p]===\"object\"?(o[p]===null?\"null\":\"{\"+serialise(o[p])+\"}\"):\\'\"\\'+o[p].toString()+\\'\"\\')+\" \"}}return str.replace(/ \\\\}/g \"}\").replace(/ $/g \"\")}function deserialise(str){var o;str=\"{\"+str+\"}\";if(!validateSerialisation(str)){throw\"Invalid input provided for deserialisation.\"}eval(\"o = \"+str);return o}var validateSerialisation=(function(){var OBJECT_TOKEN=\"<Object>\" ESCAPED_CHAR=\\'\"\\\\\\\\n\\\\\\\\r\\\\\\\\u2028\\\\\\\\u2029\\\\\\\\u000A\\\\\\\\u000D\\\\\\\\u005C\\' ALLOWED_CHAR=\"([^\"+ESCAPED_CHAR+\"]|\\\\\\\\\\\\\\\\[\"+ESCAPED_CHAR+\"])\" KEY=\\'\"\\'+ALLOWED_CHAR+\\'+\"\\' VALUE=\\'(null|\"\\'+ALLOWED_CHAR+\\'*\"|\\'+OBJECT_TOKEN+\")\" KEY_VALUE=KEY+\":\"+VALUE KEY_VALUE_SEQUENCE=\"(\"+KEY_VALUE+\" )*\"+KEY_VALUE OBJECT_LITERAL=\"({}|{\"+KEY_VALUE_SEQUENCE+\"})\" objectPattern=new RegExp(OBJECT_LITERAL \"g\");return function(str){if(str.indexOf(OBJECT_TOKEN)!==-1){return false}while(str.match(objectPattern)){str=str.replace(objectPattern OBJECT_TOKEN)}return str===OBJECT_TOKEN}})();function validateCookieName(name){if(name.match(/ ;/)){throw\"Illegal name provided must be valid in browser cookie.\"}}})(); /*]]>*/</script> <script type=\"text/javascript\">/*<![CDATA[*/ if (typeof bbccookies_flag === \\'undefined\\') { bbccookies_flag = \\'ON\\'; } showCTA_flag = false; cta_enabled = (showCTA_flag && (bbccookies_flag === \\'ON\\') ); (function(){var e=\"ckns_policy\" m=\"Thu 01 Jan 1970 00:00:00 GMT\" k={ads:true personalisation:true performance:true necessary:true};function f(p){if(f.cache[p]){return f.cache[p]}var o=p.split(\"/\") q=[\"\"];do{q.unshift((o.join(\"/\")||\"/\"));o.pop()}while(q[0]!==\"/\");f.cache[p]=q;return q}f.cache={};function a(p){if(a.cache[p]){return a.cache[p]}var q=p.split(\".\") o=[];while(q.length&&\"|co.uk|com|\".indexOf(\"|\"+q.join(\".\")+\"|\")===-1){if(q.length){o.push(q.join(\".\"))}q.shift()}f.cache[p]=o;return o}a.cache={};function i(o t p){var z=[\"\"].concat(a(window.location.hostname)) w=f(window.location.pathname) y=\"\" r x;for(var s=0 v=z.length;s<v;s++){r=z[s];for(var q=0 u=w.length;q<u;q++){x=w[q];y=o+\"=\"+t+\";\"+(r?\"domain=\"+r+\";\":\"\")+(x?\"path=\"+x+\";\":\"\")+(p?\"expires=\"+p+\";\":\"\");bbccookies.set(y true)}}}window.bbccookies={_setEverywhere:i cookiesEnabled:function(){var o=\"ckns_testcookie\"+Math.floor(Math.random()*100000);this.set(o+\"=1\");if(this.get().indexOf(o)>-1){g(o);return true}return false} set:function(o){return document.cookie=o} get:function(){return document.cookie} _setPolicy:function(o){return h.apply(this arguments)} readPolicy:function(o){return b.apply(this arguments)} _deletePolicy:function(){i(e \"\" m)} isAllowed:function(){return true} _isConfirmed:function(){return c()!==null} _acceptsAll:function(){var o=b();return o&&!(j(o).indexOf(\"0\")>-1)} _getCookieName:function(){return d.apply(this arguments)} _showPrompt:function(){var o=(!this._isConfirmed()&&window.cta_enabled&&this.cookiesEnabled()&&!window.bbccookies_disable);return(window.orb&&window.orb.fig)?o&&(window.orb.fig(\"no\")||window.orb.fig(\"ck\")):o}};bbccookies._getPolicy=bbccookies.readPolicy;function d(p){var o=(\"\"+p).match(/^([^=]+)(?==)/);return(o&&o.length?o[0]:\"\")}function j(o){return\"\"+(o.ads?1:0)+(o.personalisation?1:0)+(o.performance?1:0)}function h(r){if(typeof r===\"undefined\"){r=k}if(typeof arguments[0]===\"string\"){var o=arguments[0] q=arguments[1];if(o===\"necessary\"){q=true}r=b();r[o]=q}else{if(typeof arguments[0]===\"object\"){r.necessary=true}}var p=new Date();p.setYear(p.getFullYear()+1);p=p.toUTCString();bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.co.uk;path=/;expires=\"+p+\";\");bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.com;path=/;expires=\"+p+\";\");return r}function l(o){if(o===null){return null}var p=o.split(\"\");return{ads:!!+p[0] personalisation:!!+p[1] performance:!!+p[2] necessary:true}}function c(){var o=new RegExp(\"(?:^|; ?)\"+e+\"=(\\\\\\\\d\\\\\\\\d\\\\\\\\d)($|;)\") p=document.cookie.match(o);if(!p){return null}return p[1]}function b(o){var p=l(c());if(!p){p=k}if(o){return p[o]}else{return p}}function g(o){return document.cookie=o+\"=;expires=\"+m+\";\"}function n(){var o=\\'<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/bbccookies/0.6.6/script/bbccookies.js\"><\\\\/script>\\';if(window.bbccookies_flag===\"ON\"&&!bbccookies._acceptsAll()&&!window.bbccookies_disable){document.write(o)}}n()})(); /*]]>*/</script> <script type=\"text/javascript\"> if (! window.gloader) { window.gloader = [ \"glow\" {map: \"http://node1.bbcimg.co.uk/glow/glow/map.1.7.7.js\"}]; } </script> <script type=\"text/javascript\" src=\"http://node1.bbcimg.co.uk/glow/gloader.0.1.6.js\"></script> <script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/requirejs/0.16.0/sharedmodules/require.js\"></script> <script type=\"text/javascript\"> bbcRequireMap = {\"jquery-1\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.7.2\" \"jquery-1.4\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.4\" \"jquery-1.9\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.9.1\" \"swfobject-2\":\"http://static.bbci.co.uk/frameworks/swfobject/0.1.10/sharedmodules/swfobject-2\" \"demi-1\":\"http://static.bbci.co.uk/frameworks/demi/0.10.0/sharedmodules/demi-1\" \"gelui-1\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1\" \"cssp!gelui-1/overlay\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1/overlay.css\" \"istats-1\":\"http://static.bbci.co.uk/frameworks/istats/0.23.1/modules/istats-1\" \"relay-1\":\"http://static.bbci.co.uk/frameworks/relay/0.2.6/sharedmodules/relay-1\" \"clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1\" \"canvas-clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/canvas-clock-1\" \"cssp!clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1.css\" \"jssignals-1\":\"http://static.bbci.co.uk/frameworks/jssignals/0.3.6/modules/jssignals-1\" \"jcarousel-1\":\"http://static.bbci.co.uk/frameworks/jcarousel/0.1.10/modules/jcarousel-1\" \"bump-3\":\"//emp.bbci.co.uk/emp/bump-3/bump-3\"}; require({ baseUrl: \\'http://static.bbci.co.uk/\\' paths: bbcRequireMap waitSeconds: 30 }); </script> <script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/script/barlesque.js\"></script>\\n \\n<!--[if IE 6]>\\n <script type=\"text/javascript\">\\n try {\\n document.execCommand(\"BackgroundImageCache\" false true);\\n } catch(e) {}\\n </script>\\n <style type=\"text/css\">\\n /* Use filters for IE6 */\\n #blq-blocks a {\\n background-image: none;\\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\\'http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-blocks_white_alpha.png\\' sizingMethod=\\'image\\');\\n }\\n .blq-masthead-focus #blq-blocks a \\n .blq-mast-text-dark #blq-blocks a {\\n background-image: none;\\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\\'http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-blocks_grey_alpha.png\\' sizingMethod=\\'image\\');\\n }\\n #blq-nav-search button span {\\n background-image: none;\\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src=\\'http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-search_grey_alpha.png\\' sizingMethod=\\'image\\');\\n }\\n #blq-nav-search button img {\\n position: absolute;\\n left: -999em; \\n }\\n </style>\\n<![endif]-->\\n<!--[if (IE 7])|(IE 8)>\\n <style type=\"text/css\">\\n .blq-clearfix {\\n display: inline-block;\\n }\\n </style>\\n<![endif]-->\\n<script type=\"text/javascript\">\\n blq.setEnvironment(\\'live\\'); if (blq.setLabel) blq.setLabel(\\'searchSuggestion\\' \"Search\"); if (! /bbc\\\\.co\\\\.uk$/i.test(window.location.hostname) ) { document.documentElement.className += \\' blq-not-bbc-co-uk\\'; } </script>\\n <script type=\"text/javascript\"> /*<![CDATA[*/ function oqsSurveyManager(w flag) { var defaultThreshold = 0 usePulseThreshold = (flag === \\'OFF\\')? 1 : defaultThreshold activeThreshold; w.oqs = w.oqs || {}; /* we support cookie override for testing */ if ( w.document.cookie.match(/(?:^|; *)ckns_oqs_usePulseThreshold=([\\\\d.]+)/) ) { activeThreshold = RegExp.$1; } /* we support clientside override */ else if (typeof w.oqs_usePulseThreshold !== \\'undefined\\') { activeThreshold = w.oqs_usePulseThreshold; } else { activeThreshold = usePulseThreshold; } w.oqs.usePulse = (w.Math.random() < activeThreshold); if (!w.oqs.usePulse) { w.document.write(\\'<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/script/vendor/edr.js\"><\\'+\\'/script>\\'); } } oqsSurveyManager(window \\'ON\\'); /*]]>*/ </script> \\n <script type=\"text/javascript\">/*<![CDATA[*/ window.istats = (window.istats || {}); (istats.head = function(w d) { w.istats._linkTracked = w.istats._trackingCookie = decodeURIComponent( (d.cookie.match(/\\\\bsa_labels=([^;]+)/)||[]).pop() || \\'\\' ); var host = w.location.host m = host.match(/(bbc(?:\\\\.co\\\\.uk|\\\\.com))$/i); d.cookie = \\'sa_labels=; expires=Thu 01 Jan 1970 00:00:01 GMT; domain=\\' + (m? m[1] : host) + \\'; path=/\\'; })(window document); /*]]>*/</script> <!-- BBCDOTCOM template: desktop journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON -->\\n \\n \\n <!-- shared/head -->\\n<meta http-equiv=\"imagetoolbar\" content=\"no\" />\\n<!--[if !(lt IE 6)]>\\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/type.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/global.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"print\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/print.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen and (max-device-width: 976px)\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/mobile.css\" />\\n \\n<link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/components/components.css\" />\\n<![endif]-->\\n<!--[if !IE]>-->\\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/type.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/global.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"print\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/print.css\" />\\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen and (max-device-width: 976px)\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/mobile.css\" />\\n \\n<link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/components/components.css\" />\\n<!--<![endif]-->\\n<script type=\"text/javascript\">\\n/*<![CDATA[*/\\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.dom.get(\"html\").addClass(\"blq-js\")}});\\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.ready(function(){if (glow.env.gecko){var gv = glow.env.version.split(\".\");for (var i=gv.length;i<4;i++){gv[i]=0;}if((gv[0]==1 && gv[1]==9 && gv[2]==0)||(gv[0]==1 && gv[1]<9)||(gv[0]<1)){glow.dom.get(\"body\").addClass(\"firefox-older-than-3-5\");}}});}});\\nwindow.disableFacebookSDK=true;\\nif (window.location.pathname.indexOf(\\'+\\')>=0){window.disableFacebookSDK=true;}\\n/*]]>*/\\n</script>\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/locationservices/locator/v4_0/locator.js\"></script>\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/core/3_3_1/bbc_fmtj.js\"></script>\\n<script type=\"text/javascript\">\\n<!--\\n bbc.fmtj.page = {\\n serverTime: 1415728570000 \\n editionToServe: \\'international\\' \\n queryString: null \\n section: \\'technology\\' \\n sectionPath: \\'/Technology\\' \\n siteName: \\'BBC News\\' \\n siteToServe: \\'news\\' \\n siteVersion: \\'cream\\' \\n storyId: \\'26415021\\' \\n assetType: \\'story\\' \\n uri: \\'/news/technology-26415021\\' \\n country: \\'il\\' \\n masthead: false \\n adKeyword: null \\n templateVersion: \\'v1_0\\' \\n counterName: \\'news.technology.story.26415021.page\\'\\n }\\n-->\\n</script>\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/common/3_2_1/bbc_fmtj_common.js\"></script>\\n<script type=\"text/javascript\">$useMap({map:\"http://news.bbcimg.co.uk/js/map/map_0_0_35.js\"});</script>\\n<script type=\"text/javascript\">$loadView(\"0.0\" [\"bbc.fmtj.view\"]);</script>\\n<script type=\"text/javascript\">$render(\"livestats-heatmap\");</script>\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/config/apps/4_7_2/bbc_fmtj_config.js\"></script>\\n<!-- add Bump3 to the require map -->\\n<script type=\"text/javascript\">\\n if (typeof bbcRequireMap !== \\'undefined\\' && bbcRequireMap[\"jquery-1.9\"] === undefined && bbcRequireMap[\"jquery-1\"]) {\\n var jquery19Path = bbcRequireMap[\"jquery-1\"].replace(/0.(1|2).(1|4)/ \\'0.3.0\\').replace(/jquery-1.(5|7).(1|2)/ \\'jquery-1.9.1\\');\\n require({\\n paths : {\\n \"jquery-1.9\": jquery19Path\\n }\\n });\\n }\\n if (typeof bbcRequireMap !== \\'undefined\\' && bbcRequireMap[\"swfobject-2\"]) {\\n require({\\n paths : {\\n \"swfobject-2\": bbcRequireMap[\"swfobject-2\"].replace(\\'0.1.3\\' \\'0.1.10\\')\\n }\\n });\\n }\\n</script>\\n<script type=\"text/javascript\">\\n require({\\n paths : {\\n \"bump-3\": \"http://emp.bbci.co.uk/emp/bump-3/bump-3\"\\n }\\n });\\n</script>\\n<!-- load glow and required modules -->\\n<script type=\"text/javascript\">\\n//<![CDATA[\\ngloader.load([\\'glow\\' \\'1\\' \\'glow.dom\\']);\\n//]]>\\n</script>\\n<!-- pull in our emp code -->\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/av/emp/2_1_8/emp.js\"></script>\\n<!-- pull in compatibility.js -->\\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/av/emp/2_1_8/compatibility.js\"></script>\\n<script type=\"text/javascript\">\\n//<![CDATA[\\n \\n \\n// set site specific config\\nbbc.fmtj.av.emp.configs.push(\\'news\\');\\nrequire([\\'jquery-1\\'] function ($) {\\n $(document).ready(function () {\\n bbc.fmtj.av.emp.loadAll();\\n });\\n});\\n//]]>\\n</script>\\n<!-- Check for advertising testing -->\\n<meta name=\"viewport\" content=\"width = 996\" />\\n <!-- shared/head_story -->\\n<!-- THESE STYLESHEETS VARY ACCORDING TO PAGE CONTENT --> \\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/layout/story.css\" />\\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/story.css\" />\\n<!-- js story view -->\\n<script type=\"text/javascript\">$loadView(\"0.0\" [\"bbc.fmtj.view.news.story\"]);</script>\\n<!-- EMP -->\\n<script type=\"text/javascript\" src=\"http://news.bbc.co.uk/js/app/av/emp/compatibility.js\"></script>\\n<!-- /EMP -->\\n \\n <!-- #CREAM hi news international include head.inc -->\\n <!-- is suitable for ads adding isadvertise ... -->\\n \\n \\n \\n <!-- features_enabled.inc -->\\n \\n \\n<script type=\"text/javascript\">/*<![CDATA[*/if(bbcdotcom===undefined){var bbcdotcom={init:function(a){} objects:function(a){return false} domLoaded:false data:{ads:0 stats:0 statsProvider:null} adverts:{slot:function(b a){} layout:{reset:function(){}}} config:{isActive:function(a){return false}} addLoadEvent:function(a){var b=window.onload;if(typeof window.onload!=\"function\"){window.onload=a}else{window.onload=function(){if(b){b()}a()}}}}}bbcdotcom.objects=function(e f g){var d a c=arguments b=e.split(\".\");if(f===undefined){f=\"valid\"}if(g===undefined){g=window}for(d=0 a=b.length;d<a;d++){if(g[b[d]]===undefined){if(f===\"create\"){g[b[d]]={}}else{return false}}else{if(typeof g[b[d]]===\"function\"){if(typeof c[1]!==\"undefined\"&&c[1]!==null&&g[b[d]](c[1])!==undefined){return g[b[d]](c[1])}else{if(g[b[d]]()!==undefined){return g[b[d]]()}}}}g=g[b[d]]}return g};bbcdotcom.objects(\"bbcdotcom.config\" \"create\");bbcdotcom.config=(function(e c){var b=e a=c d=\"\" f=\"\" g=\"\";return{setAdsEnabled:function(h){b=(b!==0)?h:0} isAdsEnabled:function(){return b} setAnalyticsEnabled:function(h){a=(a!==0)?h:0} isAnalyticsEnabled:function(){return a} setJsPrefix:function(h){d=h} getJsPrefix:function(){return d} setSwfPrefix:function(h){f=h} getSwfPrefix:function(){return f} setCssPrefix:function(h){g=h} getCssPrefix:function(){return g}}}(1 1));bbcdotcom.objects(\"bbcdotcom.stats\" \"create\");if(BBC===undefined){var BBC={}}if(BBC.adverts===undefined){BBC.adverts={setZone:function(){} configure:function(){} write:function(){} show:function(){} isActive:function(){return false} setScriptRoot:function(){} setImgRoot:function(){} getAdvertTag:function(){} getSectionPath:function(){}}};/*]]>*/</script>\\n<meta name=\"application-name\" content=\"BBC\"/>\\n<meta name=\"msapplication-tooltip\" content=\"Explore the BBC for latest news sport and weather TV &amp; radio schedules and highlights with nature food comedy children\\'s programmes and much more\"/>\\n <meta name=\"msapplication-starturl\" content=\"http://www.bbc.com/news/?ocid=global-news-pinned-ie9\"/>\\n<meta name=\"msapplication-window\" content=\"width=1024;height=768\"/>\\n<meta name=\"msapplication-task\" content=\"name=BBC Home;action-uri=http://www.bbc.com/?ocid=global-homepage-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<meta name=\"msapplication-task\" content=\"name=BBC News;action-uri=http://www.bbc.com/news/?ocid=global-news-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<meta name=\"msapplication-task\" content=\"name=BBC Sport;action-uri=http://www.bbc.com/sport/0/?ocid=global-sport-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<meta name=\"msapplication-task\" content=\"name=BBC Future;action-uri=http://www.bbc.com/future?ocid=global-future-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<meta name=\"msapplication-task\" content=\"name=BBC Travel;action-uri=http://www.bbc.com/travel?ocid=global-travel-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<meta name=\"msapplication-task\" content=\"name=BBC Weather;action-uri=http://www.bbc.co.uk/weather/?ocid=global-weather-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\\n<!-- BBCCOM client-side -->\\n<style type=\"text/css\">.bbccom_display_none{display:none;}</style>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n if (typeof orb !== \\'undefined\\' && typeof orb.fig === \\'function\\') {\\n bbcdotcom.data = {\\n a: orb.fig(\\'ad\\')? 1 : 0 \\n b: (0 == orb.fig(\\'uk\\')) ? 1 : 0 \\n c: orb.fig(\\'ap\\')\\n };\\n } else {\\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://tps.bbc.com/wwscripts/data\"%3E%3C/script%3E\\'));\\n }\\n/*]]>*/</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n if (typeof bbcdotcom.data == \\'undefined\\' || typeof bbcdotcom.data.a == \\'undefined\\' || typeof bbcdotcom.data.b == \\'undefined\\' || typeof bbcdotcom.data.c == \\'undefined\\') {\\n bbcdotcom.data = {a:0 b:0 c:0};\\n }\\n if (bbcdotcom.data.a == 1) {\\n document.write(unescape(\\'%3Clink href=\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288/3pt_ads.css\" rel=\"stylesheet\" type=\"text/css\" /%3E\\'));\\n \\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://www.bbc.co.uk/wwscripts/flag\"%3E%3C/script%3E\\'));\\n \\n }\\n/*]]>*/</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n if (typeof bbcdotcom.flag == \\'undefined\\' || bbcdotcom.flag.a != 1) {\\n bbcdotcom.data.a = 0;\\n }\\n/*]]>*/</script>\\n<!-- BEGIN Krux Control Tag for \"BBC.com News\" -->\\n<!-- Source: /snippet/controltag?confid=JZTWpGsM&site=BBC.com%20News&edit=1 -->\\n<script class=\"kxct\" data-id=\"JZTWpGsM\" data-timing=\"async\" data-version=\"1.9\" type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\\n window.Krux||((Krux=function(){Krux.q.push(arguments)}).q=[]);\\n (function(){\\n var k=document.createElement(\\'script\\');k.type=\\'text/javascript\\';k.async=true;\\n var m src=(m=location.href.match(/\\\\bkxsrc=([^&]+)/))&&decodeURIComponent(m[1]);\\n k.src = /^https?:\\\\/\\\\/([a-z0-9_\\\\-\\\\.]+\\\\.)?krxd\\\\.net(:\\\\d{1 5})?\\\\//i.test(src) ? src : src === \"disable\" ? \"\" :\\n (location.protocol===\"https:\"?\"https:\":\"http:\")+\"//cdn.krxd.net/controltag?confid=JZTWpGsM\"\\n ;\\n var s=document.getElementsByTagName(\\'script\\')[0];s.parentNode.insertBefore(k s);\\n }());\\n }\\n /*]]>*/\\n</script>\\n<!-- END Krux Controltag -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\\n window.Krux||((Krux=function(){Krux.q.push(arguments);}).q=[]);\\n (function(){\\n function retrieve(n){\\n var m k=\\'kx\\'+n;\\n if (window.localStorage) {\\n return window.localStorage[k] || \"\";\\n } else if (navigator.cookieEnabled) {\\n m = document.cookie.match(k+\\'=([^;]*)\\');\\n return (m && unescape(m[1])) || \"\";\\n } else {\\n return \\'\\';\\n }\\n }\\n Krux.user = retrieve(\\'user\\');\\n Krux.segments = retrieve(\\'segs\\') ? retrieve(\\'segs\\').split(\\' \\') : [];\\n // DFP Premium\\n var dfpp = [];\\n if (Krux.user) {\\n dfpp.push(\\'khost=\\' + encodeURIComponent(location.hostname));\\n dfpp.push(\\'kuid=\\' + Krux.user);\\n }\\n for (var i = 0; i < Krux.segments.length; i++ ) {\\n dfpp.push(\\'ksg=\\' + Krux.segments[i]);\\n }\\n Krux.dfppKeyValues = dfpp.length ? dfpp.join(\\';\\') + \\';\\' : \\'\\';\\n })();\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/bbccom.js\"%3E%3C/script%3E\\'));\\n }\\n/*]]>*/</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/\\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\\n BBC.adverts.setData(bbcdotcom.data);\\n bbcdotcom.config.setAdsEnabled(bbcdotcom.data.a);\\n bbcdotcom.config.setAnalyticsEnabled(bbcdotcom.data.b);\\n if(typeof bbcdotcom !== \\'undefined\\' && typeof bbcdotcom.survey !== \\'undefined\\' && typeof bbcdotcom.survey.init === \\'function\\') {\\n bbcdotcom.survey.init();\\n }\\n }\\n /*\\n * Native remove content for UK visitors\\n */\\n (function() {\\n if (bbcdotcom.data.b == 0) {\\n var adKeyword = bbcdotcom.objects(\\'bbc.fmtj.page.adKeyword\\');\\n if(adKeyword && adKeyword !== null && typeof adKeyword === \\'string\\' && adKeyword.indexOf(\\'native-\\') !== -1) {\\n document.write(\\'<style >\\' +\\n \\'#storypage-container .story-body {display:none;}\\' +\\n \\'#native-uk-disclaimer {border: 2px solid;margin: 8px;padding: 16px;}\\' +\\n \\'</style>\\');\\n require([\\'jquery-1\\'] function($) {\\n $(function(){\\n /* Native advertising disclaimer */\\n $( \".story-body\" ).html(\\'<div id=\"native-uk-disclaimer\">\\' +\\n \\'<h1>BBC Sport (International version)</h1>\\' +\\n \\'We\\\\\\'re sorry but this article is not accessible from the UK as it is part of our \\' +\\n \\'international service and is not funded by the license fee.\\' +\\n \\'</div>\\');\\n $( \".story-body\" ).show();\\n });\\n });\\n }\\n }\\n }());\\n bbcdotcom.objects(\\'page\\' \\'create\\' bbcdotcom);\\n bbcdotcom.page.edition = \\'(none)\\';\\n bbcdotcom.page.url = \\'/news/technology-26415021\\';\\n bbcdotcom.page.zoneFile = \\'3pt_zone_file\\';\\n bbcdotcom.page.http_host = \\'www.bbc.com\\';\\n \\n \\n/*]]>*/</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/if(bbcdotcom.data.a == 1){(function(){switch(bbcdotcom.page.url){case\"/\":case\"/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/1/hi/default.stm\":\"/2/hi/default.stm\";break;case\"/sport\":case\"/sport/\":case\"/sport/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/sport1/hi/default.stm\":\"/sport2/hi/default.stm\";break}BBC.adverts.setScriptRoot(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/\");bbcdotcom.config.setJsPrefix(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\");bbcdotcom.config.setSwfPrefix(\"http://news.bbcimg.co.uk/shared/swf/bbccom/0.3.288\");bbcdotcom.config.setCssPrefix(\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288\");BBC.adverts.setImgRoot(\"http://news.bbcimg.co.uk/shared/img/bbccom/\");BBC.adverts.init({domain:bbcdotcom.page.http_host location:bbcdotcom.page.url zoneVersion:bbcdotcom.page.zoneFile zoneReferrer:document.referrer})}());(function(){if(typeof require!==\"undefined\"){require({paths:{bbcdotcom:\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\"}})}})();if(BBC.adverts.getV6Gvl3()&&\"undefined\"!==typeof bbcdotcom.page.bddUseLatestFromTest){document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://wwwpreview.test.newsonline.tc.nca.bbc.co.uk/js/app/bbccom/\\'+bbcdotcom.latest_version+\\'/advert.js\"\\'))}else{if(BBC.adverts.getV6Gvl3()){document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/advert.js\"%3E%3C/script%3E\\'))}}if(/[?|&]metadata=yes(&|$)/.test(window.location.search)){document.write(\"http://www.test.bbc.com/wwscripts/metadata?bbcdotcom_asset=\"+window.location.hostname+window.location.pathname)};}/*]]>*/</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n document.write(unescape(\\'%3Cscript id=\"gnlAnalyticsEnabled\" class=\"bbccom_display_none\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n document.write(unescape(\\'%3Cscript id=\"continuous-play-enabled\" class=\"bbccom_display_none\"%3E%3C/script%3E\\'));\\n /*]]>*/\\n</script>\\n \\n \\n<script type=\"text/javascript\">\\n if(typeof BBC.adverts != \\'undefined\\' && typeof BBC.adverts.setPageVersion != \\'undefined\\'){\\n BBC.adverts.setPageVersion(\\'(none)\\');\\n }\\n</script>\\n \\n <!-- hi/news/head_last.inc -->\\n<script type=\"text/javascript\">\\nfunction BetaSite() {\\n function setMobileCookie() {\\n var d = new Date ();\\n d.setDate(d.getDate() + 1);\\n d = d.toUTCString();\\n window.bbccookies.set(\\'ckps_d=m;domain=.bbc.co.uk;path=/;expires=\\' + d );\\n window.bbccookies.set(\\'ckps_d=m;domain=.bbc.com;path=/;expires=\\' + d );\\n }\\n function isValidQueryString() {\\n return (window.location.search.indexOf(\\'view=beta\\') !== -1);\\n }\\n function isClientCapable() {\\n return (\\'querySelector\\' in document && \\'localStorage\\' in window && \\'addEventListener\\' in window);\\n }\\n if (isClientCapable() && isValidQueryString()) {\\n setMobileCookie();\\n window.location.host = \\'m.bbc.co.uk\\';\\n }\\n}\\nBetaSite();\\n</script>\\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/1_4_38/cream/hi/news/skin.css\" />\\n \\n <script type=\"text/javascript\">\\n if(bbcdotcom.objects(\\'BBC.adverts.getAdvertTag\\')) {\\n gloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad: function(glow){\\n glow.ready(function(){\\n if(bbcdotcom.objects(\\'BBC.adverts.getAdvertTag\\')) {\\n var adImageUrl = BBC.adverts.getAdvertTag(\\'printableversionsponsorship\\' \\'\\' \\'standardUri\\');\\n if(adImageUrl) {\\n if (glow.env.ie ) {\\n window.onbeforeprint = function(){\\n var printAdvert = glow.dom.get(\"#print-advert\");\\n if (printAdvert.get(\"img\").length == 0)\\n {\\n printAdvert.append(\\'<img src=\"\\'+adImageUrl+\\'\" alt=\"\" />\\');\\n }\\n };\\n }else{\\n glow.dom.get(\"head\").append(\\'<style type=\"text/css\">#print-advert {display:none};</style><style type=\"text/css\" media=\"print\">#print-advert::after{content:url(\\'+adImageUrl+\\');} #print-advert{display:block;overflow:hidden;}</style>\\');\\n }\\n }\\n }\\n });\\n }});\\n }\\n </script>\\n \\n<link rel=\"apple-touch-icon\" href=\"http://news.bbcimg.co.uk/img/1_0_3/cream/hi/news/iphone.png\"/>\\n<script type=\"text/javascript\">\\n bbcRequireMap[\\'module/weather\\'] = \\'/inc/specials/cream/hi/news/personalisation/weather\\';\\n bbcRequireMap[\\'module/local\\'] = \\'/inc/specials/cream/hi/news/personalisation\\';\\n bbcRequireMap[\\'module/localnewsandweather\\'] = \\'/inc/specials/cream/hi/news/personalisation/localnewsandweather\\';\\n bbcRequireMap[\\'translation\\'] = \\'module/translations/en-GB\\';\\n require({ baseUrl: \\'http://static.bbci.co.uk/\\' paths: bbcRequireMap waitSeconds: 30 });\\n</script>\\n<script type=\"text/javascript\">\\nrequire([\\'jquery-1\\'] function(jQuery) {\\n jQuery.ajaxSetup({cache: true})\\n});\\nrequire([\"jquery-1\" \"istats-1\"] function ($ istats) {\\n $(function() {\\n istats.track(\\'external\\' {region: $(\\'.story-body\\') linkLocation : \\'story-body\\'});\\n istats.track(\\'external\\' {region: $(\\'.story-related .related-links\\') linkLocation : \\'related-links\\'});\\n istats.track(\\'external\\' {region: $(\\'.story-related .newstracker-list\\') linkLocation : \\'newstracker\\'});\\n });\\n});\\n</script>\\n \\n \\n \\n \\n \\n \\n<!-- CPS COMMENT STATUS: false -->\\n <!--Rendered by NOLAPPS571-6006 -->\\n <link rel=\"schema.dcterms\" href=\"http://purl.org/dc/terms/\" />\\n <meta name=\"DCTERMS.created\" content=\"2014-03-03T10:22:55+00:00\" />\\n <meta name=\"DCTERMS.modified\" content=\"2014-03-03T10:22:55+00:00\" />\\n </head>\\n <!--[if lte IE 6]><body class=\"news ie\"><![endif]-->\\n <!--[if IE 7]><body class=\"news ie7\"><![endif]-->\\n <!--[if IE 8]><body class=\"news ie8\"><![endif]-->\\n <!--[if !IE]>--><body class=\"news\"><!--<![endif]-->\\n \\n<div class=\"livestats-web-bug\" id=\"livestats-web-bug-tag\"></div>\\n<script type=\"text/JavaScript\">\\n var referrer = document.referrer;\\n var livestatsBug = \"<img alt=\\'\\' id=\\'livestats\\' src=\\'http://stats.bbc.co.uk/o.gif?~RS~s~RS~News~RS~t~RS~HighWeb_Story~RS~i~RS~26415021~RS~p~RS~99113~RS~a~RS~International~RS~u~RS~/news/technology-26415021~RS~r~RS~\"+referrer+\"~RS~q~RS~~RS~z~RS~10~RS~\\'>\";\\n document.getElementById(\\'livestats-web-bug-tag\\').innerHTML = livestatsBug;\\n</script>\\n<noscript>\\n<div class=\"livestats-web-bug\"><img alt=\"\" id=\"livestats\" src=\"http://stats.bbc.co.uk/o.gif?~RS~s~RS~News~RS~t~RS~HighWeb_Story~RS~i~RS~26415021~RS~p~RS~99113~RS~a~RS~International~RS~u~RS~/news/technology-26415021~RS~q~RS~~RS~z~RS~10~RS~\"/></div>\\n</noscript>\\n \\n \\n <!-- BBCDOTCOM body first include -->\\n \\n<script type=\"text/javascript\">BBC.adverts.write(\"wallpaper\" false);</script>\\n<script type=\"text/javascript\">/*<![CDATA[*/BBC.adverts.wallpaperBodyTag=document.getElementsByTagName(\"body\");BBC.adverts.wallpaperATag=document.getElementsByTagName(\"a\");if(\"undefined\"!=typeof BBC.adverts.wallpaperATag&&\"undefined\"!=typeof BBC.adverts.wallpaperATag[0]&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag[0]&&-1!==BBC.adverts.wallpaperATag[0].href.indexOf(\"http://ad.doubleclick.net\")){BBC.adverts.wallpaperBodyTag[0].removeChild(BBC.adverts.wallpaperATag[0])};/*]]>*/</script>\\n \\n \\n <!-- BBCDOTCOM body first -->\\n <!-- Start SiteCatalyst -->\\n <!-- End SiteCatalyst -->\\n <!-- ISTATS -->\\n \\n <script type=\"text/javascript\">/*<![CDATA[*/ bbcFlagpoles_istats = \\'ON\\'; istatsTrackingUrl = \\'//sa.bbc.co.uk/bbc/bbc/s?name=news.technology.story.26415021.page&cps_asset_id=26415021&page_type=story&section=technology&app_version=6.2.176-RC2&first_pub=2014-03-03T10:22:55+00:00&last_editorial_update=2014-03-03T10:22:55+00:00&title=How+to+get+your+children+coding&comments_box=false&cps_media_type=&cps_media_state=&by_nation=&app_type=web&ml_name=SSI&ml_version=0.23.1&language=en-GB\\'; if (window.istats_countername) { istatsTrackingUrl = istatsTrackingUrl.replace(/([?&]name=)[^&]+/ig \\'$1\\' + istats_countername); } (function() { if ( /\\\\bIDENTITY=/.test(document.cookie) ) { istatsTrackingUrl += \\'&bbc_identity=1\\'; } var c = (document.cookie.match(/\\\\bckns_policy=(\\\\d\\\\d\\\\d)/)||[]).pop() || \\'\\'; istatsTrackingUrl += \\'&bbc_mc=\\' + (c? \\'ad\\'+c.charAt(0)+\\'ps\\'+c.charAt(1)+\\'pf\\'+c.charAt(2) : \\'not_set\\'); if ( /\\\\bckns_policy=\\\\d\\\\d0/.test(document.cookie) ) { istatsTrackingUrl += \\'&ns_nc=1\\'; } var screenWidthAndHeight = \\'unavailable\\'; if (window.screen && screen.width && screen.height) { screenWidthAndHeight = screen.width + \\'x\\' + screen.height; } istatsTrackingUrl += (\\'&screen_resolution=\\' + screenWidthAndHeight); istatsTrackingUrl += \\'&blq_s=3.5d&blq_r=3.5&blq_v=journalism-worldwide\\'; })(); /*]]>*/</script> <!-- Begin iStats 20100118 (UX-CMC 1.1009.3) --> <script type=\"text/javascript\">/*<![CDATA[*/ (function() { window.istats || (istats = {}); var cookieDisabled = (document.cookie.indexOf(\\'NO-SA=\\') != -1) hasCookieLabels = (document.cookie.indexOf(\\'sa_labels=\\') != -1) hasClickThrough = /^#sa-(.*?)(?:-sa(.*))?$/.test(document.location.hash) runSitestat = !cookieDisabled && !hasCookieLabels && !hasClickThrough && !istats._linkTracked; if (runSitestat && bbcFlagpoles_istats === \\'ON\\') { sitestat(istatsTrackingUrl); } else { window.ns_pixelUrl = istatsTrackingUrl; /* used by Flash library to track */ } function sitestat(n){var j=document f=j.location b=\"\";if(j.cookie.indexOf(\"st_ux=\")!=-1){var k=j.cookie.split(\";\");var e=\"st_ux\" h=document.domain a=\"/\";if(typeof ns_!=\"undefined\"&&typeof ns_.ux!=\"undefined\"){e=ns_.ux.cName||e;h=ns_.ux.cDomain||h;a=ns_.ux.cPath||a}for(var g=0 f=k.length;g<f;g++){var m=k[g].indexOf(\"st_ux=\");if(m!=-1){b=\"&\"+unescape(k[g].substring(m+6))}}document.cookie=e+\"=; expires=\"+new Date(new Date().getTime()-60).toGMTString()+\"; path=\"+a+\"; domain=\"+h}ns_pixelUrl=n;n=ns_pixelUrl+\"&ns__t=\"+(new Date().getTime())+\"&ns_c=\"+((j.characterSet)?j.characterSet:j.defaultCharset)+\"&ns_ti=\"+escape(j.title)+b+\"&ns_jspageurl=\"+escape(f&&f.href?f.href:j.URL)+\"&ns_referrer=\"+escape(j.referrer);if(n.length>2000&&n.lastIndexOf(\"&\")){n=n.substring(0 n.lastIndexOf(\"&\")+1)+\"ns_cut=\"+n.substring(n.lastIndexOf(\"&\")+1 n.lastIndexOf(\"=\")).substring(0 40)}(j.images)?new Image().src=n:j.write(\\'<p><i\\'+\\'mg src=\"\\'+n+\\'\" height=\"1\" width=\"1\" alt=\"\" /></p>\\')}; })(); /*]]>*/</script> <noscript><p style=\"position: absolute; top: -999em;\"><img src=\"//sa.bbc.co.uk/bbc/bbc/s?name=news.technology.story.26415021.page&amp;cps_asset_id=26415021&amp;page_type=story&amp;section=technology&amp;app_version=6.2.176-RC2&amp;first_pub=2014-03-03T10:22:55+00:00&amp;last_editorial_update=2014-03-03T10:22:55+00:00&amp;title=How+to+get+your+children+coding&amp;comments_box=false&amp;cps_media_type=&amp;cps_media_state=&amp;by_nation=&amp;app_type=web&amp;ml_name=SSI&amp;ml_version=0.23.1&amp;language=en-GB&amp;blq_s=3.5d&amp;blq_r=3.5&amp;blq_v=journalism-worldwide\" height=\"1\" width=\"1\" alt=\"\" /></p></noscript> <!-- End iStats (UX-CMC) --> <div id=\"blq-global\"> <noscript> <div id=\"blq-no-js-banner\"> <p>For a better experience on your device try our <a href=\"http://m.bbc.co.uk\">mobile site</a>.</p> </div> </noscript> <div id=\"blq-pre-mast\" xml:lang=\"en-GB\"> <!-- Pre mast --> \\n<!-- BBCDOTCOM leaderboard template:client-side journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON showAdAboveBlq: true blqLeaderboardAd: true -->\\n </div> </div> <script type=\"text/html\" id=\"blq-bbccookies-tmpl\"><![CDATA[ <div id=\"bbccookies-prompt\" class=\"bbccookies-w\"> <h2> Cookies on the BBC website </h2> <p> We use cookies to ensure that we give you the best experience on our website.<span class=\"bbccookies-international-message\"> We also use cookies to ensure we show you advertising that is relevant to you.</span> If you continue without changing your settings we\\'ll assume that you are happy to receive all cookies on the BBC website. However if you would like to you can <a href=\"/privacy/cookies/managing/cookie-settings.html\">change your cookie settings</a> at any time. </p> <ul> <li id=\"bbccookies-continue\"> <button type=\"button\" id=\"bbccookies-continue-button\">Continue</button> </li> <li id=\"bbccookies-more\"><a href=\"/privacy/cookies/bbc\">Find out more</a></li></ul> </div> ]]></script> <script type=\"text/javascript\">/*<![CDATA[*/ (function(){if(bbccookies._showPrompt()){var i=document b=i.getElementById(\"blq-pre-mast\") f=i.getElementById(\"blq-global\") h=i.getElementById(\"blq-container\") c=i.getElementById(\"blq-bbccookies-tmpl\") a g e;if(b&&i.createElement){a=i.createElement(\"div\");a.id=\"bbccookies\";e=c.innerHTML;e=e.replace(\"<\"+\"![CDATA[\" \"\").replace(\"]]\"+\">\" \"\");a.innerHTML=e;if(f){f.insertBefore(a b)}else{h.insertBefore(a b)}g=i.getElementById(\"bbccookies-continue-button\");g.onclick=function(){a.parentNode.removeChild(a);return false};bbccookies._setPolicy()}}})(); /*]]>*/</script> <div id=\"blq-masthead\" class=\"blq-clearfix blq-mast-bg-transparent-light blq-lang-en-GB blq-ltr\"> <span id=\"blq-mast-background\"><span></span></span> <div id=\"blq-mast\" class=\"blq-rst\"> <div id=\"blq-mast-bar\" class=\"blq-masthead-container blq-journalism-worldwide\"> <div id=\"blq-blocks\"> <a href=\"http://www.bbc.co.uk/\" hreflang=\"en-GB\"> <abbr title=\"British Broadcasting Corporation\" class=\"blq-home\"> <img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blq-blocks_grey_alpha.png\" alt=\"BBC\" width=\"84\" height=\"24\" /> </abbr> </a> </div> <div id=\"blq-acc-links\"> <h2 id=\"page-top\">Accessibility links</h2> <ul> <li><a href=\"#main-content\">Skip to content</a></li> <li><a href=\"#blq-local-nav\">Skip to local navigation</a></li> <li><a href=\"http://www.bbc.co.uk/accessibility/\">Accessibility Help</a></li> </ul> </div> <div id=\"blq-sign-in\" class=\"blq-gel\"> </div> <div id=\"blq-nav\"> <h2>BBC navigation</h2> <ul id=\"blq-nav-main\"> <li id=\"blq-nav-news\"> <a href=\"http://www.bbc.com/news/\">News</a> </li> <li id=\"blq-nav-sport\"> <a href=\"http://www.bbc.co.uk/sport/\">Sport</a> </li> <li id=\"blq-nav-weather\"> <a href=\"http://www.bbc.co.uk/weather/\">Weather</a> </li> <li id=\"blq-nav-earth\"> <a href=\"http://www.bbc.com/earth/\">Earth</a> </li> <li id=\"blq-nav-future\"> <a href=\"http://www.bbc.com/future/\">Future</a> </li> <li id=\"blq-nav-shop\"> <a href=\"http://shop.bbc.com/\">Shop</a> </li> <li id=\"blq-nav-tv\"> <a href=\"http://www.bbc.co.uk/tv/\">TV</a> </li> <li id=\"blq-nav-radio\"> <a href=\"http://www.bbc.co.uk/radio/\">Radio</a> </li> <li id=\"blq-nav-more\"> <a href=\"http://www.bbc.co.uk/a-z/\">More&hellip;</a> </li> </ul> <div id=\"blq-nav-search\"> <form method=\"get\" action=\"http://search.bbc.co.uk/search\" accept-charset=\"utf-8\" id=\"blq-search-form\"> <div> <input type=\"hidden\" name=\"go\" value=\"toolbar\" /> <input type=\"hidden\" value=\"http://www.bbc.com/news/technology-26415021\" name=\"uri\" /> <input type=\"hidden\" name=\"scope\" value=\"news\" /> <label for=\"blq-search-q\" class=\"blq-hide\">Search term:</label> <input id=\"blq-search-q\" type=\"text\" name=\"q\" value=\"\" maxlength=\"128\" /> <button id=\"blq-search-btn\" type=\"submit\"><span><img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blq-search_grey_alpha.png\" width=\"13\" height=\"13\" alt=\"Search\"/></span></button> </div> </form> </div> </div> </div> </div> </div> <div id=\"blq-container-outer\" class=\"blq-journalism-worldwide blq-ltr\" > <div id=\"blq-container\" class=\"blq-lang-en-GB blq-dotcom\"> <div id=\"blq-container-inner\" xml:lang=\"en-GB\"> <div id=\"blq-main\" class=\"blq-clearfix\"> \\n \\n \\n <div class=\"technology has-no-ticker \">\\n <div id=\"header-wrapper\">\\n \\n <h2 id=\"header\">\\n <a rel=\"index\" href=\"http://www.bbc.co.uk/news/\"><img alt=\"BBC News\" src=\"http://news.bbcimg.co.uk/img/1_0_3/cream/hi/news/news-blocks.gif\" /></a>\\n <span class=\"section-title\">Technology</span>\\n </h2>\\n \\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-section\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n \\n <div id=\"blq-local-nav\">\\n <ul id=\"nav\" class=\"nav\">\\n \\n \\n <li class=\"first-child \"><a href=\"/news/\">Home</a></li>\\n \\n \\n <li><a href=\"/news/uk/\">UK</a></li>\\n \\n \\n <li><a href=\"/news/world/africa/\">Africa</a></li>\\n \\n \\n <li><a href=\"/news/world/asia/\">Asia</a></li>\\n \\n \\n <li><a href=\"/news/world/australia/\">Australia</a></li>\\n \\n \\n <li><a href=\"/news/world/europe/\">Europe</a></li>\\n \\n \\n <li><a href=\"/news/world/latin_america/\">Latin America</a></li>\\n \\n \\n <li><a href=\"/news/world/middle_east/\">Mid-East</a></li>\\n \\n \\n <li><a href=\"/news/world/us_and_canada/\">US &amp; Canada</a></li>\\n \\n \\n <li><a href=\"/news/business/\">Business</a></li>\\n \\n \\n <li><a href=\"/news/health/\">Health</a></li>\\n \\n \\n <li><a href=\"/news/science_and_environment/\">Sci/Environment</a></li>\\n \\n \\n <li class=\"selected\"><a href=\"/news/technology/\">Tech</a></li>\\n \\n \\n <li><a href=\"/news/entertainment_and_arts/\">Entertainment</a></li>\\n \\n \\n <li><a href=\"/news/10462520\">Video</a></li>\\n </ul> \\n \\n </div>\\n \\n </div>\\n <!-- START CPS_SITE CLASS: international -->\\n <div id=\"content-wrapper\" class=\"international\">\\n <div class=\"advert\">\\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-leaderboard\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n </div>\\n <div id=\"bbccom_custom_branding\">\\n <script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if(typeof bbcdotcom.objects(\\'bbcdotcom.branding.init\\') === \\'function\\') {\\n bbcdotcom.branding.init(BBC.adverts.getZoneData().zone BBC.adverts.getAdKeyword());\\n bbcdotcom.branding.write();\\n }\\n /*]]>*/\\n </script>\\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">\\n /*<![CDATA[*/\\n $render(\"advert\" \"advert-sponsor-subsection\");\\n /*]]>*/\\n </script>\\n</div>\\n</div>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n $render(\"advert-post-script-load\");\\n /*]]>*/\\n</script>\\n \\n <!-- START CPS_SITE CLASS: story -->\\n <div id=\"main-content\" class=\"story blq-clearfix\">\\n <!-- No EWA -->\\n \\n<div id=\"print-advert\">\\n</div>\\n<div class=\"layout-block-a\">\\n <div class=\"story-body\">\\n <span class=\"story-date\">\\n <span class=\"date\">3 March 2014</span>\\n<span class=\"time-text\">Last updated at </span><span class=\"time\">10:22 GMT</span>\\n \\n</span>\\n <div id=\"page-bookmark-links-head\" class=\"share-help\">\\n <h3>Share this page</h3>\\n <ul> \\n <li class=\"delicious\">\\n <a title=\"Post this story to Delicious\" href=\"http://del.icio.us/post?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Delicious</a>\\n </li>\\n <li class=\"digg\">\\n <a title=\"Post this story to Digg\" href=\"http://digg.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Digg</a>\\n </li>\\n <li class=\"facebook\">\\n <a title=\"Post this story to Facebook\" href=\"http://www.facebook.com/sharer.php?u=http://www.bbc.com/news/technology-26415021&amp;t=BBC+News+-+An+hour+to+catch+the+coding+bug\">Facebook</a>\\n </li>\\n <li class=\"reddit\">\\n <a title=\"Post this story to reddit\" href=\"http://reddit.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">reddit</a>\\n </li>\\n <li class=\"stumbleupon\">\\n <a title=\"Post this story to StumbleUpon\" href=\"http://www.stumbleupon.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">StumbleUpon</a>\\n </li>\\n <li class=\"twitter\">\\n <a title=\"Post this story to Twitter\" href=\"http://twitter.com/home?status=BBC+News+-+An+hour+to+catch+the+coding+bug+http://www.bbc.com/news/technology-26415021\">Twitter</a>\\n </li>\\n <li class=\"email\">\\n <a title=\"Email this story\" href=\"http://newsvote.bbc.co.uk/mpapps/pagetools/email/www.bbc.com/news/technology-26415021\">Email</a>\\n </li>\\n <li class=\"print\">\\n <a title=\"Print this story\" href=\"?print=true\">Print</a>\\n </li>\\n </ul>\\n<!-- Social media icons by Paul Annet | http://nicepaul.com/icons -->\\n</div>\\n<script type=\"text/javascript\"> \\n<!--\\n$render(\"page-bookmark-links\" \"page-bookmark-links-head\" {\\n useForgeShareTools:\"true\" \\n position:\"top\" \\n site:\\'News\\' \\n headline:\\'BBC News - An hour to catch the coding bug\\' \\n storyId:\\'26415021\\' \\n sectionId:\\'99113\\' \\n url:\\'http://www.bbc.com/news/technology-26415021\\' \\n edition:\\'International\\'\\n}); \\n-->\\n</script>\\n <h1 class=\"story-header\">An hour to catch the coding bug</h1>\\n \\n \\n \\n \\n \\n <span class=\"byline\">\\n <span class=\"byline-name\">By Mark Ward</span>\\n <span class=\"byline-title\">Technology correspondent BBC News</span>\\n </span>\\n \\n <div class=\"caption full-width\">\\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325163_olly009.jpg\" width=\"512\" height=\"320\" alt=\"Child with computer\" />\\n <span style=\"width:512px;\">We did our Hour of Code on a lazy Sunday morning</span>\\n </div>\\n <div class=\"story-feature related narrow\">\\n <a class=\"hidden\" href=\"#story_continues_1\">Continue reading the main story</a> <h2>Related Stories</h2>\\n <ul class=\"related-links-list\">\\n \\n \\n \\n<li class=\"has-icon-boxedwatch \">\\n <a class=\"story\" rel=\"published-1389169705927\" href=\"/news/education-25648769\">Computer code lessons at primary school<span class=\"gvl3-icon gvl3-icon-boxedwatch\"> Watch</span></a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1392196197052\" href=\"/news/technology-26150717\">Year of Code - PR fiasco or vital mission?</a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1390468159072\" href=\"/news/technology-25857276\">Are teachers ready for the coding revolution?</a>\\n </li>\\n </ul>\\n </div>\\n <p class=\"introduction\" id=\"story_continues_1\">Okay 60 minutes and counting. Here we go.</p>\\n <p>I&#039;ve got an hour to convince my kids that programming is for them.</p>\\n <p>Well sort of.</p>\\n <p>I&#039;m putting my twin 10-year-old boys Toby and Callum through the Hour of Code - a campaign that seeks to ignite an interest in programming - the part we&#039;re doing using specially created web-based exercises. </p>\\n <p>The campaign begun in the US has landed in the UK where it also coincides with government calls for as many children as possible to get coding.</p>\\n <p>Programming is being pushed because in an ever more technological world it can only be a good thing to give people a peep into what goes on behind the touch screen cash point and website. </p>\\n <p>The Hour of Code is supposed to be the start of that journey and I like many other parents feel it&#039;s one my children should be embarking on. I do feel like a clock somewhere is ticking and unless they get started with this essential skill they&#039;ll be left behind. </p>\\n <p>&quot;In the future kids are going to be doing programming &quot; said Callum when I asked him why it was worth learning how to code. &quot;We need to learn so we can do stuff with the computer otherwise it will be a blank page and never work.&quot;</p>\\n <span class=\"cross-head\">Zombie dance</span>\\n <div class=\"caption full-width\">\\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325167_hourofcode.jpg\" width=\"512\" height=\"288\" alt=\"Screenshot from the hour of code\" />\\n <span style=\"width:512px;\">The coding exercises involve familiar characters such as the Angry Birds</span>\\n </div>\\n <p>It&#039;s the getting started for both parents and their offspring that the Hour is intended to help with. I&#039;m probably like most parents in that I have no significant qualification in computer science. All I can offer my boys is a lifetime of tinkering backed up over the past 18 months with online courses in Python HTML CSS Javascript and the like. </p>\\n <p>There&#039;s good precedents for the value of something like the Hour of Code. I&#039;ve quizzed every chief technology officer (CTO) developer or IT worker I&#039;ve met in the past couple of weeks about what got them started and every one knew exactly the moment they got it. Their eyes lit up as they talked about typing in code listings from magazines working through every Dos command or designing their own blocky 8-bit game characters.</p>\\n <p>And finally at the back of my mind are all those statistics about the shortages of skilled IT staff and my hope that if this works then their future career options will be much wider than they would be without this skill.</p>\\n <p>So no pressure then.</p>\\n <p>Yesterday morning we gave it a go. I was keen for it to be fun rather than feel like school as there&#039;s nothing more likely to turn them off than for it to be sold as good for them. I think we struck the right note of informality - Cal did it in his onesie. </p>\\n <p>It went OK no better than that. Pretty good. We worked through all the exercises getting angry birds to mash pigs and zombies to chomp sunflowers. The coding is done by dragging blocks representing different commands into a work area and building the blocks into a tower of coherent instructions.</p>\\n <p>The block-building system is based on the Scratch programming language build by MIT&#039;s Mitch Resnick. </p>\\n <p>The exercises start easy - just getting an angry bird to hop on to a pig. By the end we were using &quot;If\\xe2\\x80\\xa6 else&quot; statements and loops to help a zombie navigate a tricky maze to reach the sunflower.</p>\\n <p>This went down well with Callum. &quot;Cool! It&#039;s scanning for a path &quot; he said as the zombie worked its way towards the hapless flower.</p>\\n <p>Mistakes were made but we learned from them we debated over which way to make the birds and zombies turn and the time went really fast. </p>\\n <p>Toby was surprised to find that this counted as programming.</p>\\n <p>&quot;I thought coding was just a lot of people tapping in letter and numbers until they got it right &quot; he said. </p>\\n <span class=\"cross-head\">Next steps</span>\\n <p>And yet I felt it was a bit too easy. I wanted to make the coding connection to real life more tangible. So as we had about 15 minutes of our Hour of Code left we went further.</p>\\n <p>This time we used the MIT App Inventor to build a basic program that would run on the tablets they own. </p>\\n <p>The app inventor uses the same &quot;drag the block&quot; method to build a program and following the instructions we had soon created an app that turned anything typed in text into speech. </p>\\n <div class=\"caption\">\\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325169_appinventor.jpg\" width=\"448\" height=\"287\" alt=\"Screenshot from MIT App Inventor\" />\\n <span style=\"width:448px;\">The App Inventor uses the same block dragging system as the Hour of Code exercises</span>\\n </div>\\n <p>We got it working on Cal&#039;s tablet and soon they were getting that gadget to call out lots of phrases. Almost inevitably as they are 10 years old a lot of these phrases involved the words &quot;willy&quot; and &quot;bum&quot;. </p>\\n <p>But they had a lot of fun with it and it brought home to them how straight-forward coding can be. In just over an hour they went from being pretty much novices to creating an Android app - a basic one that trades on the expertise of the people that built the coding tools but it was an accomplishment nonetheless.</p>\\n <p>Did they catch the coding bug as a result? </p>\\n <p>Maybe later in the day they were programming each other after one of their regular wrestling matches left Toby lying exhausted on the floor. Suddenly Cal called out commands such as &quot;roll left&quot; and Toby started obeying even to the point of crashing into the sofa when too many roll commands were given. </p>\\n <p>Then Toby had his turn and did the same they even worked out that they had to compensate for the changes in left and right as they rolled. </p>\\n <p>So I think that hour started something. Both with them and with me. Building that Android app made me realise that it is straight-forward. That my lack of formal qualifications do not matter as much as I thought. And maybe that&#039;s the point of the hour. Making people realise that it is not scary and difficult. You just have to find an hour and give it a try. You can even do it in your onesie.</p>\\n \\n </div><!-- / story-body -->\\n \\n <div>\\n <!--Related hypers and stories -->\\n <div class=\"story-related\">\\n <h2>More on This Story</h2>\\n \\n \\n<style>\\n.related-links-list li {\\nposition: relative;\\n}\\n.related-links-list .gvl3-icon {\\nposition: absolute;\\ntop: 0;\\nleft: 0;\\n}\\n</style>\\n<div class=\"see-also\">\\n <h3>Related Stories</h3>\\n <ul class=\"related-links-list\">\\n \\n <li class=\" first\">\\n \\n \\n \\n<div class=\"has-icon-boxedwatch \">\\n <a class=\"story\" rel=\"published-1389169705927\" href=\"/news/education-25648769\">Computer code lessons at primary school<span class=\"gvl3-icon gvl3-icon-boxedwatch\"> Watch</span></a>\\n </div>\\n \\n <span class=\"timestamp\">08 JANUARY 2014</span> \\n <span class=\"section\">EDUCATION & FAMILY</span>\\n </li>\\n <li class=\"\">\\n \\n \\n \\n<div>\\n <a class=\"story\" rel=\"published-1392196197052\" href=\"/news/technology-26150717\">Year of Code - PR fiasco or vital mission?</a>\\n </div>\\n \\n <span class=\"timestamp\">12 FEBRUARY 2014</span> \\n <span class=\"section\">TECHNOLOGY</span>\\n </li>\\n <li class=\"\">\\n \\n \\n \\n<div>\\n <a class=\"story\" rel=\"published-1390468159072\" href=\"/news/technology-25857276\">Are teachers ready for the coding revolution?</a>\\n </div>\\n \\n <span class=\"timestamp\">23 JANUARY 2014</span> \\n <span class=\"section\">TECHNOLOGY</span>\\n </li>\\n </ul>\\n</div>\\n<script type=\"text/javascript\">$render(\"page-see-also\" \"ID\");</script> \\n <script type=\"text/javascript\">$render(\"page-newstracker\" \"ID\");</script> \\n \\n<div class=\"related-internet-links\">\\n <h3>Related Internet links</h3>\\n <ul class=\"related-links\">\\n \\n <li class=\"column-1 first-child\">\\n <a href=\"http://uk.code.org/\">UK Hour of Code</a>\\n </li>\\n \\n <li class=\"column-1 \">\\n <a href=\"http://appinventor.mit.edu/explore/\">MIT App Inventor</a>\\n </li>\\n \\n <li class=\"column-2 \">\\n <a href=\"http://scratch.mit.edu/\">MIT Scratch</a>\\n </li>\\n </ul>\\n</div>\\n \\n <p class=\"disclaimer\">The BBC is not responsible for the content of external Internet sites</p>\\n </div>\\n<script type=\"text/javascript\">$render(\"page-related-items\" \"ID\");</script>\\n </div>\\n \\n <div class=\"share-body-bottom\">\\n <div id=\"page-bookmark-links-foot\" class=\"share-help\">\\n <h3>Share this page</h3>\\n <ul> \\n <li class=\"delicious\">\\n <a title=\"Post this story to Delicious\" href=\"http://del.icio.us/post?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Delicious</a>\\n </li>\\n <li class=\"digg\">\\n <a title=\"Post this story to Digg\" href=\"http://digg.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Digg</a>\\n </li>\\n <li class=\"facebook\">\\n <a title=\"Post this story to Facebook\" href=\"http://www.facebook.com/sharer.php?u=http://www.bbc.com/news/technology-26415021&amp;t=BBC+News+-+An+hour+to+catch+the+coding+bug\">Facebook</a>\\n </li>\\n <li class=\"reddit\">\\n <a title=\"Post this story to reddit\" href=\"http://reddit.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">reddit</a>\\n </li>\\n <li class=\"stumbleupon\">\\n <a title=\"Post this story to StumbleUpon\" href=\"http://www.stumbleupon.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">StumbleUpon</a>\\n </li>\\n <li class=\"twitter\">\\n <a title=\"Post this story to Twitter\" href=\"http://twitter.com/home?status=BBC+News+-+An+hour+to+catch+the+coding+bug+http://www.bbc.com/news/technology-26415021\">Twitter</a>\\n </li>\\n <li class=\"email\">\\n <a title=\"Email this story\" href=\"http://newsvote.bbc.co.uk/mpapps/pagetools/email/www.bbc.com/news/technology-26415021\">Email</a>\\n </li>\\n <li class=\"print\">\\n <a title=\"Print this story\" href=\"?print=true\">Print</a>\\n </li>\\n </ul>\\n<!-- Social media icons by Paul Annet | http://nicepaul.com/icons -->\\n<div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"page-bookmark-links\");</script>\\n</div>\\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n</div>\\n<script type=\"text/javascript\"> \\n<!--\\n$render(\"page-bookmark-links\" \"page-bookmark-links-foot\" {\\n useForgeShareTools:\"true\" \\n position:\"bottom\" \\n site:\\'News\\' \\n headline:\\'BBC News - An hour to catch the coding bug\\' \\n storyId:\\'26415021\\' \\n sectionId:\\'99113\\' \\n url:\\'http://www.bbc.com/news/technology-26415021\\' \\n edition:\\'International\\'\\n}); \\n-->\\n</script>\\n </div>\\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-google-adsense\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n <!-- other stories from this section include -->\\n \\n<div class=\"top-index-stories\">\\n <h2 class=\"top-index-stories-header\"><a href=\"/news/technology/\">More Technology stories</a></h2>\\n <a href=\"http://feeds.bbci.co.uk/news/technology/rss.xml\" class=\"rss\">RSS</a> \\n \\n \\n \\n <!-- Non specific version -->\\n \\n <ul>\\n \\n \\n \\n <li class=\"first-child medium-image\">\\n \\n \\n \\n<h3>\\n <a class=\"story\" rel=\"published-1415712538863\" href=\"/news/technology-30004299\"><img src=\"http://news.bbcimg.co.uk/media/images/78909000/jpg/_78909837_78909652.jpg\" alt=\"Moffett Federal Airfield aircraft runway\" />Google to lease former Nasa airfield</a>\\n </h3>\\n \\n <p>Google is to pay over \\xc2\\xa31bn to rent an airfield but little is known about what it plans to do there.</p>\\n </li>\\n \\n \\n \\n \\n <li class=\"column-1\">\\n \\n \\n \\n<h3>\\n <a class=\"story\" rel=\"published-1415718074539\" href=\"/news/technology-30007505\">Rocket bike sets 207mph speed record</a>\\n </h3>\\n \\n </li>\\n \\n \\n \\n \\n <li class=\"column-2\">\\n \\n \\n \\n<h3>\\n <a class=\"story\" rel=\"published-1415726601139\" href=\"/news/technology-30011104\">Spotify defends itself against Swift</a>\\n </h3>\\n \\n </li>\\n \\n </ul>\\n \\n</div>\\n</div><!-- / layout-block-a -->\\n<div class=\"layout-block-b\">\\n \\n <div class=\"hyperpuff\">\\n \\n<div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-high\");</script>\\n</div>\\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n<div id=\"range-top-stories\" class=\"top-stories-range-module\">\\n <h2 class=\"top-stories-range-module-header\">Top Stories</h2>\\n \\n \\n \\n <!-- Non specific version -->\\n \\n <ul>\\n \\n \\n \\n \\n<li class=\" first-child medium-image\">\\n <a class=\"story\" rel=\"published-1415721417853\" href=\"/news/world-europe-30011512\"><img src=\"http://news.bbcimg.co.uk/media/images/78919000/jpg/_78919286_71313393.jpg\" alt=\"Shoppers on London&#039;s Regent street (file pic)\" />EU court backs migrant benefit curbs</a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1415713249187\" href=\"/sport/0/football/30004279\">Morocco will not host Cup of Nations</a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1415668776330\" href=\"/news/business-29999289\">Alibaba Singles&#039; Day sales pass $9bn</a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1415723073354\" href=\"/news/world-asia-india-30010012\">India sterilisation deaths inquiry</a>\\n </li>\\n \\n \\n \\n<li>\\n <a class=\"story\" rel=\"published-1415720233032\" href=\"/news/world-asia-30009649\">Anguish at South Korea ferry verdict</a>\\n </li>\\n </ul>\\n \\n \\n</div>\\n<script type=\"text/javascript\">$render(\"range-top-stories\" \"range-top-stories\");</script>\\n \\n \\n<div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-low\");</script>\\n</div>\\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n <div id=\"features\" class=\"feature-generic\">\\n <h2 class=\"features-header\">Features &amp; Analysis</h2>\\n \\n <ul class=\"feature-main\">\\n \\n \\n \\n <!-- Non specific version -->\\n \\n \\n \\n <li class=\"medium-image\">\\n \\n \\n \\n<h3 class=\" feature-header\">\\n <a class=\"story\" rel=\"published-1415665401219\" href=\"/news/magazine-29950844\"><img src=\"http://news.bbcimg.co.uk/media/images/78897000/jpg/_78897876_redheadsindex.jpg\" alt=\"Two women with red hair\" />River republics</a>\\n </h3>\\n \\n <p>Which part of the world has the people with the reddest hair? \\n <span id=\"dna-comment-count___CPS__29950844\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\\n \\n <hr />\\n </li>\\n \\n \\n <li class=\"medium-image\">\\n \\n \\n \\n<h3 class=\" feature-header\">\\n <a class=\"story\" rel=\"published-1415665320977\" href=\"/news/magazine-29934965\"><img src=\"http://news.bbcimg.co.uk/media/images/78826000/jpg/_78826273_83fe5038-f315-4b7a-a36c-880ca55298dc.jpg\" alt=\"St John Battersby\" />Lost youth</a>\\n </h3>\\n \\n <p>How did 14-year-olds end up in the trenches in WW1? \\n <span id=\"dna-comment-count___CPS__29934965\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\\n \\n <hr />\\n </li>\\n \\n \\n <li class=\"medium-image\">\\n \\n \\n \\n<h3 class=\" feature-header\">\\n <a class=\"story\" rel=\"published-1415718709047\" href=\"/news/world-asia-china-30000744\"><img src=\"http://news.bbcimg.co.uk/media/images/78915000/jpg/_78915086_78912435.jpg\" alt=\"Russia&quot;s President Vladimir Putin right puts a shawl on Peng Liyuan left wife of Chinese President Xi Jinping\" />Macho move</a>\\n </h3>\\n \\n <p>How Russian president&#039;s gesture ignited a media firestorm in China \\n <span id=\"dna-comment-count___CPS__30000744\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\\n \\n <hr />\\n </li>\\n \\n \\n <li class=\"medium-image\">\\n \\n \\n \\n<h3 class=\" feature-header\">\\n <a class=\"story\" rel=\"published-1415703100952\" href=\"/news/blogs-magazine-monitor-30002096\"><img src=\"http://news.bbcimg.co.uk/media/images/78906000/jpg/_78906541_coposite.jpg\" alt=\"Back and front of the watch\" />The Supercomplication</a>\\n </h3>\\n \\n <p>The 24 features of the most complicated handmade watch \\n <span id=\"dna-comment-count___CPS__30002096\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\\n \\n <hr />\\n </li>\\n \\n \\n \\n \\n </ul>\\n </div>\\n <script type=\"text/javascript\">$render(\"feature-generic\" \"features\");</script> \\n \\n<div id=\"most-popular\" class=\"livestats livestats-tabbed tabbed range-most-popular\">\\n \\n <h2 class=\"livestats-header\">Most Popular</h2>\\n \\n \\n <h3 class=\"tab \"><a href=\"#\">Shared</a></h3>\\n \\n <div class=\"panel \">\\n <ol>\\n <li\\n class=\"first-child ol1\">\\n <a\\n href=\"http://www.bbc.co.uk/news/health-30000934\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-1\">1: </span>Doughnut burger busts day\\'s calories</a>\\n</li>\\n<li\\n class=\"ol2\">\\n <a\\n href=\"http://www.bbc.co.uk/news/uk-30002924\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-2\">2: </span>Gary Glitter denies sex charges</a>\\n</li>\\n<li\\n class=\"ol3\">\\n <a\\n href=\"http://www.bbc.co.uk/news/entertainment-arts-29984402\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-3\">3: </span>Ant and Dec asked to end \\'animal abuse\\'</a>\\n</li>\\n<li\\n class=\"ol4\">\\n <a\\n href=\"http://www.bbc.co.uk/news/uk-30000333\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-4\">4: </span>Last poppy laid as UK honours war dead</a>\\n</li>\\n<li\\n class=\"ol5\">\\n <a\\n href=\"http://www.bbc.co.uk/news/blogs-magazine-monitor-30002096\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-5\">5: </span>The story of the \\'most complicated\\' watch in the world</a>\\n</li>\\n </ol>\\n </div>\\n \\n <h3 class=\"tab open\"><a href=\"#\">Read</a></h3>\\n \\n <div class=\"panel open\">\\n <ol>\\n <li\\n class=\"first-child ol1\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-asia-china-30000744\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-1\">1: </span>When Singles Day Putin and China\\'s first lady collided</a>\\n</li>\\n<li\\n class=\"ol2\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-europe-30011512\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-2\">2: </span>EU court backs migrant benefit curbs</a>\\n</li>\\n<li\\n class=\"ol3\">\\n <a\\n href=\"http://www.bbc.co.uk/news/magazine-29950844\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-3\">3: </span>The people with the reddest hair in the world</a>\\n</li>\\n<li\\n class=\"ol4\">\\n <a\\n href=\"http://www.bbc.co.uk/news/entertainment-arts-30002070\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-4\">4: </span>Woman \\'maces man\\' at Turner screening</a>\\n</li>\\n<li\\n class=\"ol5\">\\n <a\\n href=\"http://www.bbc.co.uk/news/entertainment-arts-15328583\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-5\">5: </span>Van Gogh \\'did not kill himself\\'</a>\\n</li>\\n<li\\n class=\"ol6\">\\n <a\\n href=\"http://www.bbc.co.uk/news/blogs-magazine-monitor-30002096\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-6\">6: </span>The story of the \\'most complicated\\' watch in the world</a>\\n</li>\\n<li\\n class=\"ol7\">\\n <a\\n href=\"http://www.bbc.co.uk/news/entertainment-arts-30011174\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-7\">7: </span>Tarantino \\'to retire\\' after 10th film</a>\\n</li>\\n<li\\n class=\"ol8\">\\n <a\\n href=\"http://www.bbc.co.uk/news/business-29999289\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-8\">8: </span>Alibaba Singles\\' Day sales pass $9bn</a>\\n</li>\\n<li\\n class=\"ol9\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-africa-30006066\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-9\">9: </span>Nigeria fury over US arms refusal</a>\\n</li>\\n<li\\n class=\"ol10\">\\n <a\\n href=\"http://www.bbc.co.uk/news/uk-30000333\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-10\">10: </span>Last poppy laid as UK honours war dead</a>\\n</li>\\n </ol>\\n </div>\\n \\n <h3 class=\"tab \"><a href=\"#\">Video/Audio</a></h3>\\n \\n <div class=\"panel \">\\n <ol>\\n <li\\n class=\"has-icon-watch ol2\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-africa-30011166\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-2\">2: </span>\\'Revenge porn\\' victim faces arrest<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol3\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-asia-30003673\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-3\">3: </span>Putin rebuffed by China\\'s First Lady<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol4\">\\n <a\\n href=\"http://www.bbc.co.uk/news/video_and_audio/\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-4\">4: </span>One-minute World News<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol5\">\\n <a\\n href=\"http://www.bbc.co.uk/news/entertainment-arts-29999639\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-5\">5: </span>The Who celebrate 50 years<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol6\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-latin-america-29946423\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-6\">6: </span>Mexico student who escaped \\'massacre\\'<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol7\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-europe-30004314\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-7\">7: </span>How the world marked Armistice Day<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol8\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-europe-30000547\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-8\">8: </span>Veterans attend Menin Gate ceremony<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol9\">\\n <a\\n href=\"http://www.bbc.co.uk/news/world-europe-30003674\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-9\">9: </span>Is this the ultimate pushbike?<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n<li\\n class=\"has-icon-watch ol10\">\\n <a\\n href=\"http://www.bbc.co.uk/news/uk-29917406\"\\n class=\"story\">\\n <span\\n class=\"livestats-icon livestats-10\">10: </span>Bird\\'s-eye view of Gatwick runway plans<span\\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\\n</li>\\n </ol>\\n </div>\\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"range-most-popular\" \"most-popular\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n</div>\\n<script type=\"text/javascript\">$render(\"most-popular\" \"most-popular\");</script>\\n </div>\\n \\n \\n \\n <div class=\"hyperpuff\">\\n <div id=\"include-group-for-hypers\" class=\"include-only special-event-promotion-best\">\\n \\n <div id=\"from-bbc-future\" class=\"\">\\n <h2><span>BBC Future</span></h2>\\n <div id=\"\" class=\"story\">\\n <a class=\"story-image\" href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">\\n <img src=\"http://ichef.bbci.co.uk/wwfeatures/336_170/images/live/p0/2b/fc/p02bfccc.jpg\" alt=\"(Jason Cammisa)\" width=\"336\" height=\"170\"/>\\n </a>\\n <div class=\"text-container\">\\n <h3 class=\"headline\" style=\"line-height: 24px;\"><a href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">A revolution on two wheels?</a></h3>\\n <span class=\"summary\" style=\"font-size: 13px\">The shape of city cars to come <a href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">Read more...</a></span>\\n </div>\\n </div>\\n </div>\\n</div>\\n<script type=\"text/javascript\">$render(\"include-group-for-hypers\" \"include-group-for-hypers\");</script> \\n </div>\\n \\n \\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-partner-button\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n \\n \\n <div class=\"hyperpuff\">\\n \\n \\n<div id=\"container-programme-promotion\" class=\"container-programme-promotion\">\\n <h2 class=\"programmes-header\">Programmes</h2>\\n \\n \\n \\n<ul class=\"programme-breakout\">\\n \\n \\n \\n <li class=\"first-child large-image\"> \\n \\n \\n \\n<h3 class=\" programme-header\">\\n <a class=\"story\" rel=\"published-1415708859693\" href=\"http://www.bbc.co.uk/programmes/p02bkv3r\"><img src=\"http://news.bbcimg.co.uk/media/images/78912000/jpg/_78912628_webber1024.jpg\" alt=\"Former F1 driver Mark Webber\" />Extra Time<span class=\"gvl3-icon-wrapper\"><span class=\"gvl3-icon gvl3-icon-invert-watch\"> Watch</span></span></a>\\n </h3>\\n <p>Mark Webber on dealing with the politics and &#039;shallow relationships&#039; of Formula 1</p>\\n \\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"programme-breakout\" \"extra-time\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n </li>\\n</ul> \\n </div>\\n<script type=\"text/javascript\">$render(\"container-programmes-promotion\" \"container-programme-promotion\");</script>\\n \\n </div>\\n \\n \\n \\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-native-side\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n <div class=\"bbccom_advert_placeholder\">\\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-bottom\");</script>\\n </div>\\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\\n \\n \\n</div>\\n <!-- END #MAIN-CONTENT & CPS_ASSET_TYPE CLASS: story -->\\n </div>\\n<!-- END CPS_AUDIENCE CLASS: international -->\\n \\n</div> \\n<div id=\"related-services\" class=\"footer\">\\n <div id=\"news-services\">\\n <h2>Services</h2>\\n <ul>\\n <li id=\"service-mobile\" class=\"first-child\"><a href=\"/news/10628994\"><span class=\"gvl3-mobile-icon-large services-icon\">&nbsp;</span>Mobile</a></li>\\n <li id=\"service-feeds\"><a href=\"/news/help-17655000\"><span class=\"gvl3-connected-tv-icon-large services-icon\">&nbsp;</span>Connected TV</a></li>\\n <li id=\"service-podcast\"><a href=\"/news/10628494\"><span class=\"gvl3-feeds-icon-large services-icon\">&nbsp;</span>News feeds</a></li>\\n <li id=\"service-alerts\"><a href=\"/news/10628323\"><span class=\"gvl3-alerts-icon-large services-icon\">&nbsp;</span>Alerts</a></li>\\n <li id=\"service-email-news\"><a href=\"/news/help/16617948\"><span class=\"gvl3-email-icon-large services-icon\">&nbsp;</span>E-mail news</a></li>\\n </ul> \\n </div>\\n <div id=\"news-related-sites\">\\n <h2><a href=\"/news/19888761\">About BBC News</a></h2>\\n <ul>\\n <li class=\"column-1\"><a href=\"/news/blogs/the_editors/\">Editors\\' blog</a></li>\\n <li class=\"column-1\"><a href=\"/journalism/\">BBC College of Journalism</a></li>\\n <li class=\"column-1\"><a href=\"/news/10621655\">News sources</a></li>\\n <li class=\"column-1\"><a href=\"/mediaaction/\">Media Action</a></li>\\n <li class=\"column-1\"><a href=\"/editorialguidelines/\">Editorial Guidelines</a></li>\\n </ul>\\n </div>\\n</div>\\n</div><!-- close technology -->\\n \\n \\n </div> <!--[if IE 6]> <div id=\"blq-ie6-upgrade\"> <p> <span>You\\'re using the Internet Explorer 6 browser to view the BBC website. Our site will work much better if you change to a more modern browser. It\\'s free quick and easy.</span> <a href=\"http://www.browserchoice.eu/\">Find out more <span>about upgrading your browser</span> here&hellip;</a> </p> </div> <![endif]--> <div id=\"blq-foot\" xml:lang=\"en-GB\" class=\"blq-rst blq-clearfix blq-foot-transparent blq-foot-text-dark\"> <div id=\"blq-footlinks\"> <h2 class=\"blq-hide\">BBC links</h2> <ul> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"/news/mobile/\" id=\"blq-footer-mobile\">Mobile site</a></li><li><a href=\"http://www.bbc.co.uk/terms/\">Terms of Use</a></li><li><a href=\"http://www.bbc.co.uk/aboutthebbc/\">About the BBC</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://advertising.bbcworldwide.com\">Advertise With Us</a></li><li><a href=\"http://www.bbc.co.uk/privacy/\">Privacy</a></li><li><a href=\"http://www.bbc.co.uk/accessibility/\">Accessibility Help</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://www.bbc.co.uk/privacy/cookies/international/\">Ad Choices</a></li><li><a href=\"http://www.bbc.co.uk/privacy/cookies/about\">Cookies</a></li><li><a href=\"/news/21323537\">Contact the BBC</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://www.bbc.co.uk/guidance/\">Parental Guidance</a></li> </ul> </li> </ul> <script type=\"text/javascript\">/*<![CDATA[*/ (function() { var mLink = document.getElementById(\\'blq-footer-mobile\\') stick = function() { var d = new Date (); d.setYear(d.getFullYear() + 1); d = d.toUTCString(); window.bbccookies.set(\\'ckps_d=m;domain=.bbc.co.uk;path=/;expires=\\' + d ); window.bbccookies.set(\\'ckps_d=m;domain=.bbc.com;path=/;expires=\\' + d ); }; if (mLink) { if (mLink.addEventListener) { mLink.addEventListener(\\'click\\' stick false); } else if (mLink.attachEvent) { mLink.attachEvent(\\'onclick\\' stick); } } })(); /*]]>*/</script> </div> <div id=\"blq-foot-blocks\" class=\"blq-footer-image-dark\"><img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blocks/dark.png\" width=\"84\" height=\"24\" alt=\"BBC\" /></div> <p id=\"blq-disclaim\"><span id=\"blq-copy\">BBC &copy; 2014</span> <a href=\"http://www.bbc.co.uk/help/web/links/\">The BBC is not responsible for the content of external sites. Read more.</a></p> <div id=\"blq-obit\"><p><strong>This page is best viewed in an up-to-date web browser with style sheets (CSS) enabled. While you will be able to view the content of this page in your current browser you will not be able to get the full visual experience. Please consider upgrading your browser software or enabling style sheets (CSS) if you are able to do so.</strong></p></div> </div> </div> \\n<!-- BBCDOTCOM analytics template:client-side journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON -->\\n <!-- BBCCOM analytics client-side -->\\n<div id=\"bbccomWebBug\" class=\"bbccomWebBug\"></div>\\n<!-- START: BBCCOM-5810: SiteCatalyst desktop vs responsive tag comparison -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\') && window.location.pathname.indexOf(\\'/news/business\\') !== -1) {\\n document.write(\\'<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/config.js\">\\\\x3C/script>\\');\\n document.write(\\'<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/utils.js\">\\\\x3C/script>\\');\\n document.write(\\'<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/sections.js\">\\\\x3C/script>\\');\\n document.write(\\'<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/adverts/keyValues.js\">\\\\x3C/script>\\');\\n document.write(\\'<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/analytics.js\">\\\\x3C/script>\\');\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\') && window.location.pathname.indexOf(\\'/news/business\\') !== -1) {\\n if (bbcdotcom && bbcdotcom.analytics) {\\n bbcdotcom.analytics.init();\\n bbcdotcom.analytics.setSuite(\\'bbcresponsivedev\\');\\n bbcdotcom.analytics.page();\\n }\\n }\\n /*]]>*/\\n</script>\\n<!-- END: BBCCOM-5810: SiteCatalyst desktop vs responsive tag comparison -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n if(typeof(bbcdotcom) != \\'undefined\\' && typeof(bbcdotcom.stats) != \\'undefined\\') {\\n bbcdotcom.stats.contentType = \"HTML\";\\n }\\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://js.revsci.net/gateway/gw.js?csid=J08781\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n DM_tag();\\n }\\n /*]]>*/\\n</script>\\n<!-- Start SiteCatalyst -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\') && typeof scw === \\'undefined\\') {\\n BBC.journalismVariant = true;\\n \\n var s_account = \"bbcwglobalprod\";\\n \\n \\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/s_code.js\"%3E%3C/script%3E\\'));\\n \\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\') && BBC.journalismVariant) {\\n var s_code=scw.t();if(s_code)document.write(s_code)\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\') && BBC.journalismVariant) {\\n if(navigator.appVersion.indexOf(\\'MSIE\\')>=0)document.write(unescape(\\'%3C\\')+\\'\\\\!-\\'+\\'-\\')\\n }\\n /*]]>*/\\n</script>\\n<!-- End SiteCatalyst -->\\n<!-- Start comScore Tag -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n document.write(unescape(\"%3Cscript src=\\'\" + (document.location.protocol == \"https:\" ? \"https://sb\" : \"http://b\") + \".scorecardresearch.com/beacon.js\\' %3E%3C/script%3E\"));\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n COMSCORE.beacon({\\n c1:2 \\n c2:\"6035051\" \\n c3:\"\" \\n c4:\"www.bbc.com/news/technology-26415021\" \\n c5:\"\" \\n c6:\"\" \\n c15:\"\"\\n });\\n }\\n /*]]>*/\\n</script>\\n<!-- End comScore Tag -->\\n<!-- Begin Sitestat4 code -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'sitestat\\')) {\\n function sitestat(ns_l){ns_l+=\\'&amp;ns__t=\\'+(new Date()).getTime();\\n ns_0=document.referrer;\\n ns_0=(ns_0.lastIndexOf(\\'/\\')==ns_0.length-1)?ns_0.substring(ns_0.lastIndexOf(\\'/\\') 0):ns_0;\\n if(ns_0.length>0)ns_l+=\\'&amp;ns_referrer=\\'+escape(ns_0);\\n if(document.images){ns_1=new Image();ns_1.src=ns_l;}else\\n document.write(\\'<img src=\"\\'+ns_l+\\'\" width=\"1\" height=\"1\" alt=\"\">\\');}\\n sitestat(\"http://nl.sitestat.com/adfab/bbc/s?teller\");\\n }\\n /*]]>*/\\n</script>\\n<!-- End Sitestat4 code -->\\n<!-- Start Nielsen Online SiteCensus V6.0 -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'nielsen-au\\')) {\\n <!-- COPYRIGHT 2009 Nielsen Online -->\\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"\\' + (\\'https:\\' == document.location.protocol ? \\'https:\\' : \\'http:\\') + \\'//secure-au.imrworldwide.com/v60.js\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'nielsen-au\\')) {\\n <!-- Start Nielsen Online SiteCensus V6.0 Part 2 -->\\n nol_t({cid:\"au-bbc\" content:\"0\" server:\"secure-au\"}).record().post();\\n <!-- End Nielsen Online SiteCensus V6.0 Part 2 -->\\n }\\n /*]]>*/\\n</script>\\n<!-- End Nielsen Online SiteCensus V6.0 -->\\n<!-- Start Nielsen Online SiteCensus V6.0 -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'nielsen-nz\\')) {\\n <!-- COPYRIGHT 2009 Nielsen Online -->\\n document.write(unescape(\\'%3Cscript type=\"text/javascript\" src=\"\\' + (\\'https:\\' == document.location.protocol ? \\'https:\\' : \\'http:\\') + \\'//secure-nz.imrworldwide.com/v60.js\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'nielsen-nz\\')) {\\n nol_t({cid:\"nz-bbc\" content:\"0\" server:\"secure-nz\"}).record().post();\\n }\\n /*]]>*/\\n</script>\\n<!-- End Nielsen Online SiteCensus V6.0 -->\\n<!-- Start Nielsen Online SiteCensus V6.0 -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'nielsen-us\\')) {\\n <!-- COPYRIGHT 2010 Nielsen Online -->\\n (function () {\\n var d = new Image(1 1);\\n d.onerror = d.onload = function () {\\n d.onerror = d.onload = null;\\n };\\n d.src = [(\\'https:\\' == document.location.protocol ? \\'https:\\' : \\'http:\\') + \"//secure-us.imrworldwide.com/cgi-bin/m?ci=us-804789h&amp;cg=0&amp;cc=1&amp;si=\" escape(window.location.href) \"&amp;rp=\" \\n escape(document.referrer) \"&amp;ts=compact&amp;rnd=\" (new Date()).getTime()].join(\\'\\');\\n })();\\n }\\n /*]]>*/\\n</script>\\n<!-- End Nielsen Online SiteCensus V6.0 -->\\n<!-- Effective Measure BBCCOM-1195 -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'analytics\\')) {\\n (function() {\\n var em = document.createElement(\\'script\\'); em.type = \\'text/javascript\\'; em.async = true;\\n em.src = (\\'https:\\' == document.location.protocol ? \\'https://me-ssl\\' : \\'http://me-cdn\\') + \\'.effectivemeasure.net/em.js\\';\\n var s = document.getElementsByTagName(\\'script\\')[0]; s.parentNode.insertBefore(em s);\\n })();\\n }\\n /*]]>*/\\n</script>\\n<!-- End Effective Measure -->\\n<!-- AGOF BBCCOM-1271 -->\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'agof\\')) {\\n var ivwcode=\"default\";\\n if(typeof BBC != \\'undefined\\' && typeof BBC.adverts != \\'undefined\\'){\\n ivwcode = BBC.adverts.getSectionPath();\\n }\\n var IVW=\"http://bbc.ivwbox.de/cgi-bin/ivw/CP/\"+ivwcode+\";\";\\n document.write(\"<img src=\\\\\"\"+IVW+\"?r=\"+escape(document.referrer)+\"&d=\"+(Math.random()*100000)+\"\\\\\" width=\\\\\"1\\\\\" height=\\\\\"1\\\\\" alt=\\\\\"szmtag\\\\\" />\");\\n }\\n /*]]>*/\\n</script>\\n<script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'agof\\')) {\\n var szmvars=\"bbc//CP/\"+ivwcode;\\n document.write(unescape(\\'%3Cscript src=\"http://bbc.ivwbox.de/2004/01/survey.js\" type=\"text/javascript\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n</script>\\n<!-- End AGOF -->\\n <!-- BBCCOM-5234 Outbrain Tracking -->\\n \\n <div class=\"OUTBRAIN\" data-src=\"http://www.bbc.com/news/technology-26415021\" data-widget-id=\"TR_1\" data-ob-template=\"BBC.com/News\"></div>\\n <script type=\"text/javascript\">\\n /*<![CDATA[*/\\n if (BBC.adverts.isActive(\\'ads\\') && BBC.adverts.isActive(\\'analytics\\')) {\\n document.write(unescape(\\'%3Cscript src=\"http://widgets.outbrain.com/outbrain.js\" type=\"text/javascript\"%3E%3C/script%3E\\'));\\n }\\n /*]]>*/\\n </script>\\n \\n \\n<!-- BBCDOTCOM Body Last -->\\n </div> </div> <script type=\"text/javascript\"> if (typeof require !== \\'undefined\\') { require([\\'istats-1\\'] function(istats){ istats.track(\\'external\\' { region: document.getElementById(\\'blq-main\\') }); istats.track(\\'download\\' { region: document.getElementById(\\'blq-main\\') }); }); } </script> <script type=\"text/html\" id=\"blq-panel-template-promo\"><![CDATA[ <div id=\"blq-panel-promo\" class=\"blq-masthead-container\"></div> ]]></script> <script type=\"text/html\" id=\"blq-panel-template-more\"><![CDATA[ <div id=\"blq-panel-more\" class=\"blq-masthead-container blq-clearfix\" xml:lang=\"en-GB\" dir=\"ltr\"> <div class=\"blq-panel-container panel-paneltype-more\"> <div class=\"panel-header\"> <h2> <a href=\"http://www.bbc.co.uk/a-z/\"> More&hellip; </a> </h2> <a href=\"http://www.bbc.co.uk/a-z/\" class=\"panel-header-links panel-header-link\">Full A-Z<span class=\"blq-hide\"> of BBC sites</span></a> </div> <div class=\"panel-component panel-links\"> <ul> <li> <a href=\"http://www.bbc.co.uk/cbbc/\" >CBBC</a> </li> <li> <a href=\"http://www.bbc.co.uk/cbeebies/\" >CBeebies</a> </li> <li> <a href=\"http://www.bbc.com/capital\" >Capital</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/food/\" >Food</a> </li> <li> <a href=\"http://www.bbc.co.uk/history/\" >History</a> </li> <li> <a href=\"http://www.bbc.co.uk/comedy/\" >Comedy</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/music/\" >Music</a> </li> <li> <a href=\"http://www.bbc.co.uk/science/\" >Science</a> </li> <li> <a href=\"http://www.bbc.co.uk/learning/\" >Learning</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/local/\" >Local</a> </li> <li> <a href=\"http://www.bbc.com/travel/\" >Travel</a> </li> <li> <a href=\"http://www.bbc.co.uk/nature/\" >Nature</a> </li> </ul> </div> </div> ]]></script> \\n \\n<!-- shared/foot -->\\n<script type=\"text/javascript\">\\n bbc.fmtj.common.removeNoScript({});\\n bbc.fmtj.common.tabs.createTabs({});\\n</script>\\n<!-- hi/news/foot.inc -->\\n<!-- Chartbeat Web Analytics code - start -->\\n<script type=\"text/javascript\">\\nvar _sf_async_config={};\\n/** CONFIGURATION START **/\\n_sf_async_config.uid = 50924; /** Chartbeat BBC id **/\\n_sf_async_config.domain = \"bbc.co.uk\";/** BBC domain being tracked **/\\n_sf_async_config.sections = \"s-news - technology\";\\n_sf_async_config.region = \"international\";\\n <!-- all multi-edition pages that are not indexes eg. story pages need the title -->\\n var storyTitle = \"BBC+News+-+An+hour+to+catch+the+coding+bug\".replace(new RegExp(\\'\\\\\\\\+\\' \\'gi\\') \\' \\');//remove the plus signs\\n storyTitle = decodeURIComponent(storyTitle.replace(\"BBC News - \" \"\"));//remove the sub-string \\'BBC News\\' and convert utf-8 chars to html\\n _sf_async_config.title = storyTitle;\\n/** CONFIGURATION END **/\\n(function(){\\n var noCookies = true;\\n if (\"object\" === typeof bbccookies && typeof bbccookies.readPolicy == \\'function\\') {\\n noCookies = !bbccookies.readPolicy().performance;\\n }\\n _sf_async_config.noCookies = noCookies;\\n function loadChartbeat() {\\n window._sf_endpt=(new Date()).getTime();\\n var e = document.createElement(\"script\");\\n e.setAttribute(\"language\" \"javascript\");\\n e.setAttribute(\"type\" \"text/javascript\");\\n e.setAttribute(\\'src\\' \\'/inc/specials/cream/hi/news/chartbeat/chartbeat.js\\');\\n document.body.appendChild(e);\\n }\\n var oldonload = window.onload;\\n window.onload = (typeof window.onload != \"function\") ?\\n loadChartbeat : function() { oldonload(); loadChartbeat(); };\\n})();\\n</script>\\n<!-- Chartbeat Web Analytics code - end -->\\n<!-- shared/foot_story -->\\n<!-- #CREAM hi news international foot.inc -->\\n \\n</body>\\n</html>\\n'"
      }
     ],
     "prompt_number": 7
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "This is becoming a mess, let us get line breaks back:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "html = html.split(\"\\n\") # html is now a list of lines\nhtml = \"\\n\".join(html)    # we turn it back into a single string\nprint html",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML+RDFa 1.0//EN\" \"http://www.w3.org/MarkUp/DTD/xhtml-rdfa-1.dtd\">\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xmlns:og=\"http://opengraphprotocol.org/schema/\" xmlns:rnews=\"http://iptc.org/std/rNews/2011-10-07#\" xml:lang=\"en\" >\n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n<!-- THIS FILE CONFIGURES SHARED HIGHWEB STATIC ASSETS -->\n<!-- mapping_news.inc -->\n<!-- THIS FILE CONFIGURES NEWS STATIC ASSETS -->\n<!-- THIS FILE CONFIGURES VOTE 2012 STATIC ASSETS -->\n <!-- hi/shared/head_initial.inc -->\n <!-- IGOR News -->\n \n \n \n \n<!-- set CPS_HTTP_HOST_DOMAIN for news and ww1 -->\n \n \n \n <head profile=\"http://dublincore.org/documents/dcq-html/\" resource=\"http://www.bbc.co.uk/news/technology-26415021\" typeof=\"rnews:NewsItem\">\n <meta http-equiv=\"X-UA-Compatible\" content=\"IE=8\" />\n <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n <title>BBC News - An hour to catch the coding bug</title>\n <meta name=\"Description\" content=\"Is it possible to get children interested in computer programming in just 60 minutes? The Hour of Code has been designed to do just that.\"/>\n <meta property=\"rnews:description\" content=\"Is it possible to get children interested in computer programming in just 60 minutes? The Hour of Code has been designed to do just that.\"/>\n <meta name=\"OriginalPublicationDate\" content=\"2014/03/03 10:22:55\"/>\n <meta property=\"rnews:datePublished\" content=\"2014/03/03 10:22:55\"/>\n <meta name=\"UKFS_URL\" content=\"/news/technology-26415021\"/>\n <meta name=\"THUMBNAIL_URL\" content=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325446_hourofcode.jpg\"/>\n <meta property=\"rnews:thumbnailUrl\" content=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325446_hourofcode.jpg\"/>\n <meta name=\"Headline\" content=\"How to get your children coding\"/>\n <meta property=\"rnews:headline\" content=\"How to get your children coding\"/>\n <meta name=\"IFS_URL\" content=\"/news/technology-26415021\"/>\n <meta name=\"Section\" content=\"Technology\"/>\n <meta name=\"contentFlavor\" content=\"STORY\"/>\n <meta name=\"CPS_ID\" content=\"26415021\" />\n <meta name=\"CPS_SITE_NAME\" content=\"BBC News\" />\n <meta name=\"CPS_SECTION_PATH\" content=\"Technology\" />\n <meta name=\"CPS_ASSET_TYPE\" content=\"STY\" />\n <meta name=\"CPS_PLATFORM\" content=\"HighWeb\" />\n <meta name=\"CPS_AUDIENCE\" content=\"International\" />\n <meta property=\"rnews:creator\" content=\"http://www.bbc.co.uk#org\"/>\n <meta property=\"og:title\" content=\"How to get your children coding\"/>\n <meta property=\"og:type\" content=\"article\"/>\n <meta property=\"og:url\" content=\"http://www.bbc.com/news/technology-26415021\"/>\n <meta property=\"og:site_name\" content=\"BBC News\"/>\n <meta property=\"og:image\" content=\"http://newsimg.bbc.co.uk/media/images/67373000/jpg/_67373987_09f1654a-e583-4b5f-bfc4-f05850c6d3ce.jpg\"/>\n \n <meta name=\"bbcsearch_noindex\" content=\"atom\"/>\n \n \n <link rel=\"canonical\" href=\"http://www.bbc.com/news/technology-26415021\" />\n<link rel=\"alternate\" hreflang=\"en\" href=\"http://www.bbc.com/news/technology-26415021\" />\n<link rel=\"alternate\" hreflang=\"en-gb\" href=\"http://www.bbc.co.uk/news/technology-26415021\" />\n \n \n \n <!-- hi/news/head_first.inc -->\n<!-- Chartbeat Web Analytics code - start -->\n<script type=\"text/javascript\">var _sf_startpt=(new Date()).getTime()</script>\n<!-- Chartbeat Web Analytics code - end -->\n<meta name=\"application-name\" content=\"BBC News\" />\n<meta name=\"msapplication-TileImage\" content=\"/img/1_0_3/cream/hi/news/bbc-news-pin.png\" />\n<meta name=\"msapplication-TileColor\" content=\"#CC0101\" />\n<meta name=\"twitter:card\" value=\"summary\" />\n <!-- Project IGOR - Barlesque redirection logic - START -->\n <script>\n /*<![CDATA[*/\n window.bbcredirection = {\n \n device: true \n geo: true\n \n }\n /*]]>*/\n </script>\n<!-- Project IGOR - Barlesque redirection logic - END -->\n<!-- PULSE_ENABLED:yes -->\n<!-- vars inc blq_cachebust_journalism 1.21.19 -->\n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n \n <meta http-equiv=\"X-UA-Compatible\" content=\"IE=8\" /> \n <link rel=\"schema.dcterms\" href=\"http://purl.org/dc/terms/\" /> <link rel=\"index\" href=\"http://www.bbc.co.uk/a-z/\" title=\"A to Z\" /> <link rel=\"copyright\" href=\"http://www.bbc.co.uk/terms/\" title=\"Terms of Use\" /> <link rel=\"icon\" href=\"http://www.bbc.co.uk/favicon.ico\" type=\"image/x-icon\" /> <meta name=\"viewport\" content=\"width = 996\" /> \n<script type=\"text/javascript\">window.orb = window.orb || {};</script>\n<script type=\"text/javascript\">/*<![CDATA[*/\n(function(){window.fig=window.fig||{};window.fig.manager={include:function(a){a=a||window;var e=a.document g=e.cookie b=g.match(/(?:^|; ?)ckns_orb_fig=([^;]+)/);if(!b&&g.indexOf(\"ckns_orb_nofig=1\")>-1){this.setFig(a {no:1})}else{if(b){b=this.deserialise(decodeURIComponent(RegExp.$1));this.setFig(a b)}e.write('<script src=\"https://ssl.bbc.co.uk/frameworks/fig/1/fig.js\"><'+\"/script>\")}} confirm:function(a){a=a||window;if(a.orb&&a.orb.fig&&a.orb.fig(\"no\")){this.setNoFigCookie(a)}if(a.orb===undefined||a.orb.fig===undefined){this.setFig(a {no:1});this.setNoFigCookie(a)}} setNoFigCookie:function(a){a.document.cookie=\"ckns_orb_nofig=1; expires=\"+new Date(new Date().getTime()+1000*60*10).toGMTString()+\";\"} setFig:function(a b){(function(){var c=b;a.orb=a.orb||{};a.orb.fig=function(d){return(arguments.length)?c[d]:c}})()} deserialise:function(b){var a={};b.replace(/([a-z]{2}):([0-9]+)/g function(){a[RegExp.$1]=+RegExp.$2});return a}}})();fig.manager.include();/*]]>*/</script>\n<script type=\"text/javascript\"> fig.manager.confirm(); </script>\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/style/main.css\" /> <script type=\"text/javascript\">/*<![CDATA[*/ (function(undefined){if(!window.bbc){window.bbc={}}var ROLLING_PERIOD_DAYS=30;window.bbc.Mandolin=function(id segments opts){var now=new Date().getTime() storedItem DEFAULT_START=now DEFAULT_RATE=1 COOKIE_NAME=\"ckpf_mandolin\";opts=opts||{};this._id=id;this._segmentSet=segments;this._store=new window.window.bbc.Mandolin.Storage(COOKIE_NAME);this._opts=opts;this._rate=(opts.rate!==undefined)?+opts.rate:DEFAULT_RATE;this._startTs=(opts.start!==undefined)?new Date(opts.start).getTime():new Date(DEFAULT_START).getTime();this._endTs=(opts.end!==undefined)?new Date(opts.end).getTime():daysFromNow(ROLLING_PERIOD_DAYS);this._signupEndTs=(opts.signupEnd!==undefined)?new Date(opts.signupEnd).getTime():this._endTs;this._segment=null;if(typeof id!==\"string\"){throw new Error(\"Invalid Argument: id must be defined and be a string\")}if(Object.prototype.toString.call(segments)!==\"[object Array]\"){throw new Error(\"Invalid Argument: Segments are required.\")}if(opts.rate!==undefined&&(opts.rate<0||opts.rate>1)){throw new Error(\"Invalid Argument: Rate must be between 0 and 1.\")}if(this._startTs>this._endTs){throw new Error(\"Invalid Argument: end date must occur after start date.\")}if(!(this._startTs<this._signupEndTs&&this._signupEndTs<=this._endTs)){throw new Error(\"Invalid Argument: SignupEnd must be between start and end date\")}removeExpired.call(this now);var overrides=window.bbccookies.get().match(/ckns_mandolin_setSegments=([^;]+)/);if(overrides!==null){eval(\"overrides = \"+decodeURIComponent(RegExp.$1)+\";\");if(overrides[this._id]&&this._segmentSet.indexOf(overrides[this._id])==-1){throw new Error(\"Invalid Override: overridden segment should exist in segments array\")}}if(overrides!==null&&overrides[this._id]){this._segment=overrides[this._id]}else{if((storedItem=this._store.getItem(this._id))){this._segment=storedItem.segment}else{if(this._startTs<=now&&now<this._signupEndTs&&now<=this._endTs&&this._store.isEnabled()===true){this._segment=pick(segments this._rate);if(opts.end===undefined){this._store.setItem(this._id {segment:this._segment})}else{this._store.setItem(this._id {segment:this._segment end:this._endTs})}log.call(this \"mandolin_segment\")}}}log.call(this \"mandolin_view\")};window.bbc.Mandolin.prototype.getSegment=function(){return this._segment};function log(actionType params){var that=this;require([\"istats-1\"] function(istats){istats.log(actionType that._id+\":\"+that._segment params?params:{})})}function removeExpired(expires){var items=this._store.getItems() expiresInt=+expires;for(var key in items){if(items[key].end!==undefined&&+items[key].end<expiresInt){this._store.removeItem(key)}}}function getLastExpirationDate(data){var winner=0 rollingExpire=daysFromNow(ROLLING_PERIOD_DAYS);for(var key in data){if(data[key].end===undefined&&rollingExpire>winner){winner=rollingExpire}else{if(+data[key].end>winner){winner=+data[key].end}}}return(winner)?new Date(winner):new Date(rollingExpire)}window.bbc.Mandolin.prototype.log=function(params){log.call(this \"mandolin_log\" params)};window.bbc.Mandolin.prototype.convert=function(params){log.call(this \"mandolin_convert\" params);this.convert=function(){}};function daysFromNow(n){var endDate;endDate=new Date().getTime()+(n*60*60*24)*1000;return endDate}function pick(segments rate){var picked min=0 max=segments.length-1;if(typeof rate===\"number\"&&Math.random()>rate){return null}do{picked=Math.floor(Math.random()*(max-min+1))+min}while(picked>max);return segments[picked]}window.bbc.Mandolin.Storage=function(name){validateCookieName(name);this._cookieName=name;this._isEnabled=(bbccookies.isAllowed(this._cookieName)===true&&bbccookies.cookiesEnabled()===true)};window.bbc.Mandolin.Storage.prototype.setItem=function(key value){var storeData=this.getItems();storeData[key]=value;this.save(storeData);return value};window.bbc.Mandolin.Storage.prototype.isEnabled=function(){return this._isEnabled};window.bbc.Mandolin.Storage.prototype.getItem=function(key){var storeData=this.getItems();return storeData[key]};window.bbc.Mandolin.Storage.prototype.removeItem=function(key){var storeData=this.getItems();delete storeData[key];this.save(storeData)};window.bbc.Mandolin.Storage.prototype.getItems=function(){return deserialise(this.readCookie(this._cookieName)||\"\")};window.bbc.Mandolin.Storage.prototype.save=function(data){window.bbccookies.set(this._cookieName+\"=\"+encodeURIComponent(serialise(data))+\"; expires=\"+getLastExpirationDate(data).toUTCString()+\";\")};window.bbc.Mandolin.Storage.prototype.readCookie=function(name){var nameEq=name+\"=\" ca=window.bbccookies.get().split(\"; \") i c;validateCookieName(name);for(i=0;i<ca.length;i++){c=ca[i];if(c.indexOf(nameEq)===0){return decodeURIComponent(c.substring(nameEq.length c.length))}}return null};function serialise(o){var str=\"\";for(var p in o){if(o.hasOwnProperty(p)){str+='\"'+p+'\"'+\":\"+(typeof o[p]===\"object\"?(o[p]===null?\"null\":\"{\"+serialise(o[p])+\"}\"):'\"'+o[p].toString()+'\"')+\" \"}}return str.replace(/ \\}/g \"}\").replace(/ $/g \"\")}function deserialise(str){var o;str=\"{\"+str+\"}\";if(!validateSerialisation(str)){throw\"Invalid input provided for deserialisation.\"}eval(\"o = \"+str);return o}var validateSerialisation=(function(){var OBJECT_TOKEN=\"<Object>\" ESCAPED_CHAR='\"\\\\n\\\\r\\\\u2028\\\\u2029\\\\u000A\\\\u000D\\\\u005C' ALLOWED_CHAR=\"([^\"+ESCAPED_CHAR+\"]|\\\\\\\\[\"+ESCAPED_CHAR+\"])\" KEY='\"'+ALLOWED_CHAR+'+\"' VALUE='(null|\"'+ALLOWED_CHAR+'*\"|'+OBJECT_TOKEN+\")\" KEY_VALUE=KEY+\":\"+VALUE KEY_VALUE_SEQUENCE=\"(\"+KEY_VALUE+\" )*\"+KEY_VALUE OBJECT_LITERAL=\"({}|{\"+KEY_VALUE_SEQUENCE+\"})\" objectPattern=new RegExp(OBJECT_LITERAL \"g\");return function(str){if(str.indexOf(OBJECT_TOKEN)!==-1){return false}while(str.match(objectPattern)){str=str.replace(objectPattern OBJECT_TOKEN)}return str===OBJECT_TOKEN}})();function validateCookieName(name){if(name.match(/ ;/)){throw\"Illegal name provided must be valid in browser cookie.\"}}})(); /*]]>*/</script> <script type=\"text/javascript\">/*<![CDATA[*/ if (typeof bbccookies_flag === 'undefined') { bbccookies_flag = 'ON'; } showCTA_flag = false; cta_enabled = (showCTA_flag && (bbccookies_flag === 'ON') ); (function(){var e=\"ckns_policy\" m=\"Thu 01 Jan 1970 00:00:00 GMT\" k={ads:true personalisation:true performance:true necessary:true};function f(p){if(f.cache[p]){return f.cache[p]}var o=p.split(\"/\") q=[\"\"];do{q.unshift((o.join(\"/\")||\"/\"));o.pop()}while(q[0]!==\"/\");f.cache[p]=q;return q}f.cache={};function a(p){if(a.cache[p]){return a.cache[p]}var q=p.split(\".\") o=[];while(q.length&&\"|co.uk|com|\".indexOf(\"|\"+q.join(\".\")+\"|\")===-1){if(q.length){o.push(q.join(\".\"))}q.shift()}f.cache[p]=o;return o}a.cache={};function i(o t p){var z=[\"\"].concat(a(window.location.hostname)) w=f(window.location.pathname) y=\"\" r x;for(var s=0 v=z.length;s<v;s++){r=z[s];for(var q=0 u=w.length;q<u;q++){x=w[q];y=o+\"=\"+t+\";\"+(r?\"domain=\"+r+\";\":\"\")+(x?\"path=\"+x+\";\":\"\")+(p?\"expires=\"+p+\";\":\"\");bbccookies.set(y true)}}}window.bbccookies={_setEverywhere:i cookiesEnabled:function(){var o=\"ckns_testcookie\"+Math.floor(Math.random()*100000);this.set(o+\"=1\");if(this.get().indexOf(o)>-1){g(o);return true}return false} set:function(o){return document.cookie=o} get:function(){return document.cookie} _setPolicy:function(o){return h.apply(this arguments)} readPolicy:function(o){return b.apply(this arguments)} _deletePolicy:function(){i(e \"\" m)} isAllowed:function(){return true} _isConfirmed:function(){return c()!==null} _acceptsAll:function(){var o=b();return o&&!(j(o).indexOf(\"0\")>-1)} _getCookieName:function(){return d.apply(this arguments)} _showPrompt:function(){var o=(!this._isConfirmed()&&window.cta_enabled&&this.cookiesEnabled()&&!window.bbccookies_disable);return(window.orb&&window.orb.fig)?o&&(window.orb.fig(\"no\")||window.orb.fig(\"ck\")):o}};bbccookies._getPolicy=bbccookies.readPolicy;function d(p){var o=(\"\"+p).match(/^([^=]+)(?==)/);return(o&&o.length?o[0]:\"\")}function j(o){return\"\"+(o.ads?1:0)+(o.personalisation?1:0)+(o.performance?1:0)}function h(r){if(typeof r===\"undefined\"){r=k}if(typeof arguments[0]===\"string\"){var o=arguments[0] q=arguments[1];if(o===\"necessary\"){q=true}r=b();r[o]=q}else{if(typeof arguments[0]===\"object\"){r.necessary=true}}var p=new Date();p.setYear(p.getFullYear()+1);p=p.toUTCString();bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.co.uk;path=/;expires=\"+p+\";\");bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.com;path=/;expires=\"+p+\";\");return r}function l(o){if(o===null){return null}var p=o.split(\"\");return{ads:!!+p[0] personalisation:!!+p[1] performance:!!+p[2] necessary:true}}function c(){var o=new RegExp(\"(?:^|; ?)\"+e+\"=(\\\\d\\\\d\\\\d)($|;)\") p=document.cookie.match(o);if(!p){return null}return p[1]}function b(o){var p=l(c());if(!p){p=k}if(o){return p[o]}else{return p}}function g(o){return document.cookie=o+\"=;expires=\"+m+\";\"}function n(){var o='<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/bbccookies/0.6.6/script/bbccookies.js\"><\\/script>';if(window.bbccookies_flag===\"ON\"&&!bbccookies._acceptsAll()&&!window.bbccookies_disable){document.write(o)}}n()})(); /*]]>*/</script> <script type=\"text/javascript\"> if (! window.gloader) { window.gloader = [ \"glow\" {map: \"http://node1.bbcimg.co.uk/glow/glow/map.1.7.7.js\"}]; } </script> <script type=\"text/javascript\" src=\"http://node1.bbcimg.co.uk/glow/gloader.0.1.6.js\"></script> <script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/requirejs/0.16.0/sharedmodules/require.js\"></script> <script type=\"text/javascript\"> bbcRequireMap = {\"jquery-1\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.7.2\" \"jquery-1.4\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.4\" \"jquery-1.9\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.9.1\" \"swfobject-2\":\"http://static.bbci.co.uk/frameworks/swfobject/0.1.10/sharedmodules/swfobject-2\" \"demi-1\":\"http://static.bbci.co.uk/frameworks/demi/0.10.0/sharedmodules/demi-1\" \"gelui-1\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1\" \"cssp!gelui-1/overlay\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1/overlay.css\" \"istats-1\":\"http://static.bbci.co.uk/frameworks/istats/0.23.1/modules/istats-1\" \"relay-1\":\"http://static.bbci.co.uk/frameworks/relay/0.2.6/sharedmodules/relay-1\" \"clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1\" \"canvas-clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/canvas-clock-1\" \"cssp!clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1.css\" \"jssignals-1\":\"http://static.bbci.co.uk/frameworks/jssignals/0.3.6/modules/jssignals-1\" \"jcarousel-1\":\"http://static.bbci.co.uk/frameworks/jcarousel/0.1.10/modules/jcarousel-1\" \"bump-3\":\"//emp.bbci.co.uk/emp/bump-3/bump-3\"}; require({ baseUrl: 'http://static.bbci.co.uk/' paths: bbcRequireMap waitSeconds: 30 }); </script> <script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/script/barlesque.js\"></script>\n \n<!--[if IE 6]>\n <script type=\"text/javascript\">\n try {\n document.execCommand(\"BackgroundImageCache\" false true);\n } catch(e) {}\n </script>\n <style type=\"text/css\">\n /* Use filters for IE6 */\n #blq-blocks a {\n background-image: none;\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-blocks_white_alpha.png' sizingMethod='image');\n }\n .blq-masthead-focus #blq-blocks a \n .blq-mast-text-dark #blq-blocks a {\n background-image: none;\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-blocks_grey_alpha.png' sizingMethod='image');\n }\n #blq-nav-search button span {\n background-image: none;\n filter: progid:DXImageTransform.Microsoft.AlphaImageLoader(src='http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5//img/blq-search_grey_alpha.png' sizingMethod='image');\n }\n #blq-nav-search button img {\n position: absolute;\n left: -999em; \n }\n </style>\n<![endif]-->\n<!--[if (IE 7])|(IE 8)>\n <style type=\"text/css\">\n .blq-clearfix {\n display: inline-block;\n }\n </style>\n<![endif]-->\n<script type=\"text/javascript\">\n blq.setEnvironment('live'); if (blq.setLabel) blq.setLabel('searchSuggestion' \"Search\"); if (! /bbc\\.co\\.uk$/i.test(window.location.hostname) ) { document.documentElement.className += ' blq-not-bbc-co-uk'; } </script>\n <script type=\"text/javascript\"> /*<![CDATA[*/ function oqsSurveyManager(w flag) { var defaultThreshold = 0 usePulseThreshold = (flag === 'OFF')? 1 : defaultThreshold activeThreshold; w.oqs = w.oqs || {}; /* we support cookie override for testing */ if ( w.document.cookie.match(/(?:^|; *)ckns_oqs_usePulseThreshold=([\\d.]+)/) ) { activeThreshold = RegExp.$1; } /* we support clientside override */ else if (typeof w.oqs_usePulseThreshold !== 'undefined') { activeThreshold = w.oqs_usePulseThreshold; } else { activeThreshold = usePulseThreshold; } w.oqs.usePulse = (w.Math.random() < activeThreshold); if (!w.oqs.usePulse) { w.document.write('<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/script/vendor/edr.js\"><'+'/script>'); } } oqsSurveyManager(window 'ON'); /*]]>*/ </script> \n <script type=\"text/javascript\">/*<![CDATA[*/ window.istats = (window.istats || {}); (istats.head = function(w d) { w.istats._linkTracked = w.istats._trackingCookie = decodeURIComponent( (d.cookie.match(/\\bsa_labels=([^;]+)/)||[]).pop() || '' ); var host = w.location.host m = host.match(/(bbc(?:\\.co\\.uk|\\.com))$/i); d.cookie = 'sa_labels=; expires=Thu 01 Jan 1970 00:00:01 GMT; domain=' + (m? m[1] : host) + '; path=/'; })(window document); /*]]>*/</script> <!-- BBCDOTCOM template: desktop journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON -->\n \n \n <!-- shared/head -->\n<meta http-equiv=\"imagetoolbar\" content=\"no\" />\n<!--[if !(lt IE 6)]>\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/type.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/global.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"print\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/print.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen and (max-device-width: 976px)\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/mobile.css\" />\n \n<link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/components/components.css\" />\n<![endif]-->\n<!--[if !IE]>-->\n <link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/type.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/global.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"print\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/print.css\" />\n <link rel=\"stylesheet\" type=\"text/css\" media=\"screen and (max-device-width: 976px)\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/mobile.css\" />\n \n<link rel=\"stylesheet\" type=\"text/css\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/components/components.css\" />\n<!--<![endif]-->\n<script type=\"text/javascript\">\n/*<![CDATA[*/\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.dom.get(\"html\").addClass(\"blq-js\")}});\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.ready(function(){if (glow.env.gecko){var gv = glow.env.version.split(\".\");for (var i=gv.length;i<4;i++){gv[i]=0;}if((gv[0]==1 && gv[1]==9 && gv[2]==0)||(gv[0]==1 && gv[1]<9)||(gv[0]<1)){glow.dom.get(\"body\").addClass(\"firefox-older-than-3-5\");}}});}});\nwindow.disableFacebookSDK=true;\nif (window.location.pathname.indexOf('+')>=0){window.disableFacebookSDK=true;}\n/*]]>*/\n</script>\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/locationservices/locator/v4_0/locator.js\"></script>\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/core/3_3_1/bbc_fmtj.js\"></script>\n<script type=\"text/javascript\">\n<!--\n bbc.fmtj.page = {\n serverTime: 1415728570000 \n editionToServe: 'international' \n queryString: null \n section: 'technology' \n sectionPath: '/Technology' \n siteName: 'BBC News' \n siteToServe: 'news' \n siteVersion: 'cream' \n storyId: '26415021' \n assetType: 'story' \n uri: '/news/technology-26415021' \n country: 'il' \n masthead: false \n adKeyword: null \n templateVersion: 'v1_0' \n counterName: 'news.technology.story.26415021.page'\n }\n-->\n</script>\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/common/3_2_1/bbc_fmtj_common.js\"></script>\n<script type=\"text/javascript\">$useMap({map:\"http://news.bbcimg.co.uk/js/map/map_0_0_35.js\"});</script>\n<script type=\"text/javascript\">$loadView(\"0.0\" [\"bbc.fmtj.view\"]);</script>\n<script type=\"text/javascript\">$render(\"livestats-heatmap\");</script>\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/config/apps/4_7_2/bbc_fmtj_config.js\"></script>\n<!-- add Bump3 to the require map -->\n<script type=\"text/javascript\">\n if (typeof bbcRequireMap !== 'undefined' && bbcRequireMap[\"jquery-1.9\"] === undefined && bbcRequireMap[\"jquery-1\"]) {\n var jquery19Path = bbcRequireMap[\"jquery-1\"].replace(/0.(1|2).(1|4)/ '0.3.0').replace(/jquery-1.(5|7).(1|2)/ 'jquery-1.9.1');\n require({\n paths : {\n \"jquery-1.9\": jquery19Path\n }\n });\n }\n if (typeof bbcRequireMap !== 'undefined' && bbcRequireMap[\"swfobject-2\"]) {\n require({\n paths : {\n \"swfobject-2\": bbcRequireMap[\"swfobject-2\"].replace('0.1.3' '0.1.10')\n }\n });\n }\n</script>\n<script type=\"text/javascript\">\n require({\n paths : {\n \"bump-3\": \"http://emp.bbci.co.uk/emp/bump-3/bump-3\"\n }\n });\n</script>\n<!-- load glow and required modules -->\n<script type=\"text/javascript\">\n//<![CDATA[\ngloader.load(['glow' '1' 'glow.dom']);\n//]]>\n</script>\n<!-- pull in our emp code -->\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/av/emp/2_1_8/emp.js\"></script>\n<!-- pull in compatibility.js -->\n<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/av/emp/2_1_8/compatibility.js\"></script>\n<script type=\"text/javascript\">\n//<![CDATA[\n \n \n// set site specific config\nbbc.fmtj.av.emp.configs.push('news');\nrequire(['jquery-1'] function ($) {\n $(document).ready(function () {\n bbc.fmtj.av.emp.loadAll();\n });\n});\n//]]>\n</script>\n<!-- Check for advertising testing -->\n<meta name=\"viewport\" content=\"width = 996\" />\n <!-- shared/head_story -->\n<!-- THESE STYLESHEETS VARY ACCORDING TO PAGE CONTENT --> \n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/layout/story.css\" />\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/3_0_21/cream/hi/shared/story.css\" />\n<!-- js story view -->\n<script type=\"text/javascript\">$loadView(\"0.0\" [\"bbc.fmtj.view.news.story\"]);</script>\n<!-- EMP -->\n<script type=\"text/javascript\" src=\"http://news.bbc.co.uk/js/app/av/emp/compatibility.js\"></script>\n<!-- /EMP -->\n \n <!-- #CREAM hi news international include head.inc -->\n <!-- is suitable for ads adding isadvertise ... -->\n \n \n \n <!-- features_enabled.inc -->\n \n \n<script type=\"text/javascript\">/*<![CDATA[*/if(bbcdotcom===undefined){var bbcdotcom={init:function(a){} objects:function(a){return false} domLoaded:false data:{ads:0 stats:0 statsProvider:null} adverts:{slot:function(b a){} layout:{reset:function(){}}} config:{isActive:function(a){return false}} addLoadEvent:function(a){var b=window.onload;if(typeof window.onload!=\"function\"){window.onload=a}else{window.onload=function(){if(b){b()}a()}}}}}bbcdotcom.objects=function(e f g){var d a c=arguments b=e.split(\".\");if(f===undefined){f=\"valid\"}if(g===undefined){g=window}for(d=0 a=b.length;d<a;d++){if(g[b[d]]===undefined){if(f===\"create\"){g[b[d]]={}}else{return false}}else{if(typeof g[b[d]]===\"function\"){if(typeof c[1]!==\"undefined\"&&c[1]!==null&&g[b[d]](c[1])!==undefined){return g[b[d]](c[1])}else{if(g[b[d]]()!==undefined){return g[b[d]]()}}}}g=g[b[d]]}return g};bbcdotcom.objects(\"bbcdotcom.config\" \"create\");bbcdotcom.config=(function(e c){var b=e a=c d=\"\" f=\"\" g=\"\";return{setAdsEnabled:function(h){b=(b!==0)?h:0} isAdsEnabled:function(){return b} setAnalyticsEnabled:function(h){a=(a!==0)?h:0} isAnalyticsEnabled:function(){return a} setJsPrefix:function(h){d=h} getJsPrefix:function(){return d} setSwfPrefix:function(h){f=h} getSwfPrefix:function(){return f} setCssPrefix:function(h){g=h} getCssPrefix:function(){return g}}}(1 1));bbcdotcom.objects(\"bbcdotcom.stats\" \"create\");if(BBC===undefined){var BBC={}}if(BBC.adverts===undefined){BBC.adverts={setZone:function(){} configure:function(){} write:function(){} show:function(){} isActive:function(){return false} setScriptRoot:function(){} setImgRoot:function(){} getAdvertTag:function(){} getSectionPath:function(){}}};/*]]>*/</script>\n<meta name=\"application-name\" content=\"BBC\"/>\n<meta name=\"msapplication-tooltip\" content=\"Explore the BBC for latest news sport and weather TV &amp; radio schedules and highlights with nature food comedy children's programmes and much more\"/>\n <meta name=\"msapplication-starturl\" content=\"http://www.bbc.com/news/?ocid=global-news-pinned-ie9\"/>\n<meta name=\"msapplication-window\" content=\"width=1024;height=768\"/>\n<meta name=\"msapplication-task\" content=\"name=BBC Home;action-uri=http://www.bbc.com/?ocid=global-homepage-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<meta name=\"msapplication-task\" content=\"name=BBC News;action-uri=http://www.bbc.com/news/?ocid=global-news-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<meta name=\"msapplication-task\" content=\"name=BBC Sport;action-uri=http://www.bbc.com/sport/0/?ocid=global-sport-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<meta name=\"msapplication-task\" content=\"name=BBC Future;action-uri=http://www.bbc.com/future?ocid=global-future-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<meta name=\"msapplication-task\" content=\"name=BBC Travel;action-uri=http://www.bbc.com/travel?ocid=global-travel-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<meta name=\"msapplication-task\" content=\"name=BBC Weather;action-uri=http://www.bbc.co.uk/weather/?ocid=global-weather-pinned-ie9;icon-uri=http://news.bbcimg.co.uk/shared/img/bbccom/favicon_16.ico\" />\n<!-- BBCCOM client-side -->\n<style type=\"text/css\">.bbccom_display_none{display:none;}</style>\n<script type=\"text/javascript\">/*<![CDATA[*/\n if (typeof orb !== 'undefined' && typeof orb.fig === 'function') {\n bbcdotcom.data = {\n a: orb.fig('ad')? 1 : 0 \n b: (0 == orb.fig('uk')) ? 1 : 0 \n c: orb.fig('ap')\n };\n } else {\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://tps.bbc.com/wwscripts/data\"%3E%3C/script%3E'));\n }\n/*]]>*/</script>\n<script type=\"text/javascript\">/*<![CDATA[*/\n if (typeof bbcdotcom.data == 'undefined' || typeof bbcdotcom.data.a == 'undefined' || typeof bbcdotcom.data.b == 'undefined' || typeof bbcdotcom.data.c == 'undefined') {\n bbcdotcom.data = {a:0 b:0 c:0};\n }\n if (bbcdotcom.data.a == 1) {\n document.write(unescape('%3Clink href=\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288/3pt_ads.css\" rel=\"stylesheet\" type=\"text/css\" /%3E'));\n \n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://www.bbc.co.uk/wwscripts/flag\"%3E%3C/script%3E'));\n \n }\n/*]]>*/</script>\n<script type=\"text/javascript\">/*<![CDATA[*/\n if (typeof bbcdotcom.flag == 'undefined' || bbcdotcom.flag.a != 1) {\n bbcdotcom.data.a = 0;\n }\n/*]]>*/</script>\n<!-- BEGIN Krux Control Tag for \"BBC.com News\" -->\n<!-- Source: /snippet/controltag?confid=JZTWpGsM&site=BBC.com%20News&edit=1 -->\n<script class=\"kxct\" data-id=\"JZTWpGsM\" data-timing=\"async\" data-version=\"1.9\" type=\"text/javascript\">\n /*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n window.Krux||((Krux=function(){Krux.q.push(arguments)}).q=[]);\n (function(){\n var k=document.createElement('script');k.type='text/javascript';k.async=true;\n var m src=(m=location.href.match(/\\bkxsrc=([^&]+)/))&&decodeURIComponent(m[1]);\n k.src = /^https?:\\/\\/([a-z0-9_\\-\\.]+\\.)?krxd\\.net(:\\d{1 5})?\\//i.test(src) ? src : src === \"disable\" ? \"\" :\n (location.protocol===\"https:\"?\"https:\":\"http:\")+\"//cdn.krxd.net/controltag?confid=JZTWpGsM\"\n ;\n var s=document.getElementsByTagName('script')[0];s.parentNode.insertBefore(k s);\n }());\n }\n /*]]>*/\n</script>\n<!-- END Krux Controltag -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n window.Krux||((Krux=function(){Krux.q.push(arguments);}).q=[]);\n (function(){\n function retrieve(n){\n var m k='kx'+n;\n if (window.localStorage) {\n return window.localStorage[k] || \"\";\n } else if (navigator.cookieEnabled) {\n m = document.cookie.match(k+'=([^;]*)');\n return (m && unescape(m[1])) || \"\";\n } else {\n return '';\n }\n }\n Krux.user = retrieve('user');\n Krux.segments = retrieve('segs') ? retrieve('segs').split(' ') : [];\n // DFP Premium\n var dfpp = [];\n if (Krux.user) {\n dfpp.push('khost=' + encodeURIComponent(location.hostname));\n dfpp.push('kuid=' + Krux.user);\n }\n for (var i = 0; i < Krux.segments.length; i++ ) {\n dfpp.push('ksg=' + Krux.segments[i]);\n }\n Krux.dfppKeyValues = dfpp.length ? dfpp.join(';') + ';' : '';\n })();\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">/*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/bbccom.js\"%3E%3C/script%3E'));\n }\n/*]]>*/</script>\n<script type=\"text/javascript\">/*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n BBC.adverts.setData(bbcdotcom.data);\n bbcdotcom.config.setAdsEnabled(bbcdotcom.data.a);\n bbcdotcom.config.setAnalyticsEnabled(bbcdotcom.data.b);\n if(typeof bbcdotcom !== 'undefined' && typeof bbcdotcom.survey !== 'undefined' && typeof bbcdotcom.survey.init === 'function') {\n bbcdotcom.survey.init();\n }\n }\n /*\n * Native remove content for UK visitors\n */\n (function() {\n if (bbcdotcom.data.b == 0) {\n var adKeyword = bbcdotcom.objects('bbc.fmtj.page.adKeyword');\n if(adKeyword && adKeyword !== null && typeof adKeyword === 'string' && adKeyword.indexOf('native-') !== -1) {\n document.write('<style >' +\n '#storypage-container .story-body {display:none;}' +\n '#native-uk-disclaimer {border: 2px solid;margin: 8px;padding: 16px;}' +\n '</style>');\n require(['jquery-1'] function($) {\n $(function(){\n /* Native advertising disclaimer */\n $( \".story-body\" ).html('<div id=\"native-uk-disclaimer\">' +\n '<h1>BBC Sport (International version)</h1>' +\n 'We\\'re sorry but this article is not accessible from the UK as it is part of our ' +\n 'international service and is not funded by the license fee.' +\n '</div>');\n $( \".story-body\" ).show();\n });\n });\n }\n }\n }());\n bbcdotcom.objects('page' 'create' bbcdotcom);\n bbcdotcom.page.edition = '(none)';\n bbcdotcom.page.url = '/news/technology-26415021';\n bbcdotcom.page.zoneFile = '3pt_zone_file';\n bbcdotcom.page.http_host = 'www.bbc.com';\n \n \n/*]]>*/</script>\n<script type=\"text/javascript\">/*<![CDATA[*/if(bbcdotcom.data.a == 1){(function(){switch(bbcdotcom.page.url){case\"/\":case\"/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/1/hi/default.stm\":\"/2/hi/default.stm\";break;case\"/sport\":case\"/sport/\":case\"/sport/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/sport1/hi/default.stm\":\"/sport2/hi/default.stm\";break}BBC.adverts.setScriptRoot(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/\");bbcdotcom.config.setJsPrefix(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\");bbcdotcom.config.setSwfPrefix(\"http://news.bbcimg.co.uk/shared/swf/bbccom/0.3.288\");bbcdotcom.config.setCssPrefix(\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288\");BBC.adverts.setImgRoot(\"http://news.bbcimg.co.uk/shared/img/bbccom/\");BBC.adverts.init({domain:bbcdotcom.page.http_host location:bbcdotcom.page.url zoneVersion:bbcdotcom.page.zoneFile zoneReferrer:document.referrer})}());(function(){if(typeof require!==\"undefined\"){require({paths:{bbcdotcom:\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\"}})}})();if(BBC.adverts.getV6Gvl3()&&\"undefined\"!==typeof bbcdotcom.page.bddUseLatestFromTest){document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://wwwpreview.test.newsonline.tc.nca.bbc.co.uk/js/app/bbccom/'+bbcdotcom.latest_version+'/advert.js\"'))}else{if(BBC.adverts.getV6Gvl3()){document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/advert.js\"%3E%3C/script%3E'))}}if(/[?|&]metadata=yes(&|$)/.test(window.location.search)){document.write(\"http://www.test.bbc.com/wwscripts/metadata?bbcdotcom_asset=\"+window.location.hostname+window.location.pathname)};}/*]]>*/</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n document.write(unescape('%3Cscript id=\"gnlAnalyticsEnabled\" class=\"bbccom_display_none\"%3E%3C/script%3E'));\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n document.write(unescape('%3Cscript id=\"continuous-play-enabled\" class=\"bbccom_display_none\"%3E%3C/script%3E'));\n /*]]>*/\n</script>\n \n \n<script type=\"text/javascript\">\n if(typeof BBC.adverts != 'undefined' && typeof BBC.adverts.setPageVersion != 'undefined'){\n BBC.adverts.setPageVersion('(none)');\n }\n</script>\n \n <!-- hi/news/head_last.inc -->\n<script type=\"text/javascript\">\nfunction BetaSite() {\n function setMobileCookie() {\n var d = new Date ();\n d.setDate(d.getDate() + 1);\n d = d.toUTCString();\n window.bbccookies.set('ckps_d=m;domain=.bbc.co.uk;path=/;expires=' + d );\n window.bbccookies.set('ckps_d=m;domain=.bbc.com;path=/;expires=' + d );\n }\n function isValidQueryString() {\n return (window.location.search.indexOf('view=beta') !== -1);\n }\n function isClientCapable() {\n return ('querySelector' in document && 'localStorage' in window && 'addEventListener' in window);\n }\n if (isClientCapable() && isValidQueryString()) {\n setMobileCookie();\n window.location.host = 'm.bbc.co.uk';\n }\n}\nBetaSite();\n</script>\n<link rel=\"stylesheet\" type=\"text/css\" media=\"screen\" href=\"http://news.bbcimg.co.uk/view/1_4_38/cream/hi/news/skin.css\" />\n \n <script type=\"text/javascript\">\n if(bbcdotcom.objects('BBC.adverts.getAdvertTag')) {\n gloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad: function(glow){\n glow.ready(function(){\n if(bbcdotcom.objects('BBC.adverts.getAdvertTag')) {\n var adImageUrl = BBC.adverts.getAdvertTag('printableversionsponsorship' '' 'standardUri');\n if(adImageUrl) {\n if (glow.env.ie ) {\n window.onbeforeprint = function(){\n var printAdvert = glow.dom.get(\"#print-advert\");\n if (printAdvert.get(\"img\").length == 0)\n {\n printAdvert.append('<img src=\"'+adImageUrl+'\" alt=\"\" />');\n }\n };\n }else{\n glow.dom.get(\"head\").append('<style type=\"text/css\">#print-advert {display:none};</style><style type=\"text/css\" media=\"print\">#print-advert::after{content:url('+adImageUrl+');} #print-advert{display:block;overflow:hidden;}</style>');\n }\n }\n }\n });\n }});\n }\n </script>\n \n<link rel=\"apple-touch-icon\" href=\"http://news.bbcimg.co.uk/img/1_0_3/cream/hi/news/iphone.png\"/>\n<script type=\"text/javascript\">\n bbcRequireMap['module/weather'] = '/inc/specials/cream/hi/news/personalisation/weather';\n bbcRequireMap['module/local'] = '/inc/specials/cream/hi/news/personalisation';\n bbcRequireMap['module/localnewsandweather'] = '/inc/specials/cream/hi/news/personalisation/localnewsandweather';\n bbcRequireMap['translation'] = 'module/translations/en-GB';\n require({ baseUrl: 'http://static.bbci.co.uk/' paths: bbcRequireMap waitSeconds: 30 });\n</script>\n<script type=\"text/javascript\">\nrequire(['jquery-1'] function(jQuery) {\n jQuery.ajaxSetup({cache: true})\n});\nrequire([\"jquery-1\" \"istats-1\"] function ($ istats) {\n $(function() {\n istats.track('external' {region: $('.story-body') linkLocation : 'story-body'});\n istats.track('external' {region: $('.story-related .related-links') linkLocation : 'related-links'});\n istats.track('external' {region: $('.story-related .newstracker-list') linkLocation : 'newstracker'});\n });\n});\n</script>\n \n \n \n \n \n \n<!-- CPS COMMENT STATUS: false -->\n <!--Rendered by NOLAPPS571-6006 -->\n <link rel=\"schema.dcterms\" href=\"http://purl.org/dc/terms/\" />\n <meta name=\"DCTERMS.created\" content=\"2014-03-03T10:22:55+00:00\" />\n <meta name=\"DCTERMS.modified\" content=\"2014-03-03T10:22:55+00:00\" />\n </head>\n <!--[if lte IE 6]><body class=\"news ie\"><![endif]-->\n <!--[if IE 7]><body class=\"news ie7\"><![endif]-->\n <!--[if IE 8]><body class=\"news ie8\"><![endif]-->\n <!--[if !IE]>--><body class=\"news\"><!--<![endif]-->\n \n<div class=\"livestats-web-bug\" id=\"livestats-web-bug-tag\"></div>\n<script type=\"text/JavaScript\">\n var referrer = document.referrer;\n var livestatsBug = \"<img alt='' id='livestats' src='http://stats.bbc.co.uk/o.gif?~RS~s~RS~News~RS~t~RS~HighWeb_Story~RS~i~RS~26415021~RS~p~RS~99113~RS~a~RS~International~RS~u~RS~/news/technology-26415021~RS~r~RS~\"+referrer+\"~RS~q~RS~~RS~z~RS~10~RS~'>\";\n document.getElementById('livestats-web-bug-tag').innerHTML = livestatsBug;\n</script>\n<noscript>\n<div class=\"livestats-web-bug\"><img alt=\"\" id=\"livestats\" src=\"http://stats.bbc.co.uk/o.gif?~RS~s~RS~News~RS~t~RS~HighWeb_Story~RS~i~RS~26415021~RS~p~RS~99113~RS~a~RS~International~RS~u~RS~/news/technology-26415021~RS~q~RS~~RS~z~RS~10~RS~\"/></div>\n</noscript>\n \n \n <!-- BBCDOTCOM body first include -->\n \n<script type=\"text/javascript\">BBC.adverts.write(\"wallpaper\" false);</script>\n<script type=\"text/javascript\">/*<![CDATA[*/BBC.adverts.wallpaperBodyTag=document.getElementsByTagName(\"body\");BBC.adverts.wallpaperATag=document.getElementsByTagName(\"a\");if(\"undefined\"!=typeof BBC.adverts.wallpaperATag&&\"undefined\"!=typeof BBC.adverts.wallpaperATag[0]&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag[0]&&-1!==BBC.adverts.wallpaperATag[0].href.indexOf(\"http://ad.doubleclick.net\")){BBC.adverts.wallpaperBodyTag[0].removeChild(BBC.adverts.wallpaperATag[0])};/*]]>*/</script>\n \n \n <!-- BBCDOTCOM body first -->\n <!-- Start SiteCatalyst -->\n <!-- End SiteCatalyst -->\n <!-- ISTATS -->\n \n <script type=\"text/javascript\">/*<![CDATA[*/ bbcFlagpoles_istats = 'ON'; istatsTrackingUrl = '//sa.bbc.co.uk/bbc/bbc/s?name=news.technology.story.26415021.page&cps_asset_id=26415021&page_type=story&section=technology&app_version=6.2.176-RC2&first_pub=2014-03-03T10:22:55+00:00&last_editorial_update=2014-03-03T10:22:55+00:00&title=How+to+get+your+children+coding&comments_box=false&cps_media_type=&cps_media_state=&by_nation=&app_type=web&ml_name=SSI&ml_version=0.23.1&language=en-GB'; if (window.istats_countername) { istatsTrackingUrl = istatsTrackingUrl.replace(/([?&]name=)[^&]+/ig '$1' + istats_countername); } (function() { if ( /\\bIDENTITY=/.test(document.cookie) ) { istatsTrackingUrl += '&bbc_identity=1'; } var c = (document.cookie.match(/\\bckns_policy=(\\d\\d\\d)/)||[]).pop() || ''; istatsTrackingUrl += '&bbc_mc=' + (c? 'ad'+c.charAt(0)+'ps'+c.charAt(1)+'pf'+c.charAt(2) : 'not_set'); if ( /\\bckns_policy=\\d\\d0/.test(document.cookie) ) { istatsTrackingUrl += '&ns_nc=1'; } var screenWidthAndHeight = 'unavailable'; if (window.screen && screen.width && screen.height) { screenWidthAndHeight = screen.width + 'x' + screen.height; } istatsTrackingUrl += ('&screen_resolution=' + screenWidthAndHeight); istatsTrackingUrl += '&blq_s=3.5d&blq_r=3.5&blq_v=journalism-worldwide'; })(); /*]]>*/</script> <!-- Begin iStats 20100118 (UX-CMC 1.1009.3) --> <script type=\"text/javascript\">/*<![CDATA[*/ (function() { window.istats || (istats = {}); var cookieDisabled = (document.cookie.indexOf('NO-SA=') != -1) hasCookieLabels = (document.cookie.indexOf('sa_labels=') != -1) hasClickThrough = /^#sa-(.*?)(?:-sa(.*))?$/.test(document.location.hash) runSitestat = !cookieDisabled && !hasCookieLabels && !hasClickThrough && !istats._linkTracked; if (runSitestat && bbcFlagpoles_istats === 'ON') { sitestat(istatsTrackingUrl); } else { window.ns_pixelUrl = istatsTrackingUrl; /* used by Flash library to track */ } function sitestat(n){var j=document f=j.location b=\"\";if(j.cookie.indexOf(\"st_ux=\")!=-1){var k=j.cookie.split(\";\");var e=\"st_ux\" h=document.domain a=\"/\";if(typeof ns_!=\"undefined\"&&typeof ns_.ux!=\"undefined\"){e=ns_.ux.cName||e;h=ns_.ux.cDomain||h;a=ns_.ux.cPath||a}for(var g=0 f=k.length;g<f;g++){var m=k[g].indexOf(\"st_ux=\");if(m!=-1){b=\"&\"+unescape(k[g].substring(m+6))}}document.cookie=e+\"=; expires=\"+new Date(new Date().getTime()-60).toGMTString()+\"; path=\"+a+\"; domain=\"+h}ns_pixelUrl=n;n=ns_pixelUrl+\"&ns__t=\"+(new Date().getTime())+\"&ns_c=\"+((j.characterSet)?j.characterSet:j.defaultCharset)+\"&ns_ti=\"+escape(j.title)+b+\"&ns_jspageurl=\"+escape(f&&f.href?f.href:j.URL)+\"&ns_referrer=\"+escape(j.referrer);if(n.length>2000&&n.lastIndexOf(\"&\")){n=n.substring(0 n.lastIndexOf(\"&\")+1)+\"ns_cut=\"+n.substring(n.lastIndexOf(\"&\")+1 n.lastIndexOf(\"=\")).substring(0 40)}(j.images)?new Image().src=n:j.write('<p><i'+'mg src=\"'+n+'\" height=\"1\" width=\"1\" alt=\"\" /></p>')}; })(); /*]]>*/</script> <noscript><p style=\"position: absolute; top: -999em;\"><img src=\"//sa.bbc.co.uk/bbc/bbc/s?name=news.technology.story.26415021.page&amp;cps_asset_id=26415021&amp;page_type=story&amp;section=technology&amp;app_version=6.2.176-RC2&amp;first_pub=2014-03-03T10:22:55+00:00&amp;last_editorial_update=2014-03-03T10:22:55+00:00&amp;title=How+to+get+your+children+coding&amp;comments_box=false&amp;cps_media_type=&amp;cps_media_state=&amp;by_nation=&amp;app_type=web&amp;ml_name=SSI&amp;ml_version=0.23.1&amp;language=en-GB&amp;blq_s=3.5d&amp;blq_r=3.5&amp;blq_v=journalism-worldwide\" height=\"1\" width=\"1\" alt=\"\" /></p></noscript> <!-- End iStats (UX-CMC) --> <div id=\"blq-global\"> <noscript> <div id=\"blq-no-js-banner\"> <p>For a better experience on your device try our <a href=\"http://m.bbc.co.uk\">mobile site</a>.</p> </div> </noscript> <div id=\"blq-pre-mast\" xml:lang=\"en-GB\"> <!-- Pre mast --> \n<!-- BBCDOTCOM leaderboard template:client-side journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON showAdAboveBlq: true blqLeaderboardAd: true -->\n </div> </div> <script type=\"text/html\" id=\"blq-bbccookies-tmpl\"><![CDATA[ <div id=\"bbccookies-prompt\" class=\"bbccookies-w\"> <h2> Cookies on the BBC website </h2> <p> We use cookies to ensure that we give you the best experience on our website.<span class=\"bbccookies-international-message\"> We also use cookies to ensure we show you advertising that is relevant to you.</span> If you continue without changing your settings we'll assume that you are happy to receive all cookies on the BBC website. However if you would like to you can <a href=\"/privacy/cookies/managing/cookie-settings.html\">change your cookie settings</a> at any time. </p> <ul> <li id=\"bbccookies-continue\"> <button type=\"button\" id=\"bbccookies-continue-button\">Continue</button> </li> <li id=\"bbccookies-more\"><a href=\"/privacy/cookies/bbc\">Find out more</a></li></ul> </div> ]]></script> <script type=\"text/javascript\">/*<![CDATA[*/ (function(){if(bbccookies._showPrompt()){var i=document b=i.getElementById(\"blq-pre-mast\") f=i.getElementById(\"blq-global\") h=i.getElementById(\"blq-container\") c=i.getElementById(\"blq-bbccookies-tmpl\") a g e;if(b&&i.createElement){a=i.createElement(\"div\");a.id=\"bbccookies\";e=c.innerHTML;e=e.replace(\"<\"+\"![CDATA[\" \"\").replace(\"]]\"+\">\" \"\");a.innerHTML=e;if(f){f.insertBefore(a b)}else{h.insertBefore(a b)}g=i.getElementById(\"bbccookies-continue-button\");g.onclick=function(){a.parentNode.removeChild(a);return false};bbccookies._setPolicy()}}})(); /*]]>*/</script> <div id=\"blq-masthead\" class=\"blq-clearfix blq-mast-bg-transparent-light blq-lang-en-GB blq-ltr\"> <span id=\"blq-mast-background\"><span></span></span> <div id=\"blq-mast\" class=\"blq-rst\"> <div id=\"blq-mast-bar\" class=\"blq-masthead-container blq-journalism-worldwide\"> <div id=\"blq-blocks\"> <a href=\"http://www.bbc.co.uk/\" hreflang=\"en-GB\"> <abbr title=\"British Broadcasting Corporation\" class=\"blq-home\"> <img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blq-blocks_grey_alpha.png\" alt=\"BBC\" width=\"84\" height=\"24\" /> </abbr> </a> </div> <div id=\"blq-acc-links\"> <h2 id=\"page-top\">Accessibility links</h2> <ul> <li><a href=\"#main-content\">Skip to content</a></li> <li><a href=\"#blq-local-nav\">Skip to local navigation</a></li> <li><a href=\"http://www.bbc.co.uk/accessibility/\">Accessibility Help</a></li> </ul> </div> <div id=\"blq-sign-in\" class=\"blq-gel\"> </div> <div id=\"blq-nav\"> <h2>BBC navigation</h2> <ul id=\"blq-nav-main\"> <li id=\"blq-nav-news\"> <a href=\"http://www.bbc.com/news/\">News</a> </li> <li id=\"blq-nav-sport\"> <a href=\"http://www.bbc.co.uk/sport/\">Sport</a> </li> <li id=\"blq-nav-weather\"> <a href=\"http://www.bbc.co.uk/weather/\">Weather</a> </li> <li id=\"blq-nav-earth\"> <a href=\"http://www.bbc.com/earth/\">Earth</a> </li> <li id=\"blq-nav-future\"> <a href=\"http://www.bbc.com/future/\">Future</a> </li> <li id=\"blq-nav-shop\"> <a href=\"http://shop.bbc.com/\">Shop</a> </li> <li id=\"blq-nav-tv\"> <a href=\"http://www.bbc.co.uk/tv/\">TV</a> </li> <li id=\"blq-nav-radio\"> <a href=\"http://www.bbc.co.uk/radio/\">Radio</a> </li> <li id=\"blq-nav-more\"> <a href=\"http://www.bbc.co.uk/a-z/\">More&hellip;</a> </li> </ul> <div id=\"blq-nav-search\"> <form method=\"get\" action=\"http://search.bbc.co.uk/search\" accept-charset=\"utf-8\" id=\"blq-search-form\"> <div> <input type=\"hidden\" name=\"go\" value=\"toolbar\" /> <input type=\"hidden\" value=\"http://www.bbc.com/news/technology-26415021\" name=\"uri\" /> <input type=\"hidden\" name=\"scope\" value=\"news\" /> <label for=\"blq-search-q\" class=\"blq-hide\">Search term:</label> <input id=\"blq-search-q\" type=\"text\" name=\"q\" value=\"\" maxlength=\"128\" /> <button id=\"blq-search-btn\" type=\"submit\"><span><img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blq-search_grey_alpha.png\" width=\"13\" height=\"13\" alt=\"Search\"/></span></button> </div> </form> </div> </div> </div> </div> </div> <div id=\"blq-container-outer\" class=\"blq-journalism-worldwide blq-ltr\" > <div id=\"blq-container\" class=\"blq-lang-en-GB blq-dotcom\"> <div id=\"blq-container-inner\" xml:lang=\"en-GB\"> <div id=\"blq-main\" class=\"blq-clearfix\"> \n \n \n <div class=\"technology has-no-ticker \">\n <div id=\"header-wrapper\">\n \n <h2 id=\"header\">\n <a rel=\"index\" href=\"http://www.bbc.co.uk/news/\"><img alt=\"BBC News\" src=\"http://news.bbcimg.co.uk/img/1_0_3/cream/hi/news/news-blocks.gif\" /></a>\n <span class=\"section-title\">Technology</span>\n </h2>\n \n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-section\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n \n <div id=\"blq-local-nav\">\n <ul id=\"nav\" class=\"nav\">\n \n \n <li class=\"first-child \"><a href=\"/news/\">Home</a></li>\n \n \n <li><a href=\"/news/uk/\">UK</a></li>\n \n \n <li><a href=\"/news/world/africa/\">Africa</a></li>\n \n \n <li><a href=\"/news/world/asia/\">Asia</a></li>\n \n \n <li><a href=\"/news/world/australia/\">Australia</a></li>\n \n \n <li><a href=\"/news/world/europe/\">Europe</a></li>\n \n \n <li><a href=\"/news/world/latin_america/\">Latin America</a></li>\n \n \n <li><a href=\"/news/world/middle_east/\">Mid-East</a></li>\n \n \n <li><a href=\"/news/world/us_and_canada/\">US &amp; Canada</a></li>\n \n \n <li><a href=\"/news/business/\">Business</a></li>\n \n \n <li><a href=\"/news/health/\">Health</a></li>\n \n \n <li><a href=\"/news/science_and_environment/\">Sci/Environment</a></li>\n \n \n <li class=\"selected\"><a href=\"/news/technology/\">Tech</a></li>\n \n \n <li><a href=\"/news/entertainment_and_arts/\">Entertainment</a></li>\n \n \n <li><a href=\"/news/10462520\">Video</a></li>\n </ul> \n \n </div>\n \n </div>\n <!-- START CPS_SITE CLASS: international -->\n <div id=\"content-wrapper\" class=\"international\">\n <div class=\"advert\">\n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-leaderboard\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n </div>\n <div id=\"bbccom_custom_branding\">\n <script type=\"text/javascript\">\n /*<![CDATA[*/\n if(typeof bbcdotcom.objects('bbcdotcom.branding.init') === 'function') {\n bbcdotcom.branding.init(BBC.adverts.getZoneData().zone BBC.adverts.getAdKeyword());\n bbcdotcom.branding.write();\n }\n /*]]>*/\n </script>\n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">\n /*<![CDATA[*/\n $render(\"advert\" \"advert-sponsor-subsection\");\n /*]]>*/\n </script>\n</div>\n</div>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n $render(\"advert-post-script-load\");\n /*]]>*/\n</script>\n \n <!-- START CPS_SITE CLASS: story -->\n <div id=\"main-content\" class=\"story blq-clearfix\">\n <!-- No EWA -->\n \n<div id=\"print-advert\">\n</div>\n<div class=\"layout-block-a\">\n <div class=\"story-body\">\n <span class=\"story-date\">\n <span class=\"date\">3 March 2014</span>\n<span class=\"time-text\">Last updated at </span><span class=\"time\">10:22 GMT</span>\n \n</span>\n <div id=\"page-bookmark-links-head\" class=\"share-help\">\n <h3>Share this page</h3>\n <ul> \n <li class=\"delicious\">\n <a title=\"Post this story to Delicious\" href=\"http://del.icio.us/post?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Delicious</a>\n </li>\n <li class=\"digg\">\n <a title=\"Post this story to Digg\" href=\"http://digg.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Digg</a>\n </li>\n <li class=\"facebook\">\n <a title=\"Post this story to Facebook\" href=\"http://www.facebook.com/sharer.php?u=http://www.bbc.com/news/technology-26415021&amp;t=BBC+News+-+An+hour+to+catch+the+coding+bug\">Facebook</a>\n </li>\n <li class=\"reddit\">\n <a title=\"Post this story to reddit\" href=\"http://reddit.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">reddit</a>\n </li>\n <li class=\"stumbleupon\">\n <a title=\"Post this story to StumbleUpon\" href=\"http://www.stumbleupon.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">StumbleUpon</a>\n </li>\n <li class=\"twitter\">\n <a title=\"Post this story to Twitter\" href=\"http://twitter.com/home?status=BBC+News+-+An+hour+to+catch+the+coding+bug+http://www.bbc.com/news/technology-26415021\">Twitter</a>\n </li>\n <li class=\"email\">\n <a title=\"Email this story\" href=\"http://newsvote.bbc.co.uk/mpapps/pagetools/email/www.bbc.com/news/technology-26415021\">Email</a>\n </li>\n <li class=\"print\">\n <a title=\"Print this story\" href=\"?print=true\">Print</a>\n </li>\n </ul>\n<!-- Social media icons by Paul Annet | http://nicepaul.com/icons -->\n</div>\n<script type=\"text/javascript\"> \n<!--\n$render(\"page-bookmark-links\" \"page-bookmark-links-head\" {\n useForgeShareTools:\"true\" \n position:\"top\" \n site:'News' \n headline:'BBC News - An hour to catch the coding bug' \n storyId:'26415021' \n sectionId:'99113' \n url:'http://www.bbc.com/news/technology-26415021' \n edition:'International'\n}); \n-->\n</script>\n <h1 class=\"story-header\">An hour to catch the coding bug</h1>\n \n \n \n \n \n <span class=\"byline\">\n <span class=\"byline-name\">By Mark Ward</span>\n <span class=\"byline-title\">Technology correspondent BBC News</span>\n </span>\n \n <div class=\"caption full-width\">\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325163_olly009.jpg\" width=\"512\" height=\"320\" alt=\"Child with computer\" />\n <span style=\"width:512px;\">We did our Hour of Code on a lazy Sunday morning</span>\n </div>\n <div class=\"story-feature related narrow\">\n <a class=\"hidden\" href=\"#story_continues_1\">Continue reading the main story</a> <h2>Related Stories</h2>\n <ul class=\"related-links-list\">\n \n \n \n<li class=\"has-icon-boxedwatch \">\n <a class=\"story\" rel=\"published-1389169705927\" href=\"/news/education-25648769\">Computer code lessons at primary school<span class=\"gvl3-icon gvl3-icon-boxedwatch\"> Watch</span></a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1392196197052\" href=\"/news/technology-26150717\">Year of Code - PR fiasco or vital mission?</a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1390468159072\" href=\"/news/technology-25857276\">Are teachers ready for the coding revolution?</a>\n </li>\n </ul>\n </div>\n <p class=\"introduction\" id=\"story_continues_1\">Okay 60 minutes and counting. Here we go.</p>\n <p>I&#039;ve got an hour to convince my kids that programming is for them.</p>\n <p>Well sort of.</p>\n <p>I&#039;m putting my twin 10-year-old boys Toby and Callum through the Hour of Code - a campaign that seeks to ignite an interest in programming - the part we&#039;re doing using specially created web-based exercises. </p>\n <p>The campaign begun in the US has landed in the UK where it also coincides with government calls for as many children as possible to get coding.</p>\n <p>Programming is being pushed because in an ever more technological world it can only be a good thing to give people a peep into what goes on behind the touch screen cash point and website. </p>\n <p>The Hour of Code is supposed to be the start of that journey and I like many other parents feel it&#039;s one my children should be embarking on. I do feel like a clock somewhere is ticking and unless they get started with this essential skill they&#039;ll be left behind. </p>\n <p>&quot;In the future kids are going to be doing programming &quot; said Callum when I asked him why it was worth learning how to code. &quot;We need to learn so we can do stuff with the computer otherwise it will be a blank page and never work.&quot;</p>\n <span class=\"cross-head\">Zombie dance</span>\n <div class=\"caption full-width\">\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325167_hourofcode.jpg\" width=\"512\" height=\"288\" alt=\"Screenshot from the hour of code\" />\n <span style=\"width:512px;\">The coding exercises involve familiar characters such as the Angry Birds</span>\n </div>\n <p>It&#039;s the getting started for both parents and their offspring that the Hour is intended to help with. I&#039;m probably like most parents in that I have no significant qualification in computer science. All I can offer my boys is a lifetime of tinkering backed up over the past 18 months with online courses in Python HTML CSS Javascript and the like. </p>\n <p>There&#039;s good precedents for the value of something like the Hour of Code. I&#039;ve quizzed every chief technology officer (CTO) developer or IT worker I&#039;ve met in the past couple of weeks about what got them started and every one knew exactly the moment they got it. Their eyes lit up as they talked about typing in code listings from magazines working through every Dos command or designing their own blocky 8-bit game characters.</p>\n <p>And finally at the back of my mind are all those statistics about the shortages of skilled IT staff and my hope that if this works then their future career options will be much wider than they would be without this skill.</p>\n <p>So no pressure then.</p>\n <p>Yesterday morning we gave it a go. I was keen for it to be fun rather than feel like school as there&#039;s nothing more likely to turn them off than for it to be sold as good for them. I think we struck the right note of informality - Cal did it in his onesie. </p>\n <p>It went OK no better than that. Pretty good. We worked through all the exercises getting angry birds to mash pigs and zombies to chomp sunflowers. The coding is done by dragging blocks representing different commands into a work area and building the blocks into a tower of coherent instructions.</p>\n <p>The block-building system is based on the Scratch programming language build by MIT&#039;s Mitch Resnick. </p>\n <p>The exercises start easy - just getting an angry bird to hop on to a pig. By the end we were using &quot;If\u2026 else&quot; statements and loops to help a zombie navigate a tricky maze to reach the sunflower.</p>\n <p>This went down well with Callum. &quot;Cool! It&#039;s scanning for a path &quot; he said as the zombie worked its way towards the hapless flower.</p>\n <p>Mistakes were made but we learned from them we debated over which way to make the birds and zombies turn and the time went really fast. </p>\n <p>Toby was surprised to find that this counted as programming.</p>\n <p>&quot;I thought coding was just a lot of people tapping in letter and numbers until they got it right &quot; he said. </p>\n <span class=\"cross-head\">Next steps</span>\n <p>And yet I felt it was a bit too easy. I wanted to make the coding connection to real life more tangible. So as we had about 15 minutes of our Hour of Code left we went further.</p>\n <p>This time we used the MIT App Inventor to build a basic program that would run on the tablets they own. </p>\n <p>The app inventor uses the same &quot;drag the block&quot; method to build a program and following the instructions we had soon created an app that turned anything typed in text into speech. </p>\n <div class=\"caption\">\n <img src=\"http://news.bbcimg.co.uk/media/images/73325000/jpg/_73325169_appinventor.jpg\" width=\"448\" height=\"287\" alt=\"Screenshot from MIT App Inventor\" />\n <span style=\"width:448px;\">The App Inventor uses the same block dragging system as the Hour of Code exercises</span>\n </div>\n <p>We got it working on Cal&#039;s tablet and soon they were getting that gadget to call out lots of phrases. Almost inevitably as they are 10 years old a lot of these phrases involved the words &quot;willy&quot; and &quot;bum&quot;. </p>\n <p>But they had a lot of fun with it and it brought home to them how straight-forward coding can be. In just over an hour they went from being pretty much novices to creating an Android app - a basic one that trades on the expertise of the people that built the coding tools but it was an accomplishment nonetheless.</p>\n <p>Did they catch the coding bug as a result? </p>\n <p>Maybe later in the day they were programming each other after one of their regular wrestling matches left Toby lying exhausted on the floor. Suddenly Cal called out commands such as &quot;roll left&quot; and Toby started obeying even to the point of crashing into the sofa when too many roll commands were given. </p>\n <p>Then Toby had his turn and did the same they even worked out that they had to compensate for the changes in left and right as they rolled. </p>\n <p>So I think that hour started something. Both with them and with me. Building that Android app made me realise that it is straight-forward. That my lack of formal qualifications do not matter as much as I thought. And maybe that&#039;s the point of the hour. Making people realise that it is not scary and difficult. You just have to find an hour and give it a try. You can even do it in your onesie.</p>\n \n </div><!-- / story-body -->\n \n <div>\n <!--Related hypers and stories -->\n <div class=\"story-related\">\n <h2>More on This Story</h2>\n \n \n<style>\n.related-links-list li {\nposition: relative;\n}\n.related-links-list .gvl3-icon {\nposition: absolute;\ntop: 0;\nleft: 0;\n}\n</style>\n<div class=\"see-also\">\n <h3>Related Stories</h3>\n <ul class=\"related-links-list\">\n \n <li class=\" first\">\n \n \n \n<div class=\"has-icon-boxedwatch \">\n <a class=\"story\" rel=\"published-1389169705927\" href=\"/news/education-25648769\">Computer code lessons at primary school<span class=\"gvl3-icon gvl3-icon-boxedwatch\"> Watch</span></a>\n </div>\n \n <span class=\"timestamp\">08 JANUARY 2014</span> \n <span class=\"section\">EDUCATION & FAMILY</span>\n </li>\n <li class=\"\">\n \n \n \n<div>\n <a class=\"story\" rel=\"published-1392196197052\" href=\"/news/technology-26150717\">Year of Code - PR fiasco or vital mission?</a>\n </div>\n \n <span class=\"timestamp\">12 FEBRUARY 2014</span> \n <span class=\"section\">TECHNOLOGY</span>\n </li>\n <li class=\"\">\n \n \n \n<div>\n <a class=\"story\" rel=\"published-1390468159072\" href=\"/news/technology-25857276\">Are teachers ready for the coding revolution?</a>\n </div>\n \n <span class=\"timestamp\">23 JANUARY 2014</span> \n <span class=\"section\">TECHNOLOGY</span>\n </li>\n </ul>\n</div>\n<script type=\"text/javascript\">$render(\"page-see-also\" \"ID\");</script> \n <script type=\"text/javascript\">$render(\"page-newstracker\" \"ID\");</script> \n \n<div class=\"related-internet-links\">\n <h3>Related Internet links</h3>\n <ul class=\"related-links\">\n \n <li class=\"column-1 first-child\">\n <a href=\"http://uk.code.org/\">UK Hour of Code</a>\n </li>\n \n <li class=\"column-1 \">\n <a href=\"http://appinventor.mit.edu/explore/\">MIT App Inventor</a>\n </li>\n \n <li class=\"column-2 \">\n <a href=\"http://scratch.mit.edu/\">MIT Scratch</a>\n </li>\n </ul>\n</div>\n \n <p class=\"disclaimer\">The BBC is not responsible for the content of external Internet sites</p>\n </div>\n<script type=\"text/javascript\">$render(\"page-related-items\" \"ID\");</script>\n </div>\n \n <div class=\"share-body-bottom\">\n <div id=\"page-bookmark-links-foot\" class=\"share-help\">\n <h3>Share this page</h3>\n <ul> \n <li class=\"delicious\">\n <a title=\"Post this story to Delicious\" href=\"http://del.icio.us/post?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Delicious</a>\n </li>\n <li class=\"digg\">\n <a title=\"Post this story to Digg\" href=\"http://digg.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">Digg</a>\n </li>\n <li class=\"facebook\">\n <a title=\"Post this story to Facebook\" href=\"http://www.facebook.com/sharer.php?u=http://www.bbc.com/news/technology-26415021&amp;t=BBC+News+-+An+hour+to+catch+the+coding+bug\">Facebook</a>\n </li>\n <li class=\"reddit\">\n <a title=\"Post this story to reddit\" href=\"http://reddit.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">reddit</a>\n </li>\n <li class=\"stumbleupon\">\n <a title=\"Post this story to StumbleUpon\" href=\"http://www.stumbleupon.com/submit?url=http://www.bbc.com/news/technology-26415021&amp;title=BBC+News+-+An+hour+to+catch+the+coding+bug\">StumbleUpon</a>\n </li>\n <li class=\"twitter\">\n <a title=\"Post this story to Twitter\" href=\"http://twitter.com/home?status=BBC+News+-+An+hour+to+catch+the+coding+bug+http://www.bbc.com/news/technology-26415021\">Twitter</a>\n </li>\n <li class=\"email\">\n <a title=\"Email this story\" href=\"http://newsvote.bbc.co.uk/mpapps/pagetools/email/www.bbc.com/news/technology-26415021\">Email</a>\n </li>\n <li class=\"print\">\n <a title=\"Print this story\" href=\"?print=true\">Print</a>\n </li>\n </ul>\n<!-- Social media icons by Paul Annet | http://nicepaul.com/icons -->\n<div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"page-bookmark-links\");</script>\n</div>\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n</div>\n<script type=\"text/javascript\"> \n<!--\n$render(\"page-bookmark-links\" \"page-bookmark-links-foot\" {\n useForgeShareTools:\"true\" \n position:\"bottom\" \n site:'News' \n headline:'BBC News - An hour to catch the coding bug' \n storyId:'26415021' \n sectionId:'99113' \n url:'http://www.bbc.com/news/technology-26415021' \n edition:'International'\n}); \n-->\n</script>\n </div>\n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-google-adsense\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n <!-- other stories from this section include -->\n \n<div class=\"top-index-stories\">\n <h2 class=\"top-index-stories-header\"><a href=\"/news/technology/\">More Technology stories</a></h2>\n <a href=\"http://feeds.bbci.co.uk/news/technology/rss.xml\" class=\"rss\">RSS</a> \n \n \n \n <!-- Non specific version -->\n \n <ul>\n \n \n \n <li class=\"first-child medium-image\">\n \n \n \n<h3>\n <a class=\"story\" rel=\"published-1415712538863\" href=\"/news/technology-30004299\"><img src=\"http://news.bbcimg.co.uk/media/images/78909000/jpg/_78909837_78909652.jpg\" alt=\"Moffett Federal Airfield aircraft runway\" />Google to lease former Nasa airfield</a>\n </h3>\n \n <p>Google is to pay over \u00a31bn to rent an airfield but little is known about what it plans to do there.</p>\n </li>\n \n \n \n \n <li class=\"column-1\">\n \n \n \n<h3>\n <a class=\"story\" rel=\"published-1415718074539\" href=\"/news/technology-30007505\">Rocket bike sets 207mph speed record</a>\n </h3>\n \n </li>\n \n \n \n \n <li class=\"column-2\">\n \n \n \n<h3>\n <a class=\"story\" rel=\"published-1415726601139\" href=\"/news/technology-30011104\">Spotify defends itself against Swift</a>\n </h3>\n \n </li>\n \n </ul>\n \n</div>\n</div><!-- / layout-block-a -->\n<div class=\"layout-block-b\">\n \n <div class=\"hyperpuff\">\n \n<div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-high\");</script>\n</div>\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n<div id=\"range-top-stories\" class=\"top-stories-range-module\">\n <h2 class=\"top-stories-range-module-header\">Top Stories</h2>\n \n \n \n <!-- Non specific version -->\n \n <ul>\n \n \n \n \n<li class=\" first-child medium-image\">\n <a class=\"story\" rel=\"published-1415721417853\" href=\"/news/world-europe-30011512\"><img src=\"http://news.bbcimg.co.uk/media/images/78919000/jpg/_78919286_71313393.jpg\" alt=\"Shoppers on London&#039;s Regent street (file pic)\" />EU court backs migrant benefit curbs</a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1415713249187\" href=\"/sport/0/football/30004279\">Morocco will not host Cup of Nations</a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1415668776330\" href=\"/news/business-29999289\">Alibaba Singles&#039; Day sales pass $9bn</a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1415723073354\" href=\"/news/world-asia-india-30010012\">India sterilisation deaths inquiry</a>\n </li>\n \n \n \n<li>\n <a class=\"story\" rel=\"published-1415720233032\" href=\"/news/world-asia-30009649\">Anguish at South Korea ferry verdict</a>\n </li>\n </ul>\n \n \n</div>\n<script type=\"text/javascript\">$render(\"range-top-stories\" \"range-top-stories\");</script>\n \n \n<div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-low\");</script>\n</div>\n<script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n <div id=\"features\" class=\"feature-generic\">\n <h2 class=\"features-header\">Features &amp; Analysis</h2>\n \n <ul class=\"feature-main\">\n \n \n \n <!-- Non specific version -->\n \n \n \n <li class=\"medium-image\">\n \n \n \n<h3 class=\" feature-header\">\n <a class=\"story\" rel=\"published-1415665401219\" href=\"/news/magazine-29950844\"><img src=\"http://news.bbcimg.co.uk/media/images/78897000/jpg/_78897876_redheadsindex.jpg\" alt=\"Two women with red hair\" />River republics</a>\n </h3>\n \n <p>Which part of the world has the people with the reddest hair? \n <span id=\"dna-comment-count___CPS__29950844\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\n \n <hr />\n </li>\n \n \n <li class=\"medium-image\">\n \n \n \n<h3 class=\" feature-header\">\n <a class=\"story\" rel=\"published-1415665320977\" href=\"/news/magazine-29934965\"><img src=\"http://news.bbcimg.co.uk/media/images/78826000/jpg/_78826273_83fe5038-f315-4b7a-a36c-880ca55298dc.jpg\" alt=\"St John Battersby\" />Lost youth</a>\n </h3>\n \n <p>How did 14-year-olds end up in the trenches in WW1? \n <span id=\"dna-comment-count___CPS__29934965\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\n \n <hr />\n </li>\n \n \n <li class=\"medium-image\">\n \n \n \n<h3 class=\" feature-header\">\n <a class=\"story\" rel=\"published-1415718709047\" href=\"/news/world-asia-china-30000744\"><img src=\"http://news.bbcimg.co.uk/media/images/78915000/jpg/_78915086_78912435.jpg\" alt=\"Russia&quot;s President Vladimir Putin right puts a shawl on Peng Liyuan left wife of Chinese President Xi Jinping\" />Macho move</a>\n </h3>\n \n <p>How Russian president&#039;s gesture ignited a media firestorm in China \n <span id=\"dna-comment-count___CPS__30000744\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\n \n <hr />\n </li>\n \n \n <li class=\"medium-image\">\n \n \n \n<h3 class=\" feature-header\">\n <a class=\"story\" rel=\"published-1415703100952\" href=\"/news/blogs-magazine-monitor-30002096\"><img src=\"http://news.bbcimg.co.uk/media/images/78906000/jpg/_78906541_coposite.jpg\" alt=\"Back and front of the watch\" />The Supercomplication</a>\n </h3>\n \n <p>The 24 features of the most complicated handmade watch \n <span id=\"dna-comment-count___CPS__30002096\" class=\"gvl3-icon gvl3-icon-comment comment-count\"></span></p>\n \n <hr />\n </li>\n \n \n \n \n </ul>\n </div>\n <script type=\"text/javascript\">$render(\"feature-generic\" \"features\");</script> \n \n<div id=\"most-popular\" class=\"livestats livestats-tabbed tabbed range-most-popular\">\n \n <h2 class=\"livestats-header\">Most Popular</h2>\n \n \n <h3 class=\"tab \"><a href=\"#\">Shared</a></h3>\n \n <div class=\"panel \">\n <ol>\n <li\n class=\"first-child ol1\">\n <a\n href=\"http://www.bbc.co.uk/news/health-30000934\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-1\">1: </span>Doughnut burger busts day's calories</a>\n</li>\n<li\n class=\"ol2\">\n <a\n href=\"http://www.bbc.co.uk/news/uk-30002924\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-2\">2: </span>Gary Glitter denies sex charges</a>\n</li>\n<li\n class=\"ol3\">\n <a\n href=\"http://www.bbc.co.uk/news/entertainment-arts-29984402\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-3\">3: </span>Ant and Dec asked to end 'animal abuse'</a>\n</li>\n<li\n class=\"ol4\">\n <a\n href=\"http://www.bbc.co.uk/news/uk-30000333\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-4\">4: </span>Last poppy laid as UK honours war dead</a>\n</li>\n<li\n class=\"ol5\">\n <a\n href=\"http://www.bbc.co.uk/news/blogs-magazine-monitor-30002096\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-5\">5: </span>The story of the 'most complicated' watch in the world</a>\n</li>\n </ol>\n </div>\n \n <h3 class=\"tab open\"><a href=\"#\">Read</a></h3>\n \n <div class=\"panel open\">\n <ol>\n <li\n class=\"first-child ol1\">\n <a\n href=\"http://www.bbc.co.uk/news/world-asia-china-30000744\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-1\">1: </span>When Singles Day Putin and China's first lady collided</a>\n</li>\n<li\n class=\"ol2\">\n <a\n href=\"http://www.bbc.co.uk/news/world-europe-30011512\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-2\">2: </span>EU court backs migrant benefit curbs</a>\n</li>\n<li\n class=\"ol3\">\n <a\n href=\"http://www.bbc.co.uk/news/magazine-29950844\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-3\">3: </span>The people with the reddest hair in the world</a>\n</li>\n<li\n class=\"ol4\">\n <a\n href=\"http://www.bbc.co.uk/news/entertainment-arts-30002070\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-4\">4: </span>Woman 'maces man' at Turner screening</a>\n</li>\n<li\n class=\"ol5\">\n <a\n href=\"http://www.bbc.co.uk/news/entertainment-arts-15328583\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-5\">5: </span>Van Gogh 'did not kill himself'</a>\n</li>\n<li\n class=\"ol6\">\n <a\n href=\"http://www.bbc.co.uk/news/blogs-magazine-monitor-30002096\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-6\">6: </span>The story of the 'most complicated' watch in the world</a>\n</li>\n<li\n class=\"ol7\">\n <a\n href=\"http://www.bbc.co.uk/news/entertainment-arts-30011174\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-7\">7: </span>Tarantino 'to retire' after 10th film</a>\n</li>\n<li\n class=\"ol8\">\n <a\n href=\"http://www.bbc.co.uk/news/business-29999289\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-8\">8: </span>Alibaba Singles' Day sales pass $9bn</a>\n</li>\n<li\n class=\"ol9\">\n <a\n href=\"http://www.bbc.co.uk/news/world-africa-30006066\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-9\">9: </span>Nigeria fury over US arms refusal</a>\n</li>\n<li\n class=\"ol10\">\n <a\n href=\"http://www.bbc.co.uk/news/uk-30000333\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-10\">10: </span>Last poppy laid as UK honours war dead</a>\n</li>\n </ol>\n </div>\n \n <h3 class=\"tab \"><a href=\"#\">Video/Audio</a></h3>\n \n <div class=\"panel \">\n <ol>\n <li\n class=\"has-icon-watch ol2\">\n <a\n href=\"http://www.bbc.co.uk/news/world-africa-30011166\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-2\">2: </span>'Revenge porn' victim faces arrest<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol3\">\n <a\n href=\"http://www.bbc.co.uk/news/world-asia-30003673\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-3\">3: </span>Putin rebuffed by China's First Lady<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol4\">\n <a\n href=\"http://www.bbc.co.uk/news/video_and_audio/\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-4\">4: </span>One-minute World News<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol5\">\n <a\n href=\"http://www.bbc.co.uk/news/entertainment-arts-29999639\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-5\">5: </span>The Who celebrate 50 years<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol6\">\n <a\n href=\"http://www.bbc.co.uk/news/world-latin-america-29946423\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-6\">6: </span>Mexico student who escaped 'massacre'<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol7\">\n <a\n href=\"http://www.bbc.co.uk/news/world-europe-30004314\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-7\">7: </span>How the world marked Armistice Day<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol8\">\n <a\n href=\"http://www.bbc.co.uk/news/world-europe-30000547\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-8\">8: </span>Veterans attend Menin Gate ceremony<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol9\">\n <a\n href=\"http://www.bbc.co.uk/news/world-europe-30003674\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-9\">9: </span>Is this the ultimate pushbike?<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n<li\n class=\"has-icon-watch ol10\">\n <a\n href=\"http://www.bbc.co.uk/news/uk-29917406\"\n class=\"story\">\n <span\n class=\"livestats-icon livestats-10\">10: </span>Bird's-eye view of Gatwick runway plans<span\n class=\"gvl3-icon gvl3-icon-watch\"> Watch</span></a>\n</li>\n </ol>\n </div>\n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"range-most-popular\" \"most-popular\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n</div>\n<script type=\"text/javascript\">$render(\"most-popular\" \"most-popular\");</script>\n </div>\n \n \n \n <div class=\"hyperpuff\">\n <div id=\"include-group-for-hypers\" class=\"include-only special-event-promotion-best\">\n \n <div id=\"from-bbc-future\" class=\"\">\n <h2><span>BBC Future</span></h2>\n <div id=\"\" class=\"story\">\n <a class=\"story-image\" href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">\n <img src=\"http://ichef.bbci.co.uk/wwfeatures/336_170/images/live/p0/2b/fc/p02bfccc.jpg\" alt=\"(Jason Cammisa)\" width=\"336\" height=\"170\"/>\n </a>\n <div class=\"text-container\">\n <h3 class=\"headline\" style=\"line-height: 24px;\"><a href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">A revolution on two wheels?</a></h3>\n <span class=\"summary\" style=\"font-size: 13px\">The shape of city cars to come <a href=\"http://www.bbc.com/future/story/20141110-a-revolution-on-two-wheels\">Read more...</a></span>\n </div>\n </div>\n </div>\n</div>\n<script type=\"text/javascript\">$render(\"include-group-for-hypers\" \"include-group-for-hypers\");</script> \n </div>\n \n \n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-partner-button\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n \n \n <div class=\"hyperpuff\">\n \n \n<div id=\"container-programme-promotion\" class=\"container-programme-promotion\">\n <h2 class=\"programmes-header\">Programmes</h2>\n \n \n \n<ul class=\"programme-breakout\">\n \n \n \n <li class=\"first-child large-image\"> \n \n \n \n<h3 class=\" programme-header\">\n <a class=\"story\" rel=\"published-1415708859693\" href=\"http://www.bbc.co.uk/programmes/p02bkv3r\"><img src=\"http://news.bbcimg.co.uk/media/images/78912000/jpg/_78912628_webber1024.jpg\" alt=\"Former F1 driver Mark Webber\" />Extra Time<span class=\"gvl3-icon-wrapper\"><span class=\"gvl3-icon gvl3-icon-invert-watch\"> Watch</span></span></a>\n </h3>\n <p>Mark Webber on dealing with the politics and &#039;shallow relationships&#039; of Formula 1</p>\n \n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-sponsor-module\" \"programme-breakout\" \"extra-time\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n </li>\n</ul> \n </div>\n<script type=\"text/javascript\">$render(\"container-programmes-promotion\" \"container-programme-promotion\");</script>\n \n </div>\n \n \n \n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-native-side\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n <div class=\"bbccom_advert_placeholder\">\n <script type=\"text/javascript\">$render(\"advert\" \"advert-mpu-bottom\");</script>\n </div>\n <script type=\"text/javascript\">$render(\"advert-post-script-load\");</script>\n \n \n</div>\n <!-- END #MAIN-CONTENT & CPS_ASSET_TYPE CLASS: story -->\n </div>\n<!-- END CPS_AUDIENCE CLASS: international -->\n \n</div> \n<div id=\"related-services\" class=\"footer\">\n <div id=\"news-services\">\n <h2>Services</h2>\n <ul>\n <li id=\"service-mobile\" class=\"first-child\"><a href=\"/news/10628994\"><span class=\"gvl3-mobile-icon-large services-icon\">&nbsp;</span>Mobile</a></li>\n <li id=\"service-feeds\"><a href=\"/news/help-17655000\"><span class=\"gvl3-connected-tv-icon-large services-icon\">&nbsp;</span>Connected TV</a></li>\n <li id=\"service-podcast\"><a href=\"/news/10628494\"><span class=\"gvl3-feeds-icon-large services-icon\">&nbsp;</span>News feeds</a></li>\n <li id=\"service-alerts\"><a href=\"/news/10628323\"><span class=\"gvl3-alerts-icon-large services-icon\">&nbsp;</span>Alerts</a></li>\n <li id=\"service-email-news\"><a href=\"/news/help/16617948\"><span class=\"gvl3-email-icon-large services-icon\">&nbsp;</span>E-mail news</a></li>\n </ul> \n </div>\n <div id=\"news-related-sites\">\n <h2><a href=\"/news/19888761\">About BBC News</a></h2>\n <ul>\n <li class=\"column-1\"><a href=\"/news/blogs/the_editors/\">Editors' blog</a></li>\n <li class=\"column-1\"><a href=\"/journalism/\">BBC College of Journalism</a></li>\n <li class=\"column-1\"><a href=\"/news/10621655\">News sources</a></li>\n <li class=\"column-1\"><a href=\"/mediaaction/\">Media Action</a></li>\n <li class=\"column-1\"><a href=\"/editorialguidelines/\">Editorial Guidelines</a></li>\n </ul>\n </div>\n</div>\n</div><!-- close technology -->\n \n \n </div> <!--[if IE 6]> <div id=\"blq-ie6-upgrade\"> <p> <span>You're using the Internet Explorer 6 browser to view the BBC website. Our site will work much better if you change to a more modern browser. It's free quick and easy.</span> <a href=\"http://www.browserchoice.eu/\">Find out more <span>about upgrading your browser</span> here&hellip;</a> </p> </div> <![endif]--> <div id=\"blq-foot\" xml:lang=\"en-GB\" class=\"blq-rst blq-clearfix blq-foot-transparent blq-foot-text-dark\"> <div id=\"blq-footlinks\"> <h2 class=\"blq-hide\">BBC links</h2> <ul> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"/news/mobile/\" id=\"blq-footer-mobile\">Mobile site</a></li><li><a href=\"http://www.bbc.co.uk/terms/\">Terms of Use</a></li><li><a href=\"http://www.bbc.co.uk/aboutthebbc/\">About the BBC</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://advertising.bbcworldwide.com\">Advertise With Us</a></li><li><a href=\"http://www.bbc.co.uk/privacy/\">Privacy</a></li><li><a href=\"http://www.bbc.co.uk/accessibility/\">Accessibility Help</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://www.bbc.co.uk/privacy/cookies/international/\">Ad Choices</a></li><li><a href=\"http://www.bbc.co.uk/privacy/cookies/about\">Cookies</a></li><li><a href=\"/news/21323537\">Contact the BBC</a></li> </ul> </li> <li class=\"blq-footlinks-row\"> <ul class=\"blq-footlinks-row-list\"> <li><a href=\"http://www.bbc.co.uk/guidance/\">Parental Guidance</a></li> </ul> </li> </ul> <script type=\"text/javascript\">/*<![CDATA[*/ (function() { var mLink = document.getElementById('blq-footer-mobile') stick = function() { var d = new Date (); d.setYear(d.getFullYear() + 1); d = d.toUTCString(); window.bbccookies.set('ckps_d=m;domain=.bbc.co.uk;path=/;expires=' + d ); window.bbccookies.set('ckps_d=m;domain=.bbc.com;path=/;expires=' + d ); }; if (mLink) { if (mLink.addEventListener) { mLink.addEventListener('click' stick false); } else if (mLink.attachEvent) { mLink.attachEvent('onclick' stick); } } })(); /*]]>*/</script> </div> <div id=\"blq-foot-blocks\" class=\"blq-footer-image-dark\"><img src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/img/blocks/dark.png\" width=\"84\" height=\"24\" alt=\"BBC\" /></div> <p id=\"blq-disclaim\"><span id=\"blq-copy\">BBC &copy; 2014</span> <a href=\"http://www.bbc.co.uk/help/web/links/\">The BBC is not responsible for the content of external sites. Read more.</a></p> <div id=\"blq-obit\"><p><strong>This page is best viewed in an up-to-date web browser with style sheets (CSS) enabled. While you will be able to view the content of this page in your current browser you will not be able to get the full visual experience. Please consider upgrading your browser software or enabling style sheets (CSS) if you are able to do so.</strong></p></div> </div> </div> \n<!-- BBCDOTCOM analytics template:client-side journalismVariant: true ipIsAdvertiseCombined: true adsEnabled: false flagpole: ON -->\n <!-- BBCCOM analytics client-side -->\n<div id=\"bbccomWebBug\" class=\"bbccomWebBug\"></div>\n<!-- START: BBCCOM-5810: SiteCatalyst desktop vs responsive tag comparison -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && window.location.pathname.indexOf('/news/business') !== -1) {\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/config.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/utils.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/sections.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/adverts/keyValues.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/analytics.js\">\\x3C/script>');\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && window.location.pathname.indexOf('/news/business') !== -1) {\n if (bbcdotcom && bbcdotcom.analytics) {\n bbcdotcom.analytics.init();\n bbcdotcom.analytics.setSuite('bbcresponsivedev');\n bbcdotcom.analytics.page();\n }\n }\n /*]]>*/\n</script>\n<!-- END: BBCCOM-5810: SiteCatalyst desktop vs responsive tag comparison -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n if(typeof(bbcdotcom) != 'undefined' && typeof(bbcdotcom.stats) != 'undefined') {\n bbcdotcom.stats.contentType = \"HTML\";\n }\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://js.revsci.net/gateway/gw.js?csid=J08781\"%3E%3C/script%3E'));\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n DM_tag();\n }\n /*]]>*/\n</script>\n<!-- Start SiteCatalyst -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && typeof scw === 'undefined') {\n BBC.journalismVariant = true;\n \n var s_account = \"bbcwglobalprod\";\n \n \n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/s_code.js\"%3E%3C/script%3E'));\n \n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && BBC.journalismVariant) {\n var s_code=scw.t();if(s_code)document.write(s_code)\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && BBC.journalismVariant) {\n if(navigator.appVersion.indexOf('MSIE')>=0)document.write(unescape('%3C')+'\\!-'+'-')\n }\n /*]]>*/\n</script>\n<!-- End SiteCatalyst -->\n<!-- Start comScore Tag -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n document.write(unescape(\"%3Cscript src='\" + (document.location.protocol == \"https:\" ? \"https://sb\" : \"http://b\") + \".scorecardresearch.com/beacon.js' %3E%3C/script%3E\"));\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n COMSCORE.beacon({\n c1:2 \n c2:\"6035051\" \n c3:\"\" \n c4:\"www.bbc.com/news/technology-26415021\" \n c5:\"\" \n c6:\"\" \n c15:\"\"\n });\n }\n /*]]>*/\n</script>\n<!-- End comScore Tag -->\n<!-- Begin Sitestat4 code -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('sitestat')) {\n function sitestat(ns_l){ns_l+='&amp;ns__t='+(new Date()).getTime();\n ns_0=document.referrer;\n ns_0=(ns_0.lastIndexOf('/')==ns_0.length-1)?ns_0.substring(ns_0.lastIndexOf('/') 0):ns_0;\n if(ns_0.length>0)ns_l+='&amp;ns_referrer='+escape(ns_0);\n if(document.images){ns_1=new Image();ns_1.src=ns_l;}else\n document.write('<img src=\"'+ns_l+'\" width=\"1\" height=\"1\" alt=\"\">');}\n sitestat(\"http://nl.sitestat.com/adfab/bbc/s?teller\");\n }\n /*]]>*/\n</script>\n<!-- End Sitestat4 code -->\n<!-- Start Nielsen Online SiteCensus V6.0 -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-au')) {\n <!-- COPYRIGHT 2009 Nielsen Online -->\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"' + ('https:' == document.location.protocol ? 'https:' : 'http:') + '//secure-au.imrworldwide.com/v60.js\"%3E%3C/script%3E'));\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-au')) {\n <!-- Start Nielsen Online SiteCensus V6.0 Part 2 -->\n nol_t({cid:\"au-bbc\" content:\"0\" server:\"secure-au\"}).record().post();\n <!-- End Nielsen Online SiteCensus V6.0 Part 2 -->\n }\n /*]]>*/\n</script>\n<!-- End Nielsen Online SiteCensus V6.0 -->\n<!-- Start Nielsen Online SiteCensus V6.0 -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-nz')) {\n <!-- COPYRIGHT 2009 Nielsen Online -->\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"' + ('https:' == document.location.protocol ? 'https:' : 'http:') + '//secure-nz.imrworldwide.com/v60.js\"%3E%3C/script%3E'));\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-nz')) {\n nol_t({cid:\"nz-bbc\" content:\"0\" server:\"secure-nz\"}).record().post();\n }\n /*]]>*/\n</script>\n<!-- End Nielsen Online SiteCensus V6.0 -->\n<!-- Start Nielsen Online SiteCensus V6.0 -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-us')) {\n <!-- COPYRIGHT 2010 Nielsen Online -->\n (function () {\n var d = new Image(1 1);\n d.onerror = d.onload = function () {\n d.onerror = d.onload = null;\n };\n d.src = [('https:' == document.location.protocol ? 'https:' : 'http:') + \"//secure-us.imrworldwide.com/cgi-bin/m?ci=us-804789h&amp;cg=0&amp;cc=1&amp;si=\" escape(window.location.href) \"&amp;rp=\" \n escape(document.referrer) \"&amp;ts=compact&amp;rnd=\" (new Date()).getTime()].join('');\n })();\n }\n /*]]>*/\n</script>\n<!-- End Nielsen Online SiteCensus V6.0 -->\n<!-- Effective Measure BBCCOM-1195 -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n (function() {\n var em = document.createElement('script'); em.type = 'text/javascript'; em.async = true;\n em.src = ('https:' == document.location.protocol ? 'https://me-ssl' : 'http://me-cdn') + '.effectivemeasure.net/em.js';\n var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(em s);\n })();\n }\n /*]]>*/\n</script>\n<!-- End Effective Measure -->\n<!-- AGOF BBCCOM-1271 -->\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('agof')) {\n var ivwcode=\"default\";\n if(typeof BBC != 'undefined' && typeof BBC.adverts != 'undefined'){\n ivwcode = BBC.adverts.getSectionPath();\n }\n var IVW=\"http://bbc.ivwbox.de/cgi-bin/ivw/CP/\"+ivwcode+\";\";\n document.write(\"<img src=\\\"\"+IVW+\"?r=\"+escape(document.referrer)+\"&d=\"+(Math.random()*100000)+\"\\\" width=\\\"1\\\" height=\\\"1\\\" alt=\\\"szmtag\\\" />\");\n }\n /*]]>*/\n</script>\n<script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('agof')) {\n var szmvars=\"bbc//CP/\"+ivwcode;\n document.write(unescape('%3Cscript src=\"http://bbc.ivwbox.de/2004/01/survey.js\" type=\"text/javascript\"%3E%3C/script%3E'));\n }\n /*]]>*/\n</script>\n<!-- End AGOF -->\n <!-- BBCCOM-5234 Outbrain Tracking -->\n \n <div class=\"OUTBRAIN\" data-src=\"http://www.bbc.com/news/technology-26415021\" data-widget-id=\"TR_1\" data-ob-template=\"BBC.com/News\"></div>\n <script type=\"text/javascript\">\n /*<![CDATA[*/\n if (BBC.adverts.isActive('ads') && BBC.adverts.isActive('analytics')) {\n document.write(unescape('%3Cscript src=\"http://widgets.outbrain.com/outbrain.js\" type=\"text/javascript\"%3E%3C/script%3E'));\n }\n /*]]>*/\n </script>\n \n \n<!-- BBCDOTCOM Body Last -->\n </div> </div> <script type=\"text/javascript\"> if (typeof require !== 'undefined') { require(['istats-1'] function(istats){ istats.track('external' { region: document.getElementById('blq-main') }); istats.track('download' { region: document.getElementById('blq-main') }); }); } </script> <script type=\"text/html\" id=\"blq-panel-template-promo\"><![CDATA[ <div id=\"blq-panel-promo\" class=\"blq-masthead-container\"></div> ]]></script> <script type=\"text/html\" id=\"blq-panel-template-more\"><![CDATA[ <div id=\"blq-panel-more\" class=\"blq-masthead-container blq-clearfix\" xml:lang=\"en-GB\" dir=\"ltr\"> <div class=\"blq-panel-container panel-paneltype-more\"> <div class=\"panel-header\"> <h2> <a href=\"http://www.bbc.co.uk/a-z/\"> More&hellip; </a> </h2> <a href=\"http://www.bbc.co.uk/a-z/\" class=\"panel-header-links panel-header-link\">Full A-Z<span class=\"blq-hide\"> of BBC sites</span></a> </div> <div class=\"panel-component panel-links\"> <ul> <li> <a href=\"http://www.bbc.co.uk/cbbc/\" >CBBC</a> </li> <li> <a href=\"http://www.bbc.co.uk/cbeebies/\" >CBeebies</a> </li> <li> <a href=\"http://www.bbc.com/capital\" >Capital</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/food/\" >Food</a> </li> <li> <a href=\"http://www.bbc.co.uk/history/\" >History</a> </li> <li> <a href=\"http://www.bbc.co.uk/comedy/\" >Comedy</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/music/\" >Music</a> </li> <li> <a href=\"http://www.bbc.co.uk/science/\" >Science</a> </li> <li> <a href=\"http://www.bbc.co.uk/learning/\" >Learning</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/local/\" >Local</a> </li> <li> <a href=\"http://www.bbc.com/travel/\" >Travel</a> </li> <li> <a href=\"http://www.bbc.co.uk/nature/\" >Nature</a> </li> </ul> </div> </div> ]]></script> \n \n<!-- shared/foot -->\n<script type=\"text/javascript\">\n bbc.fmtj.common.removeNoScript({});\n bbc.fmtj.common.tabs.createTabs({});\n</script>\n<!-- hi/news/foot.inc -->\n<!-- Chartbeat Web Analytics code - start -->\n<script type=\"text/javascript\">\nvar _sf_async_config={};\n/** CONFIGURATION START **/\n_sf_async_config.uid = 50924; /** Chartbeat BBC id **/\n_sf_async_config.domain = \"bbc.co.uk\";/** BBC domain being tracked **/\n_sf_async_config.sections = \"s-news - technology\";\n_sf_async_config.region = \"international\";\n <!-- all multi-edition pages that are not indexes eg. story pages need the title -->\n var storyTitle = \"BBC+News+-+An+hour+to+catch+the+coding+bug\".replace(new RegExp('\\\\+' 'gi') ' ');//remove the plus signs\n storyTitle = decodeURIComponent(storyTitle.replace(\"BBC News - \" \"\"));//remove the sub-string 'BBC News' and convert utf-8 chars to html\n _sf_async_config.title = storyTitle;\n/** CONFIGURATION END **/\n(function(){\n var noCookies = true;\n if (\"object\" === typeof bbccookies && typeof bbccookies.readPolicy == 'function') {\n noCookies = !bbccookies.readPolicy().performance;\n }\n _sf_async_config.noCookies = noCookies;\n function loadChartbeat() {\n window._sf_endpt=(new Date()).getTime();\n var e = document.createElement(\"script\");\n e.setAttribute(\"language\" \"javascript\");\n e.setAttribute(\"type\" \"text/javascript\");\n e.setAttribute('src' '/inc/specials/cream/hi/news/chartbeat/chartbeat.js');\n document.body.appendChild(e);\n }\n var oldonload = window.onload;\n window.onload = (typeof window.onload != \"function\") ?\n loadChartbeat : function() { oldonload(); loadChartbeat(); };\n})();\n</script>\n<!-- Chartbeat Web Analytics code - end -->\n<!-- shared/foot_story -->\n<!-- #CREAM hi news international foot.inc -->\n \n</body>\n</html>\n\n"
      }
     ],
     "prompt_number": 8
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "We give up -- to much noise in this page! How can we get just the text out of this?\n\nLet us use existing libraries.\n\nThe first we try is called BeautifulSoup.  It is a library to parse \"noisy\" HTML in general.  \nOnce parsed, the HTML string can be navigated in a convenient manner.\nMake sure you install beautifulsoup4 by running:\n\n% pip install beautifulsoup4\n\nWe can then run this:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "from bs4 import BeautifulSoup\n\ndef clean_html1(html):\n    soup = BeautifulSoup(html)\n    return soup.get_text()",
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 10
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Let us try this version of clean_html:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "print clean_html1(html)",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "\n\n\n\n\n\n\n\n\n\n\nBBC News - An hour to catch the coding bug\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\nvar _sf_startpt=(new Date()).getTime()\n\n\n\n\n\n\n\n /*<![CDATA[*/\n window.bbcredirection = {\n \n device: true \n geo: true\n \n }\n /*]]>*/\n \n\n\n\n\n    \nwindow.orb = window.orb || {};\n/*<![CDATA[*/\n(function(){window.fig=window.fig||{};window.fig.manager={include:function(a){a=a||window;var e=a.document g=e.cookie b=g.match(/(?:^|; ?)ckns_orb_fig=([^;]+)/);if(!b&&g.indexOf(\"ckns_orb_nofig=1\")>-1){this.setFig(a {no:1})}else{if(b){b=this.deserialise(decodeURIComponent(RegExp.$1));this.setFig(a b)}e.write('<script src=\"https://ssl.bbc.co.uk/frameworks/fig/1/fig.js\"><'+\"/script>\")}} confirm:function(a){a=a||window;if(a.orb&&a.orb.fig&&a.orb.fig(\"no\")){this.setNoFigCookie(a)}if(a.orb===undefined||a.orb.fig===undefined){this.setFig(a {no:1});this.setNoFigCookie(a)}} setNoFigCookie:function(a){a.document.cookie=\"ckns_orb_nofig=1; expires=\"+new Date(new Date().getTime()+1000*60*10).toGMTString()+\";\"} setFig:function(a b){(function(){var c=b;a.orb=a.orb||{};a.orb.fig=function(d){return(arguments.length)?c[d]:c}})()} deserialise:function(b){var a={};b.replace(/([a-z]{2}):([0-9]+)/g function(){a[RegExp.$1]=+RegExp.$2});return a}}})();fig.manager.include();/*]]>*/\n fig.manager.confirm(); \n /*<![CDATA[*/ (function(undefined){if(!window.bbc){window.bbc={}}var ROLLING_PERIOD_DAYS=30;window.bbc.Mandolin=function(id segments opts){var now=new Date().getTime() storedItem DEFAULT_START=now DEFAULT_RATE=1 COOKIE_NAME=\"ckpf_mandolin\";opts=opts||{};this._id=id;this._segmentSet=segments;this._store=new window.window.bbc.Mandolin.Storage(COOKIE_NAME);this._opts=opts;this._rate=(opts.rate!==undefined)?+opts.rate:DEFAULT_RATE;this._startTs=(opts.start!==undefined)?new Date(opts.start).getTime():new Date(DEFAULT_START).getTime();this._endTs=(opts.end!==undefined)?new Date(opts.end).getTime():daysFromNow(ROLLING_PERIOD_DAYS);this._signupEndTs=(opts.signupEnd!==undefined)?new Date(opts.signupEnd).getTime():this._endTs;this._segment=null;if(typeof id!==\"string\"){throw new Error(\"Invalid Argument: id must be defined and be a string\")}if(Object.prototype.toString.call(segments)!==\"[object Array]\"){throw new Error(\"Invalid Argument: Segments are required.\")}if(opts.rate!==undefined&&(opts.rate<0||opts.rate>1)){throw new Error(\"Invalid Argument: Rate must be between 0 and 1.\")}if(this._startTs>this._endTs){throw new Error(\"Invalid Argument: end date must occur after start date.\")}if(!(this._startTs<this._signupEndTs&&this._signupEndTs<=this._endTs)){throw new Error(\"Invalid Argument: SignupEnd must be between start and end date\")}removeExpired.call(this now);var overrides=window.bbccookies.get().match(/ckns_mandolin_setSegments=([^;]+)/);if(overrides!==null){eval(\"overrides = \"+decodeURIComponent(RegExp.$1)+\";\");if(overrides[this._id]&&this._segmentSet.indexOf(overrides[this._id])==-1){throw new Error(\"Invalid Override: overridden segment should exist in segments array\")}}if(overrides!==null&&overrides[this._id]){this._segment=overrides[this._id]}else{if((storedItem=this._store.getItem(this._id))){this._segment=storedItem.segment}else{if(this._startTs<=now&&now<this._signupEndTs&&now<=this._endTs&&this._store.isEnabled()===true){this._segment=pick(segments this._rate);if(opts.end===undefined){this._store.setItem(this._id {segment:this._segment})}else{this._store.setItem(this._id {segment:this._segment end:this._endTs})}log.call(this \"mandolin_segment\")}}}log.call(this \"mandolin_view\")};window.bbc.Mandolin.prototype.getSegment=function(){return this._segment};function log(actionType params){var that=this;require([\"istats-1\"] function(istats){istats.log(actionType that._id+\":\"+that._segment params?params:{})})}function removeExpired(expires){var items=this._store.getItems() expiresInt=+expires;for(var key in items){if(items[key].end!==undefined&&+items[key].end<expiresInt){this._store.removeItem(key)}}}function getLastExpirationDate(data){var winner=0 rollingExpire=daysFromNow(ROLLING_PERIOD_DAYS);for(var key in data){if(data[key].end===undefined&&rollingExpire>winner){winner=rollingExpire}else{if(+data[key].end>winner){winner=+data[key].end}}}return(winner)?new Date(winner):new Date(rollingExpire)}window.bbc.Mandolin.prototype.log=function(params){log.call(this \"mandolin_log\" params)};window.bbc.Mandolin.prototype.convert=function(params){log.call(this \"mandolin_convert\" params);this.convert=function(){}};function daysFromNow(n){var endDate;endDate=new Date().getTime()+(n*60*60*24)*1000;return endDate}function pick(segments rate){var picked min=0 max=segments.length-1;if(typeof rate===\"number\"&&Math.random()>rate){return null}do{picked=Math.floor(Math.random()*(max-min+1))+min}while(picked>max);return segments[picked]}window.bbc.Mandolin.Storage=function(name){validateCookieName(name);this._cookieName=name;this._isEnabled=(bbccookies.isAllowed(this._cookieName)===true&&bbccookies.cookiesEnabled()===true)};window.bbc.Mandolin.Storage.prototype.setItem=function(key value){var storeData=this.getItems();storeData[key]=value;this.save(storeData);return value};window.bbc.Mandolin.Storage.prototype.isEnabled=function(){return this._isEnabled};window.bbc.Mandolin.Storage.prototype.getItem=function(key){var storeData=this.getItems();return storeData[key]};window.bbc.Mandolin.Storage.prototype.removeItem=function(key){var storeData=this.getItems();delete storeData[key];this.save(storeData)};window.bbc.Mandolin.Storage.prototype.getItems=function(){return deserialise(this.readCookie(this._cookieName)||\"\")};window.bbc.Mandolin.Storage.prototype.save=function(data){window.bbccookies.set(this._cookieName+\"=\"+encodeURIComponent(serialise(data))+\"; expires=\"+getLastExpirationDate(data).toUTCString()+\";\")};window.bbc.Mandolin.Storage.prototype.readCookie=function(name){var nameEq=name+\"=\" ca=window.bbccookies.get().split(\"; \") i c;validateCookieName(name);for(i=0;i<ca.length;i++){c=ca[i];if(c.indexOf(nameEq)===0){return decodeURIComponent(c.substring(nameEq.length c.length))}}return null};function serialise(o){var str=\"\";for(var p in o){if(o.hasOwnProperty(p)){str+='\"'+p+'\"'+\":\"+(typeof o[p]===\"object\"?(o[p]===null?\"null\":\"{\"+serialise(o[p])+\"}\"):'\"'+o[p].toString()+'\"')+\" \"}}return str.replace(/ \\}/g \"}\").replace(/ $/g \"\")}function deserialise(str){var o;str=\"{\"+str+\"}\";if(!validateSerialisation(str)){throw\"Invalid input provided for deserialisation.\"}eval(\"o = \"+str);return o}var validateSerialisation=(function(){var OBJECT_TOKEN=\"<Object>\" ESCAPED_CHAR='\"\\\\n\\\\r\\\\u2028\\\\u2029\\\\u000A\\\\u000D\\\\u005C' ALLOWED_CHAR=\"([^\"+ESCAPED_CHAR+\"]|\\\\\\\\[\"+ESCAPED_CHAR+\"])\" KEY='\"'+ALLOWED_CHAR+'+\"' VALUE='(null|\"'+ALLOWED_CHAR+'*\"|'+OBJECT_TOKEN+\")\" KEY_VALUE=KEY+\":\"+VALUE KEY_VALUE_SEQUENCE=\"(\"+KEY_VALUE+\" )*\"+KEY_VALUE OBJECT_LITERAL=\"({}|{\"+KEY_VALUE_SEQUENCE+\"})\" objectPattern=new RegExp(OBJECT_LITERAL \"g\");return function(str){if(str.indexOf(OBJECT_TOKEN)!==-1){return false}while(str.match(objectPattern)){str=str.replace(objectPattern OBJECT_TOKEN)}return str===OBJECT_TOKEN}})();function validateCookieName(name){if(name.match(/ ;/)){throw\"Illegal name provided must be valid in browser cookie.\"}}})(); /*]]>*/ /*<![CDATA[*/ if (typeof bbccookies_flag === 'undefined') { bbccookies_flag = 'ON'; } showCTA_flag = false; cta_enabled = (showCTA_flag && (bbccookies_flag === 'ON') ); (function(){var e=\"ckns_policy\" m=\"Thu 01 Jan 1970 00:00:00 GMT\" k={ads:true personalisation:true performance:true necessary:true};function f(p){if(f.cache[p]){return f.cache[p]}var o=p.split(\"/\") q=[\"\"];do{q.unshift((o.join(\"/\")||\"/\"));o.pop()}while(q[0]!==\"/\");f.cache[p]=q;return q}f.cache={};function a(p){if(a.cache[p]){return a.cache[p]}var q=p.split(\".\") o=[];while(q.length&&\"|co.uk|com|\".indexOf(\"|\"+q.join(\".\")+\"|\")===-1){if(q.length){o.push(q.join(\".\"))}q.shift()}f.cache[p]=o;return o}a.cache={};function i(o t p){var z=[\"\"].concat(a(window.location.hostname)) w=f(window.location.pathname) y=\"\" r x;for(var s=0 v=z.length;s<v;s++){r=z[s];for(var q=0 u=w.length;q<u;q++){x=w[q];y=o+\"=\"+t+\";\"+(r?\"domain=\"+r+\";\":\"\")+(x?\"path=\"+x+\";\":\"\")+(p?\"expires=\"+p+\";\":\"\");bbccookies.set(y true)}}}window.bbccookies={_setEverywhere:i cookiesEnabled:function(){var o=\"ckns_testcookie\"+Math.floor(Math.random()*100000);this.set(o+\"=1\");if(this.get().indexOf(o)>-1){g(o);return true}return false} set:function(o){return document.cookie=o} get:function(){return document.cookie} _setPolicy:function(o){return h.apply(this arguments)} readPolicy:function(o){return b.apply(this arguments)} _deletePolicy:function(){i(e \"\" m)} isAllowed:function(){return true} _isConfirmed:function(){return c()!==null} _acceptsAll:function(){var o=b();return o&&!(j(o).indexOf(\"0\")>-1)} _getCookieName:function(){return d.apply(this arguments)} _showPrompt:function(){var o=(!this._isConfirmed()&&window.cta_enabled&&this.cookiesEnabled()&&!window.bbccookies_disable);return(window.orb&&window.orb.fig)?o&&(window.orb.fig(\"no\")||window.orb.fig(\"ck\")):o}};bbccookies._getPolicy=bbccookies.readPolicy;function d(p){var o=(\"\"+p).match(/^([^=]+)(?==)/);return(o&&o.length?o[0]:\"\")}function j(o){return\"\"+(o.ads?1:0)+(o.personalisation?1:0)+(o.performance?1:0)}function h(r){if(typeof r===\"undefined\"){r=k}if(typeof arguments[0]===\"string\"){var o=arguments[0] q=arguments[1];if(o===\"necessary\"){q=true}r=b();r[o]=q}else{if(typeof arguments[0]===\"object\"){r.necessary=true}}var p=new Date();p.setYear(p.getFullYear()+1);p=p.toUTCString();bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.co.uk;path=/;expires=\"+p+\";\");bbccookies.set(e+\"=\"+j(r)+\";domain=bbc.com;path=/;expires=\"+p+\";\");return r}function l(o){if(o===null){return null}var p=o.split(\"\");return{ads:!!+p[0] personalisation:!!+p[1] performance:!!+p[2] necessary:true}}function c(){var o=new RegExp(\"(?:^|; ?)\"+e+\"=(\\\\d\\\\d\\\\d)($|;)\") p=document.cookie.match(o);if(!p){return null}return p[1]}function b(o){var p=l(c());if(!p){p=k}if(o){return p[o]}else{return p}}function g(o){return document.cookie=o+\"=;expires=\"+m+\";\"}function n(){var o='<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/bbccookies/0.6.6/script/bbccookies.js\"><\\/script>';if(window.bbccookies_flag===\"ON\"&&!bbccookies._acceptsAll()&&!window.bbccookies_disable){document.write(o)}}n()})(); /*]]>*/  if (! window.gloader) { window.gloader = [ \"glow\" {map: \"http://node1.bbcimg.co.uk/glow/glow/map.1.7.7.js\"}]; }     bbcRequireMap = {\"jquery-1\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.7.2\" \"jquery-1.4\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.4\" \"jquery-1.9\":\"http://static.bbci.co.uk/frameworks/jquery/0.3.0/sharedmodules/jquery-1.9.1\" \"swfobject-2\":\"http://static.bbci.co.uk/frameworks/swfobject/0.1.10/sharedmodules/swfobject-2\" \"demi-1\":\"http://static.bbci.co.uk/frameworks/demi/0.10.0/sharedmodules/demi-1\" \"gelui-1\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1\" \"cssp!gelui-1/overlay\":\"http://static.bbci.co.uk/frameworks/gelui/0.9.13/sharedmodules/gelui-1/overlay.css\" \"istats-1\":\"http://static.bbci.co.uk/frameworks/istats/0.23.1/modules/istats-1\" \"relay-1\":\"http://static.bbci.co.uk/frameworks/relay/0.2.6/sharedmodules/relay-1\" \"clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1\" \"canvas-clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/canvas-clock-1\" \"cssp!clock-1\":\"http://static.bbci.co.uk/frameworks/clock/0.1.9/sharedmodules/clock-1.css\" \"jssignals-1\":\"http://static.bbci.co.uk/frameworks/jssignals/0.3.6/modules/jssignals-1\" \"jcarousel-1\":\"http://static.bbci.co.uk/frameworks/jcarousel/0.1.10/modules/jcarousel-1\" \"bump-3\":\"//emp.bbci.co.uk/emp/bump-3/bump-3\"}; require({ baseUrl: 'http://static.bbci.co.uk/' paths: bbcRequireMap waitSeconds: 30 });  \n\n\n\n blq.setEnvironment('live'); if (blq.setLabel) blq.setLabel('searchSuggestion' \"Search\"); if (! /bbc\\.co\\.uk$/i.test(window.location.hostname) ) { document.documentElement.className += ' blq-not-bbc-co-uk'; } \n /*<![CDATA[*/ function oqsSurveyManager(w flag) { var defaultThreshold = 0 usePulseThreshold = (flag === 'OFF')? 1 : defaultThreshold activeThreshold; w.oqs = w.oqs || {}; /* we support cookie override for testing */ if ( w.document.cookie.match(/(?:^|; *)ckns_oqs_usePulseThreshold=([\\d.]+)/) ) { activeThreshold = RegExp.$1; } /* we support clientside override */ else if (typeof w.oqs_usePulseThreshold !== 'undefined') { activeThreshold = w.oqs_usePulseThreshold; } else { activeThreshold = usePulseThreshold; } w.oqs.usePulse = (w.Math.random() < activeThreshold); if (!w.oqs.usePulse) { w.document.write('<script type=\"text/javascript\" src=\"http://static.bbci.co.uk/frameworks/barlesque/2.75.0/desktop/3.5/script/vendor/edr.js\"><'+'/script>'); } } oqsSurveyManager(window 'ON'); /*]]>*/ \n/*<![CDATA[*/ window.istats = (window.istats || {}); (istats.head = function(w d) { w.istats._linkTracked = w.istats._trackingCookie = decodeURIComponent( (d.cookie.match(/\\bsa_labels=([^;]+)/)||[]).pop() || '' ); var host = w.location.host m = host.match(/(bbc(?:\\.co\\.uk|\\.com))$/i); d.cookie = 'sa_labels=; expires=Thu 01 Jan 1970 00:00:01 GMT; domain=' + (m? m[1] : host) + '; path=/'; })(window document); /*]]>*/ \n\n\n\n\n\n\n\n\n\n\n\n/*<![CDATA[*/\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.dom.get(\"html\").addClass(\"blq-js\")}});\ngloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad:function(glow){glow.ready(function(){if (glow.env.gecko){var gv = glow.env.version.split(\".\");for (var i=gv.length;i<4;i++){gv[i]=0;}if((gv[0]==1 && gv[1]==9 && gv[2]==0)||(gv[0]==1 && gv[1]<9)||(gv[0]<1)){glow.dom.get(\"body\").addClass(\"firefox-older-than-3-5\");}}});}});\nwindow.disableFacebookSDK=true;\nif (window.location.pathname.indexOf('+')>=0){window.disableFacebookSDK=true;}\n/*]]>*/\n\n\n\n\n<!--\n bbc.fmtj.page = {\n serverTime: 1415728570000 \n editionToServe: 'international' \n queryString: null \n section: 'technology' \n sectionPath: '/Technology' \n siteName: 'BBC News' \n siteToServe: 'news' \n siteVersion: 'cream' \n storyId: '26415021' \n assetType: 'story' \n uri: '/news/technology-26415021' \n country: 'il' \n masthead: false \n adKeyword: null \n templateVersion: 'v1_0' \n counterName: 'news.technology.story.26415021.page'\n }\n-->\n\n\n$useMap({map:\"http://news.bbcimg.co.uk/js/map/map_0_0_35.js\"});\n$loadView(\"0.0\" [\"bbc.fmtj.view\"]);\n$render(\"livestats-heatmap\");\n\n\n\n if (typeof bbcRequireMap !== 'undefined' && bbcRequireMap[\"jquery-1.9\"] === undefined && bbcRequireMap[\"jquery-1\"]) {\n var jquery19Path = bbcRequireMap[\"jquery-1\"].replace(/0.(1|2).(1|4)/ '0.3.0').replace(/jquery-1.(5|7).(1|2)/ 'jquery-1.9.1');\n require({\n paths : {\n \"jquery-1.9\": jquery19Path\n }\n });\n }\n if (typeof bbcRequireMap !== 'undefined' && bbcRequireMap[\"swfobject-2\"]) {\n require({\n paths : {\n \"swfobject-2\": bbcRequireMap[\"swfobject-2\"].replace('0.1.3' '0.1.10')\n }\n });\n }\n\n\n require({\n paths : {\n \"bump-3\": \"http://emp.bbci.co.uk/emp/bump-3/bump-3\"\n }\n });\n\n\n\n//<![CDATA[\ngloader.load(['glow' '1' 'glow.dom']);\n//]]>\n\n\n\n\n\n\n//<![CDATA[\n \n \n// set site specific config\nbbc.fmtj.av.emp.configs.push('news');\nrequire(['jquery-1'] function ($) {\n $(document).ready(function () {\n bbc.fmtj.av.emp.loadAll();\n });\n});\n//]]>\n\n\n\n\n\n\n\n\n$loadView(\"0.0\" [\"bbc.fmtj.view.news.story\"]);\n\n\n\n\n\n\n/*<![CDATA[*/if(bbcdotcom===undefined){var bbcdotcom={init:function(a){} objects:function(a){return false} domLoaded:false data:{ads:0 stats:0 statsProvider:null} adverts:{slot:function(b a){} layout:{reset:function(){}}} config:{isActive:function(a){return false}} addLoadEvent:function(a){var b=window.onload;if(typeof window.onload!=\"function\"){window.onload=a}else{window.onload=function(){if(b){b()}a()}}}}}bbcdotcom.objects=function(e f g){var d a c=arguments b=e.split(\".\");if(f===undefined){f=\"valid\"}if(g===undefined){g=window}for(d=0 a=b.length;d<a;d++){if(g[b[d]]===undefined){if(f===\"create\"){g[b[d]]={}}else{return false}}else{if(typeof g[b[d]]===\"function\"){if(typeof c[1]!==\"undefined\"&&c[1]!==null&&g[b[d]](c[1])!==undefined){return g[b[d]](c[1])}else{if(g[b[d]]()!==undefined){return g[b[d]]()}}}}g=g[b[d]]}return g};bbcdotcom.objects(\"bbcdotcom.config\" \"create\");bbcdotcom.config=(function(e c){var b=e a=c d=\"\" f=\"\" g=\"\";return{setAdsEnabled:function(h){b=(b!==0)?h:0} isAdsEnabled:function(){return b} setAnalyticsEnabled:function(h){a=(a!==0)?h:0} isAnalyticsEnabled:function(){return a} setJsPrefix:function(h){d=h} getJsPrefix:function(){return d} setSwfPrefix:function(h){f=h} getSwfPrefix:function(){return f} setCssPrefix:function(h){g=h} getCssPrefix:function(){return g}}}(1 1));bbcdotcom.objects(\"bbcdotcom.stats\" \"create\");if(BBC===undefined){var BBC={}}if(BBC.adverts===undefined){BBC.adverts={setZone:function(){} configure:function(){} write:function(){} show:function(){} isActive:function(){return false} setScriptRoot:function(){} setImgRoot:function(){} getAdvertTag:function(){} getSectionPath:function(){}}};/*]]>*/\n\n\n\n\n\n\n\n\n\n\n\n.bbccom_display_none{display:none;}\n/*<![CDATA[*/\n if (typeof orb !== 'undefined' && typeof orb.fig === 'function') {\n bbcdotcom.data = {\n a: orb.fig('ad')? 1 : 0 \n b: (0 == orb.fig('uk')) ? 1 : 0 \n c: orb.fig('ap')\n };\n } else {\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://tps.bbc.com/wwscripts/data\"%3E%3C/script%3E'));\n }\n/*]]>*/\n/*<![CDATA[*/\n if (typeof bbcdotcom.data == 'undefined' || typeof bbcdotcom.data.a == 'undefined' || typeof bbcdotcom.data.b == 'undefined' || typeof bbcdotcom.data.c == 'undefined') {\n bbcdotcom.data = {a:0 b:0 c:0};\n }\n if (bbcdotcom.data.a == 1) {\n document.write(unescape('%3Clink href=\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288/3pt_ads.css\" rel=\"stylesheet\" type=\"text/css\" /%3E'));\n \n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://www.bbc.co.uk/wwscripts/flag\"%3E%3C/script%3E'));\n \n }\n/*]]>*/\n/*<![CDATA[*/\n if (typeof bbcdotcom.flag == 'undefined' || bbcdotcom.flag.a != 1) {\n bbcdotcom.data.a = 0;\n }\n/*]]>*/\n\n\n\n /*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n window.Krux||((Krux=function(){Krux.q.push(arguments)}).q=[]);\n (function(){\n var k=document.createElement('script');k.type='text/javascript';k.async=true;\n var m src=(m=location.href.match(/\\bkxsrc=([^&]+)/))&&decodeURIComponent(m[1]);\n k.src = /^https?:\\/\\/([a-z0-9_\\-\\.]+\\.)?krxd\\.net(:\\d{1 5})?\\//i.test(src) ? src : src === \"disable\" ? \"\" :\n (location.protocol===\"https:\"?\"https:\":\"http:\")+\"//cdn.krxd.net/controltag?confid=JZTWpGsM\"\n ;\n var s=document.getElementsByTagName('script')[0];s.parentNode.insertBefore(k s);\n }());\n }\n /*]]>*/\n\n\n\n /*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n window.Krux||((Krux=function(){Krux.q.push(arguments);}).q=[]);\n (function(){\n function retrieve(n){\n var m k='kx'+n;\n if (window.localStorage) {\n return window.localStorage[k] || \"\";\n } else if (navigator.cookieEnabled) {\n m = document.cookie.match(k+'=([^;]*)');\n return (m && unescape(m[1])) || \"\";\n } else {\n return '';\n }\n }\n Krux.user = retrieve('user');\n Krux.segments = retrieve('segs') ? retrieve('segs').split(' ') : [];\n // DFP Premium\n var dfpp = [];\n if (Krux.user) {\n dfpp.push('khost=' + encodeURIComponent(location.hostname));\n dfpp.push('kuid=' + Krux.user);\n }\n for (var i = 0; i < Krux.segments.length; i++ ) {\n dfpp.push('ksg=' + Krux.segments[i]);\n }\n Krux.dfppKeyValues = dfpp.length ? dfpp.join(';') + ';' : '';\n })();\n }\n /*]]>*/\n\n/*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/bbccom.js\"%3E%3C/script%3E'));\n }\n/*]]>*/\n/*<![CDATA[*/\n if (bbcdotcom.data.a == 1 || bbcdotcom.data.b == 1) {\n BBC.adverts.setData(bbcdotcom.data);\n bbcdotcom.config.setAdsEnabled(bbcdotcom.data.a);\n bbcdotcom.config.setAnalyticsEnabled(bbcdotcom.data.b);\n if(typeof bbcdotcom !== 'undefined' && typeof bbcdotcom.survey !== 'undefined' && typeof bbcdotcom.survey.init === 'function') {\n bbcdotcom.survey.init();\n }\n }\n /*\n * Native remove content for UK visitors\n */\n (function() {\n if (bbcdotcom.data.b == 0) {\n var adKeyword = bbcdotcom.objects('bbc.fmtj.page.adKeyword');\n if(adKeyword && adKeyword !== null && typeof adKeyword === 'string' && adKeyword.indexOf('native-') !== -1) {\n document.write('<style >' +\n '#storypage-container .story-body {display:none;}' +\n '#native-uk-disclaimer {border: 2px solid;margin: 8px;padding: 16px;}' +\n '</style>');\n require(['jquery-1'] function($) {\n $(function(){\n /* Native advertising disclaimer */\n $( \".story-body\" ).html('<div id=\"native-uk-disclaimer\">' +\n '<h1>BBC Sport (International version)</h1>' +\n 'We\\'re sorry but this article is not accessible from the UK as it is part of our ' +\n 'international service and is not funded by the license fee.' +\n '</div>');\n $( \".story-body\" ).show();\n });\n });\n }\n }\n }());\n bbcdotcom.objects('page' 'create' bbcdotcom);\n bbcdotcom.page.edition = '(none)';\n bbcdotcom.page.url = '/news/technology-26415021';\n bbcdotcom.page.zoneFile = '3pt_zone_file';\n bbcdotcom.page.http_host = 'www.bbc.com';\n \n \n/*]]>*/\n/*<![CDATA[*/if(bbcdotcom.data.a == 1){(function(){switch(bbcdotcom.page.url){case\"/\":case\"/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/1/hi/default.stm\":\"/2/hi/default.stm\";break;case\"/sport\":case\"/sport/\":case\"/sport/default.stm\":bbcdotcom.page.url=(bbcdotcom.page.edition===\"domestic\")?\"/sport1/hi/default.stm\":\"/sport2/hi/default.stm\";break}BBC.adverts.setScriptRoot(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/\");bbcdotcom.config.setJsPrefix(\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\");bbcdotcom.config.setSwfPrefix(\"http://news.bbcimg.co.uk/shared/swf/bbccom/0.3.288\");bbcdotcom.config.setCssPrefix(\"http://news.bbcimg.co.uk/css/screen/shared/0.3.288\");BBC.adverts.setImgRoot(\"http://news.bbcimg.co.uk/shared/img/bbccom/\");BBC.adverts.init({domain:bbcdotcom.page.http_host location:bbcdotcom.page.url zoneVersion:bbcdotcom.page.zoneFile zoneReferrer:document.referrer})}());(function(){if(typeof require!==\"undefined\"){require({paths:{bbcdotcom:\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288\"}})}})();if(BBC.adverts.getV6Gvl3()&&\"undefined\"!==typeof bbcdotcom.page.bddUseLatestFromTest){document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://wwwpreview.test.newsonline.tc.nca.bbc.co.uk/js/app/bbccom/'+bbcdotcom.latest_version+'/advert.js\"'))}else{if(BBC.adverts.getV6Gvl3()){document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/advert.js\"%3E%3C/script%3E'))}}if(/[?|&]metadata=yes(&|$)/.test(window.location.search)){document.write(\"http://www.test.bbc.com/wwscripts/metadata?bbcdotcom_asset=\"+window.location.hostname+window.location.pathname)};}/*]]>*/\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n document.write(unescape('%3Cscript id=\"gnlAnalyticsEnabled\" class=\"bbccom_display_none\"%3E%3C/script%3E'));\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n document.write(unescape('%3Cscript id=\"continuous-play-enabled\" class=\"bbccom_display_none\"%3E%3C/script%3E'));\n /*]]>*/\n\n\n if(typeof BBC.adverts != 'undefined' && typeof BBC.adverts.setPageVersion != 'undefined'){\n BBC.adverts.setPageVersion('(none)');\n }\n\n\n\nfunction BetaSite() {\n function setMobileCookie() {\n var d = new Date ();\n d.setDate(d.getDate() + 1);\n d = d.toUTCString();\n window.bbccookies.set('ckps_d=m;domain=.bbc.co.uk;path=/;expires=' + d );\n window.bbccookies.set('ckps_d=m;domain=.bbc.com;path=/;expires=' + d );\n }\n function isValidQueryString() {\n return (window.location.search.indexOf('view=beta') !== -1);\n }\n function isClientCapable() {\n return ('querySelector' in document && 'localStorage' in window && 'addEventListener' in window);\n }\n if (isClientCapable() && isValidQueryString()) {\n setMobileCookie();\n window.location.host = 'm.bbc.co.uk';\n }\n}\nBetaSite();\n\n\n\n if(bbcdotcom.objects('BBC.adverts.getAdvertTag')) {\n gloader.load([\"glow\" \"1\" \"glow.dom\"] {onLoad: function(glow){\n glow.ready(function(){\n if(bbcdotcom.objects('BBC.adverts.getAdvertTag')) {\n var adImageUrl = BBC.adverts.getAdvertTag('printableversionsponsorship' '' 'standardUri');\n if(adImageUrl) {\n if (glow.env.ie ) {\n window.onbeforeprint = function(){\n var printAdvert = glow.dom.get(\"#print-advert\");\n if (printAdvert.get(\"img\").length == 0)\n {\n printAdvert.append('<img src=\"'+adImageUrl+'\" alt=\"\" />');\n }\n };\n }else{\n glow.dom.get(\"head\").append('<style type=\"text/css\">#print-advert {display:none};</style><style type=\"text/css\" media=\"print\">#print-advert::after{content:url('+adImageUrl+');} #print-advert{display:block;overflow:hidden;}</style>');\n }\n }\n }\n });\n }});\n }\n \n\n\n bbcRequireMap['module/weather'] = '/inc/specials/cream/hi/news/personalisation/weather';\n bbcRequireMap['module/local'] = '/inc/specials/cream/hi/news/personalisation';\n bbcRequireMap['module/localnewsandweather'] = '/inc/specials/cream/hi/news/personalisation/localnewsandweather';\n bbcRequireMap['translation'] = 'module/translations/en-GB';\n require({ baseUrl: 'http://static.bbci.co.uk/' paths: bbcRequireMap waitSeconds: 30 });\n\n\nrequire(['jquery-1'] function(jQuery) {\n jQuery.ajaxSetup({cache: true})\n});\nrequire([\"jquery-1\" \"istats-1\"] function ($ istats) {\n $(function() {\n istats.track('external' {region: $('.story-body') linkLocation : 'story-body'});\n istats.track('external' {region: $('.story-related .related-links') linkLocation : 'related-links'});\n istats.track('external' {region: $('.story-related .newstracker-list') linkLocation : 'newstracker'});\n });\n});\n\n\n\n\n\n\n\n\n\n\n\n\n\n var referrer = document.referrer;\n var livestatsBug = \"<img alt='' id='livestats' src='http://stats.bbc.co.uk/o.gif?~RS~s~RS~News~RS~t~RS~HighWeb_Story~RS~i~RS~26415021~RS~p~RS~99113~RS~a~RS~International~RS~u~RS~/news/technology-26415021~RS~r~RS~\"+referrer+\"~RS~q~RS~~RS~z~RS~10~RS~'>\";\n document.getElementById('livestats-web-bug-tag').innerHTML = livestatsBug;\n\n\n\n\n\nBBC.adverts.write(\"wallpaper\" false);\n/*<![CDATA[*/BBC.adverts.wallpaperBodyTag=document.getElementsByTagName(\"body\");BBC.adverts.wallpaperATag=document.getElementsByTagName(\"a\");if(\"undefined\"!=typeof BBC.adverts.wallpaperATag&&\"undefined\"!=typeof BBC.adverts.wallpaperATag[0]&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag&&\"undefined\"!=typeof BBC.adverts.wallpaperBodyTag[0]&&-1!==BBC.adverts.wallpaperATag[0].href.indexOf(\"http://ad.doubleclick.net\")){BBC.adverts.wallpaperBodyTag[0].removeChild(BBC.adverts.wallpaperATag[0])};/*]]>*/\n\n\n\n\n/*<![CDATA[*/ bbcFlagpoles_istats = 'ON'; istatsTrackingUrl = '//sa.bbc.co.uk/bbc/bbc/s?name=news.technology.story.26415021.page&cps_asset_id=26415021&page_type=story&section=technology&app_version=6.2.176-RC2&first_pub=2014-03-03T10:22:55+00:00&last_editorial_update=2014-03-03T10:22:55+00:00&title=How+to+get+your+children+coding&comments_box=false&cps_media_type=&cps_media_state=&by_nation=&app_type=web&ml_name=SSI&ml_version=0.23.1&language=en-GB'; if (window.istats_countername) { istatsTrackingUrl = istatsTrackingUrl.replace(/([?&]name=)[^&]+/ig '$1' + istats_countername); } (function() { if ( /\\bIDENTITY=/.test(document.cookie) ) { istatsTrackingUrl += '&bbc_identity=1'; } var c = (document.cookie.match(/\\bckns_policy=(\\d\\d\\d)/)||[]).pop() || ''; istatsTrackingUrl += '&bbc_mc=' + (c? 'ad'+c.charAt(0)+'ps'+c.charAt(1)+'pf'+c.charAt(2) : 'not_set'); if ( /\\bckns_policy=\\d\\d0/.test(document.cookie) ) { istatsTrackingUrl += '&ns_nc=1'; } var screenWidthAndHeight = 'unavailable'; if (window.screen && screen.width && screen.height) { screenWidthAndHeight = screen.width + 'x' + screen.height; } istatsTrackingUrl += ('&screen_resolution=' + screenWidthAndHeight); istatsTrackingUrl += '&blq_s=3.5d&blq_r=3.5&blq_v=journalism-worldwide'; })(); /*]]>*/  /*<![CDATA[*/ (function() { window.istats || (istats = {}); var cookieDisabled = (document.cookie.indexOf('NO-SA=') != -1) hasCookieLabels = (document.cookie.indexOf('sa_labels=') != -1) hasClickThrough = /^#sa-(.*?)(?:-sa(.*))?$/.test(document.location.hash) runSitestat = !cookieDisabled && !hasCookieLabels && !hasClickThrough && !istats._linkTracked; if (runSitestat && bbcFlagpoles_istats === 'ON') { sitestat(istatsTrackingUrl); } else { window.ns_pixelUrl = istatsTrackingUrl; /* used by Flash library to track */ } function sitestat(n){var j=document f=j.location b=\"\";if(j.cookie.indexOf(\"st_ux=\")!=-1){var k=j.cookie.split(\";\");var e=\"st_ux\" h=document.domain a=\"/\";if(typeof ns_!=\"undefined\"&&typeof ns_.ux!=\"undefined\"){e=ns_.ux.cName||e;h=ns_.ux.cDomain||h;a=ns_.ux.cPath||a}for(var g=0 f=k.length;g<f;g++){var m=k[g].indexOf(\"st_ux=\");if(m!=-1){b=\"&\"+unescape(k[g].substring(m+6))}}document.cookie=e+\"=; expires=\"+new Date(new Date().getTime()-60).toGMTString()+\"; path=\"+a+\"; domain=\"+h}ns_pixelUrl=n;n=ns_pixelUrl+\"&ns__t=\"+(new Date().getTime())+\"&ns_c=\"+((j.characterSet)?j.characterSet:j.defaultCharset)+\"&ns_ti=\"+escape(j.title)+b+\"&ns_jspageurl=\"+escape(f&&f.href?f.href:j.URL)+\"&ns_referrer=\"+escape(j.referrer);if(n.length>2000&&n.lastIndexOf(\"&\")){n=n.substring(0 n.lastIndexOf(\"&\")+1)+\"ns_cut=\"+n.substring(n.lastIndexOf(\"&\")+1 n.lastIndexOf(\"=\")).substring(0 40)}(j.images)?new Image().src=n:j.write('<p><i'+'mg src=\"'+n+'\" height=\"1\" width=\"1\" alt=\"\" /></p>')}; })(); /*]]>*/      For a better experience on your device try our mobile site.    \n\n  <![CDATA[ <div id=\"bbccookies-prompt\" class=\"bbccookies-w\"> <h2> Cookies on the BBC website </h2> <p> We use cookies to ensure that we give you the best experience on our website.<span class=\"bbccookies-international-message\"> We also use cookies to ensure we show you advertising that is relevant to you.</span> If you continue without changing your settings we'll assume that you are happy to receive all cookies on the BBC website. However if you would like to you can <a href=\"/privacy/cookies/managing/cookie-settings.html\">change your cookie settings</a> at any time. </p> <ul> <li id=\"bbccookies-continue\"> <button type=\"button\" id=\"bbccookies-continue-button\">Continue</button> </li> <li id=\"bbccookies-more\"><a href=\"/privacy/cookies/bbc\">Find out more</a></li></ul> </div> ]]> /*<![CDATA[*/ (function(){if(bbccookies._showPrompt()){var i=document b=i.getElementById(\"blq-pre-mast\") f=i.getElementById(\"blq-global\") h=i.getElementById(\"blq-container\") c=i.getElementById(\"blq-bbccookies-tmpl\") a g e;if(b&&i.createElement){a=i.createElement(\"div\");a.id=\"bbccookies\";e=c.innerHTML;e=e.replace(\"<\"+\"![CDATA[\" \"\").replace(\"]]\"+\">\" \"\");a.innerHTML=e;if(f){f.insertBefore(a b)}else{h.insertBefore(a b)}g=i.getElementById(\"bbccookies-continue-button\");g.onclick=function(){a.parentNode.removeChild(a);return false};bbccookies._setPolicy()}}})(); /*]]>*/             Accessibility links  Skip to content Skip to local navigation Accessibility Help      BBC navigation   News   Sport   Weather   Earth   Future   Shop   TV   Radio   More\u2026         Search term:             \n\n\n\n\nTechnology\n\n\n$render(\"advert\" \"advert-sponsor-section\");\n\n$render(\"advert-post-script-load\");\n\n\nHome\nUK\nAfrica\nAsia\nAustralia\nEurope\nLatin America\nMid-East\nUS & Canada\nBusiness\nHealth\nSci/Environment\nTech\nEntertainment\nVideo\n\n\n\n\n\n\n\n$render(\"advert\" \"advert-leaderboard\");\n\n$render(\"advert-post-script-load\");\n\n\n\n /*<![CDATA[*/\n if(typeof bbcdotcom.objects('bbcdotcom.branding.init') === 'function') {\n bbcdotcom.branding.init(BBC.adverts.getZoneData().zone BBC.adverts.getAdKeyword());\n bbcdotcom.branding.write();\n }\n /*]]>*/\n \n\n\n /*<![CDATA[*/\n $render(\"advert\" \"advert-sponsor-subsection\");\n /*]]>*/\n \n\n\n\n /*<![CDATA[*/\n $render(\"advert-post-script-load\");\n /*]]>*/\n\n\n\n\n\n\n\n\n\n3 March 2014\nLast updated at 10:22 GMT\n\n\nShare this page\n\n\nDelicious\n\n\nDigg\n\n\nFacebook\n\n\nreddit\n\n\nStumbleUpon\n\n\nTwitter\n\n\nEmail\n\n\nPrint\n\n\n\n\n \n<!--\n$render(\"page-bookmark-links\" \"page-bookmark-links-head\" {\n useForgeShareTools:\"true\" \n position:\"top\" \n site:'News' \n headline:'BBC News - An hour to catch the coding bug' \n storyId:'26415021' \n sectionId:'99113' \n url:'http://www.bbc.com/news/technology-26415021' \n edition:'International'\n}); \n-->\n\nAn hour to catch the coding bug\n\nBy Mark Ward\nTechnology correspondent BBC News\n\n\n\nWe did our Hour of Code on a lazy Sunday morning\n\n\nContinue reading the main story Related Stories\n\n\nComputer code lessons at primary school Watch\n\n\nYear of Code - PR fiasco or vital mission?\n\n\nAre teachers ready for the coding revolution?\n\n\n\nOkay 60 minutes and counting. Here we go.\nI've got an hour to convince my kids that programming is for them.\nWell sort of.\nI'm putting my twin 10-year-old boys Toby and Callum through the Hour of Code - a campaign that seeks to ignite an interest in programming - the part we're doing using specially created web-based exercises. \nThe campaign begun in the US has landed in the UK where it also coincides with government calls for as many children as possible to get coding.\nProgramming is being pushed because in an ever more technological world it can only be a good thing to give people a peep into what goes on behind the touch screen cash point and website. \nThe Hour of Code is supposed to be the start of that journey and I like many other parents feel it's one my children should be embarking on. I do feel like a clock somewhere is ticking and unless they get started with this essential skill they'll be left behind. \n\"In the future kids are going to be doing programming \" said Callum when I asked him why it was worth learning how to code. \"We need to learn so we can do stuff with the computer otherwise it will be a blank page and never work.\"\nZombie dance\n\n\nThe coding exercises involve familiar characters such as the Angry Birds\n\nIt's the getting started for both parents and their offspring that the Hour is intended to help with. I'm probably like most parents in that I have no significant qualification in computer science. All I can offer my boys is a lifetime of tinkering backed up over the past 18 months with online courses in Python HTML CSS Javascript and the like. \nThere's good precedents for the value of something like the Hour of Code. I've quizzed every chief technology officer (CTO) developer or IT worker I've met in the past couple of weeks about what got them started and every one knew exactly the moment they got it. Their eyes lit up as they talked about typing in code listings from magazines working through every Dos command or designing their own blocky 8-bit game characters.\nAnd finally at the back of my mind are all those statistics about the shortages of skilled IT staff and my hope that if this works then their future career options will be much wider than they would be without this skill.\nSo no pressure then.\nYesterday morning we gave it a go. I was keen for it to be fun rather than feel like school as there's nothing more likely to turn them off than for it to be sold as good for them. I think we struck the right note of informality - Cal did it in his onesie. \nIt went OK no better than that. Pretty good. We worked through all the exercises getting angry birds to mash pigs and zombies to chomp sunflowers. The coding is done by dragging blocks representing different commands into a work area and building the blocks into a tower of coherent instructions.\nThe block-building system is based on the Scratch programming language build by MIT's Mitch Resnick. \nThe exercises start easy - just getting an angry bird to hop on to a pig. By the end we were using \"If\u2026 else\" statements and loops to help a zombie navigate a tricky maze to reach the sunflower.\nThis went down well with Callum. \"Cool! It's scanning for a path \" he said as the zombie worked its way towards the hapless flower.\nMistakes were made but we learned from them we debated over which way to make the birds and zombies turn and the time went really fast. \nToby was surprised to find that this counted as programming.\n\"I thought coding was just a lot of people tapping in letter and numbers until they got it right \" he said. \nNext steps\nAnd yet I felt it was a bit too easy. I wanted to make the coding connection to real life more tangible. So as we had about 15 minutes of our Hour of Code left we went further.\nThis time we used the MIT App Inventor to build a basic program that would run on the tablets they own. \nThe app inventor uses the same \"drag the block\" method to build a program and following the instructions we had soon created an app that turned anything typed in text into speech. \n\n\nThe App Inventor uses the same block dragging system as the Hour of Code exercises\n\nWe got it working on Cal's tablet and soon they were getting that gadget to call out lots of phrases. Almost inevitably as they are 10 years old a lot of these phrases involved the words \"willy\" and \"bum\". \nBut they had a lot of fun with it and it brought home to them how straight-forward coding can be. In just over an hour they went from being pretty much novices to creating an Android app - a basic one that trades on the expertise of the people that built the coding tools but it was an accomplishment nonetheless.\nDid they catch the coding bug as a result? \nMaybe later in the day they were programming each other after one of their regular wrestling matches left Toby lying exhausted on the floor. Suddenly Cal called out commands such as \"roll left\" and Toby started obeying even to the point of crashing into the sofa when too many roll commands were given. \nThen Toby had his turn and did the same they even worked out that they had to compensate for the changes in left and right as they rolled. \nSo I think that hour started something. Both with them and with me. Building that Android app made me realise that it is straight-forward. That my lack of formal qualifications do not matter as much as I thought. And maybe that's the point of the hour. Making people realise that it is not scary and difficult. You just have to find an hour and give it a try. You can even do it in your onesie.\n\n\n\n\nMore on This Story\n\n.related-links-list li {\nposition: relative;\n}\n.related-links-list .gvl3-icon {\nposition: absolute;\ntop: 0;\nleft: 0;\n}\n\n\nRelated Stories\n\n\n\nComputer code lessons at primary school Watch\n\n08 JANUARY 2014\nEDUCATION & FAMILY\n\n\n\nYear of Code - PR fiasco or vital mission?\n\n12 FEBRUARY 2014\nTECHNOLOGY\n\n\n\nAre teachers ready for the coding revolution?\n\n23 JANUARY 2014\nTECHNOLOGY\n\n\n\n$render(\"page-see-also\" \"ID\");\n$render(\"page-newstracker\" \"ID\");\n\nRelated Internet links\n\n\nUK Hour of Code\n\n\nMIT App Inventor\n\n\nMIT Scratch\n\n\n\nThe BBC is not responsible for the content of external Internet sites\n\n$render(\"page-related-items\" \"ID\");\n\n\n\nShare this page\n\n\nDelicious\n\n\nDigg\n\n\nFacebook\n\n\nreddit\n\n\nStumbleUpon\n\n\nTwitter\n\n\nEmail\n\n\nPrint\n\n\n\n\n$render(\"advert\" \"advert-sponsor-module\" \"page-bookmark-links\");\n\n$render(\"advert-post-script-load\");\n\n \n<!--\n$render(\"page-bookmark-links\" \"page-bookmark-links-foot\" {\n useForgeShareTools:\"true\" \n position:\"bottom\" \n site:'News' \n headline:'BBC News - An hour to catch the coding bug' \n storyId:'26415021' \n sectionId:'99113' \n url:'http://www.bbc.com/news/technology-26415021' \n edition:'International'\n}); \n-->\n\n\n\n$render(\"advert\" \"advert-google-adsense\");\n\n$render(\"advert-post-script-load\");\n\n\nMore Technology stories\nRSS\n\n\n\n\nGoogle to lease former Nasa airfield\n\nGoogle is to pay over \u00a31bn to rent an airfield but little is known about what it plans to do there.\n\n\n\nRocket bike sets 207mph speed record\n\n\n\n\nSpotify defends itself against Swift\n\n\n\n\n\n\n\n\n$render(\"advert\" \"advert-mpu-high\");\n\n$render(\"advert-post-script-load\");\n\nTop Stories\n\n\n\nEU court backs migrant benefit curbs\n\n\nMorocco will not host Cup of Nations\n\n\nAlibaba Singles' Day sales pass $9bn\n\n\nIndia sterilisation deaths inquiry\n\n\nAnguish at South Korea ferry verdict\n\n\n\n$render(\"range-top-stories\" \"range-top-stories\");\n\n$render(\"advert\" \"advert-mpu-low\");\n\n$render(\"advert-post-script-load\");\n\nFeatures & Analysis\n\n\n\n\nRiver republics\n\nWhich part of the world has the people with the reddest hair? \n \n\n\n\n\nLost youth\n\nHow did 14-year-olds end up in the trenches in WW1? \n \n\n\n\n\nMacho move\n\nHow Russian president's gesture ignited a media firestorm in China \n \n\n\n\n\nThe Supercomplication\n\nThe 24 features of the most complicated handmade watch \n \n\n\n\n\n$render(\"feature-generic\" \"features\");\n\nMost Popular\nShared\n\n\n\n\n1: Doughnut burger busts day's calories\n\n\n\n2: Gary Glitter denies sex charges\n\n\n\n3: Ant and Dec asked to end 'animal abuse'\n\n\n\n4: Last poppy laid as UK honours war dead\n\n\n\n5: The story of the 'most complicated' watch in the world\n\n\n\nRead\n\n\n\n\n1: When Singles Day Putin and China's first lady collided\n\n\n\n2: EU court backs migrant benefit curbs\n\n\n\n3: The people with the reddest hair in the world\n\n\n\n4: Woman 'maces man' at Turner screening\n\n\n\n5: Van Gogh 'did not kill himself'\n\n\n\n6: The story of the 'most complicated' watch in the world\n\n\n\n7: Tarantino 'to retire' after 10th film\n\n\n\n8: Alibaba Singles' Day sales pass $9bn\n\n\n\n9: Nigeria fury over US arms refusal\n\n\n\n10: Last poppy laid as UK honours war dead\n\n\n\nVideo/Audio\n\n\n\n\n2: 'Revenge porn' victim faces arrest Watch\n\n\n\n3: Putin rebuffed by China's First Lady Watch\n\n\n\n4: One-minute World News Watch\n\n\n\n5: The Who celebrate 50 years Watch\n\n\n\n6: Mexico student who escaped 'massacre' Watch\n\n\n\n7: How the world marked Armistice Day Watch\n\n\n\n8: Veterans attend Menin Gate ceremony Watch\n\n\n\n9: Is this the ultimate pushbike? Watch\n\n\n\n10: Bird's-eye view of Gatwick runway plans Watch\n\n\n\n\n$render(\"advert\" \"advert-sponsor-module\" \"range-most-popular\" \"most-popular\");\n\n$render(\"advert-post-script-load\");\n\n$render(\"most-popular\" \"most-popular\");\n\n\n\n\nBBC Future\n\n\n\n\n\nA revolution on two wheels?\nThe shape of city cars to come Read more...\n\n\n\n\n$render(\"include-group-for-hypers\" \"include-group-for-hypers\");\n\n\n$render(\"advert\" \"advert-partner-button\");\n\n$render(\"advert-post-script-load\");\n\n\nProgrammes\n\n\n\nExtra Time Watch\n\nMark Webber on dealing with the politics and 'shallow relationships' of Formula 1\n\n$render(\"advert\" \"advert-sponsor-module\" \"programme-breakout\" \"extra-time\");\n\n$render(\"advert-post-script-load\");\n\n\n\n$render(\"container-programmes-promotion\" \"container-programme-promotion\");\n\n\n$render(\"advert\" \"advert-native-side\");\n\n$render(\"advert-post-script-load\");\n\n$render(\"advert\" \"advert-mpu-bottom\");\n\n$render(\"advert-post-script-load\");\n\n\n\n\n\n\n\nServices\n\n\u00a0Mobile\n\u00a0Connected TV\n\u00a0News feeds\n\u00a0Alerts\n\u00a0E-mail news\n\n\n\nAbout BBC News\n\nEditors' blog\nBBC College of Journalism\nNews sources\nMedia Action\nEditorial Guidelines\n\n\n\n\n    BBC links    Mobile siteTerms of UseAbout the BBC     Advertise With UsPrivacyAccessibility Help     Ad ChoicesCookiesContact the BBC     Parental Guidance    /*<![CDATA[*/ (function() { var mLink = document.getElementById('blq-footer-mobile') stick = function() { var d = new Date (); d.setYear(d.getFullYear() + 1); d = d.toUTCString(); window.bbccookies.set('ckps_d=m;domain=.bbc.co.uk;path=/;expires=' + d ); window.bbccookies.set('ckps_d=m;domain=.bbc.com;path=/;expires=' + d ); }; if (mLink) { if (mLink.addEventListener) { mLink.addEventListener('click' stick false); } else if (mLink.attachEvent) { mLink.attachEvent('onclick' stick); } } })(); /*]]>*/   BBC \u00a9 2014 The BBC is not responsible for the content of external sites. Read more. This page is best viewed in an up-to-date web browser with style sheets (CSS) enabled. While you will be able to view the content of this page in your current browser you will not be able to get the full visual experience. Please consider upgrading your browser software or enabling style sheets (CSS) if you are able to do so.  \n\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && window.location.pathname.indexOf('/news/business') !== -1) {\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/config.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/utils.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/sections.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/adverts/keyValues.js\">\\x3C/script>');\n document.write('<script type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/orb/analytics.js\">\\x3C/script>');\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && window.location.pathname.indexOf('/news/business') !== -1) {\n if (bbcdotcom && bbcdotcom.analytics) {\n bbcdotcom.analytics.init();\n bbcdotcom.analytics.setSuite('bbcresponsivedev');\n bbcdotcom.analytics.page();\n }\n }\n /*]]>*/\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n if(typeof(bbcdotcom) != 'undefined' && typeof(bbcdotcom.stats) != 'undefined') {\n bbcdotcom.stats.contentType = \"HTML\";\n }\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://js.revsci.net/gateway/gw.js?csid=J08781\"%3E%3C/script%3E'));\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n DM_tag();\n }\n /*]]>*/\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && typeof scw === 'undefined') {\n BBC.journalismVariant = true;\n \n var s_account = \"bbcwglobalprod\";\n \n \n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"http://news.bbcimg.co.uk/js/app/bbccom/0.3.288/s_code.js\"%3E%3C/script%3E'));\n \n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && BBC.journalismVariant) {\n var s_code=scw.t();if(s_code)document.write(s_code)\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics') && BBC.journalismVariant) {\n if(navigator.appVersion.indexOf('MSIE')>=0)document.write(unescape('%3C')+'\\!-'+'-')\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n document.write(unescape(\"%3Cscript src='\" + (document.location.protocol == \"https:\" ? \"https://sb\" : \"http://b\") + \".scorecardresearch.com/beacon.js' %3E%3C/script%3E\"));\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n COMSCORE.beacon({\n c1:2 \n c2:\"6035051\" \n c3:\"\" \n c4:\"www.bbc.com/news/technology-26415021\" \n c5:\"\" \n c6:\"\" \n c15:\"\"\n });\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('sitestat')) {\n function sitestat(ns_l){ns_l+='&amp;ns__t='+(new Date()).getTime();\n ns_0=document.referrer;\n ns_0=(ns_0.lastIndexOf('/')==ns_0.length-1)?ns_0.substring(ns_0.lastIndexOf('/') 0):ns_0;\n if(ns_0.length>0)ns_l+='&amp;ns_referrer='+escape(ns_0);\n if(document.images){ns_1=new Image();ns_1.src=ns_l;}else\n document.write('<img src=\"'+ns_l+'\" width=\"1\" height=\"1\" alt=\"\">');}\n sitestat(\"http://nl.sitestat.com/adfab/bbc/s?teller\");\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-au')) {\n <!-- COPYRIGHT 2009 Nielsen Online -->\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"' + ('https:' == document.location.protocol ? 'https:' : 'http:') + '//secure-au.imrworldwide.com/v60.js\"%3E%3C/script%3E'));\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-au')) {\n <!-- Start Nielsen Online SiteCensus V6.0 Part 2 -->\n nol_t({cid:\"au-bbc\" content:\"0\" server:\"secure-au\"}).record().post();\n <!-- End Nielsen Online SiteCensus V6.0 Part 2 -->\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-nz')) {\n <!-- COPYRIGHT 2009 Nielsen Online -->\n document.write(unescape('%3Cscript type=\"text/javascript\" src=\"' + ('https:' == document.location.protocol ? 'https:' : 'http:') + '//secure-nz.imrworldwide.com/v60.js\"%3E%3C/script%3E'));\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-nz')) {\n nol_t({cid:\"nz-bbc\" content:\"0\" server:\"secure-nz\"}).record().post();\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('nielsen-us')) {\n <!-- COPYRIGHT 2010 Nielsen Online -->\n (function () {\n var d = new Image(1 1);\n d.onerror = d.onload = function () {\n d.onerror = d.onload = null;\n };\n d.src = [('https:' == document.location.protocol ? 'https:' : 'http:') + \"//secure-us.imrworldwide.com/cgi-bin/m?ci=us-804789h&amp;cg=0&amp;cc=1&amp;si=\" escape(window.location.href) \"&amp;rp=\" \n escape(document.referrer) \"&amp;ts=compact&amp;rnd=\" (new Date()).getTime()].join('');\n })();\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('analytics')) {\n (function() {\n var em = document.createElement('script'); em.type = 'text/javascript'; em.async = true;\n em.src = ('https:' == document.location.protocol ? 'https://me-ssl' : 'http://me-cdn') + '.effectivemeasure.net/em.js';\n var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(em s);\n })();\n }\n /*]]>*/\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('agof')) {\n var ivwcode=\"default\";\n if(typeof BBC != 'undefined' && typeof BBC.adverts != 'undefined'){\n ivwcode = BBC.adverts.getSectionPath();\n }\n var IVW=\"http://bbc.ivwbox.de/cgi-bin/ivw/CP/\"+ivwcode+\";\";\n document.write(\"<img src=\\\"\"+IVW+\"?r=\"+escape(document.referrer)+\"&d=\"+(Math.random()*100000)+\"\\\" width=\\\"1\\\" height=\\\"1\\\" alt=\\\"szmtag\\\" />\");\n }\n /*]]>*/\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('agof')) {\n var szmvars=\"bbc//CP/\"+ivwcode;\n document.write(unescape('%3Cscript src=\"http://bbc.ivwbox.de/2004/01/survey.js\" type=\"text/javascript\"%3E%3C/script%3E'));\n }\n /*]]>*/\n\n\n\n\n\n /*<![CDATA[*/\n if (BBC.adverts.isActive('ads') && BBC.adverts.isActive('analytics')) {\n document.write(unescape('%3Cscript src=\"http://widgets.outbrain.com/outbrain.js\" type=\"text/javascript\"%3E%3C/script%3E'));\n }\n /*]]>*/\n \n\n   if (typeof require !== 'undefined') { require(['istats-1'] function(istats){ istats.track('external' { region: document.getElementById('blq-main') }); istats.track('download' { region: document.getElementById('blq-main') }); }); }  <![CDATA[ <div id=\"blq-panel-promo\" class=\"blq-masthead-container\"></div> ]]> <![CDATA[ <div id=\"blq-panel-more\" class=\"blq-masthead-container blq-clearfix\" xml:lang=\"en-GB\" dir=\"ltr\"> <div class=\"blq-panel-container panel-paneltype-more\"> <div class=\"panel-header\"> <h2> <a href=\"http://www.bbc.co.uk/a-z/\"> More&hellip; </a> </h2> <a href=\"http://www.bbc.co.uk/a-z/\" class=\"panel-header-links panel-header-link\">Full A-Z<span class=\"blq-hide\"> of BBC sites</span></a> </div> <div class=\"panel-component panel-links\"> <ul> <li> <a href=\"http://www.bbc.co.uk/cbbc/\" >CBBC</a> </li> <li> <a href=\"http://www.bbc.co.uk/cbeebies/\" >CBeebies</a> </li> <li> <a href=\"http://www.bbc.com/capital\" >Capital</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/food/\" >Food</a> </li> <li> <a href=\"http://www.bbc.co.uk/history/\" >History</a> </li> <li> <a href=\"http://www.bbc.co.uk/comedy/\" >Comedy</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/music/\" >Music</a> </li> <li> <a href=\"http://www.bbc.co.uk/science/\" >Science</a> </li> <li> <a href=\"http://www.bbc.co.uk/learning/\" >Learning</a> </li> </ul> <ul> <li> <a href=\"http://www.bbc.co.uk/local/\" >Local</a> </li> <li> <a href=\"http://www.bbc.com/travel/\" >Travel</a> </li> <li> <a href=\"http://www.bbc.co.uk/nature/\" >Nature</a> </li> </ul> </div> </div> ]]>\n\n\n bbc.fmtj.common.removeNoScript({});\n bbc.fmtj.common.tabs.createTabs({});\n\n\n\n\nvar _sf_async_config={};\n/** CONFIGURATION START **/\n_sf_async_config.uid = 50924; /** Chartbeat BBC id **/\n_sf_async_config.domain = \"bbc.co.uk\";/** BBC domain being tracked **/\n_sf_async_config.sections = \"s-news - technology\";\n_sf_async_config.region = \"international\";\n <!-- all multi-edition pages that are not indexes eg. story pages need the title -->\n var storyTitle = \"BBC+News+-+An+hour+to+catch+the+coding+bug\".replace(new RegExp('\\\\+' 'gi') ' ');//remove the plus signs\n storyTitle = decodeURIComponent(storyTitle.replace(\"BBC News - \" \"\"));//remove the sub-string 'BBC News' and convert utf-8 chars to html\n _sf_async_config.title = storyTitle;\n/** CONFIGURATION END **/\n(function(){\n var noCookies = true;\n if (\"object\" === typeof bbccookies && typeof bbccookies.readPolicy == 'function') {\n noCookies = !bbccookies.readPolicy().performance;\n }\n _sf_async_config.noCookies = noCookies;\n function loadChartbeat() {\n window._sf_endpt=(new Date()).getTime();\n var e = document.createElement(\"script\");\n e.setAttribute(\"language\" \"javascript\");\n e.setAttribute(\"type\" \"text/javascript\");\n e.setAttribute('src' '/inc/specials/cream/hi/news/chartbeat/chartbeat.js');\n document.body.appendChild(e);\n }\n var oldonload = window.onload;\n window.onload = (typeof window.onload != \"function\") ?\n loadChartbeat : function() { oldonload(); loadChartbeat(); };\n})();\n\n\n\n\n\n\n\n"
      }
     ],
     "prompt_number": 11
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "We got rid of the HTML tags, but we still have lots of \"non text\" - mainly javascript code.\nWe can still use beautifulsoup to navigate the HTML DOM structure and filter out the script blocks - this will be effective in this case.\n\nBut we can go faster and use the justext library.  This is developed specifically to remove boilerplate from html strings.\nIt uses a very nice machine learning algorithm which is documented in its homepage.\n\nMake sure you install the library first:\n\n% pip install justext\n\nNow let's try it:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "import justext\n\ndef clean_html2(html):\n    paragraphs = justext.justext(html, justext.get_stoplist('English'))\n    return \"\\n\".join([p.text for p in paragraphs if not p.is_boilerplate])\n\n",
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 12
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Let us try this second version of clean_html:"
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "print clean_html2(html)",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "I'm putting my twin 10-year-old boys Toby and Callum through the Hour of Code - a campaign that seeks to ignite an interest in programming - the part we're doing using specially created web-based exercises.\nThe campaign begun in the US has landed in the UK where it also coincides with government calls for as many children as possible to get coding.\nProgramming is being pushed because in an ever more technological world it can only be a good thing to give people a peep into what goes on behind the touch screen cash point and website.\nThe Hour of Code is supposed to be the start of that journey and I like many other parents feel it's one my children should be embarking on. I do feel like a clock somewhere is ticking and unless they get started with this essential skill they'll be left behind.\n\"In the future kids are going to be doing programming \" said Callum when I asked him why it was worth learning how to code. \"We need to learn so we can do stuff with the computer otherwise it will be a blank page and never work.\"\nZombie dance\nThe coding exercises involve familiar characters such as the Angry Birds\nIt's the getting started for both parents and their offspring that the Hour is intended to help with. I'm probably like most parents in that I have no significant qualification in computer science. All I can offer my boys is a lifetime of tinkering backed up over the past 18 months with online courses in Python HTML CSS Javascript and the like.\nThere's good precedents for the value of something like the Hour of Code. I've quizzed every chief technology officer (CTO) developer or IT worker I've met in the past couple of weeks about what got them started and every one knew exactly the moment they got it. Their eyes lit up as they talked about typing in code listings from magazines working through every Dos command or designing their own blocky 8-bit game characters.\nAnd finally at the back of my mind are all those statistics about the shortages of skilled IT staff and my hope that if this works then their future career options will be much wider than they would be without this skill.\nSo no pressure then.\nYesterday morning we gave it a go. I was keen for it to be fun rather than feel like school as there's nothing more likely to turn them off than for it to be sold as good for them. I think we struck the right note of informality - Cal did it in his onesie.\nIt went OK no better than that. Pretty good. We worked through all the exercises getting angry birds to mash pigs and zombies to chomp sunflowers. The coding is done by dragging blocks representing different commands into a work area and building the blocks into a tower of coherent instructions.\nThe block-building system is based on the Scratch programming language build by MIT's Mitch Resnick.\nThe exercises start easy - just getting an angry bird to hop on to a pig. By the end we were using \"If\u2026 else\" statements and loops to help a zombie navigate a tricky maze to reach the sunflower.\nThis went down well with Callum. \"Cool! It's scanning for a path \" he said as the zombie worked its way towards the hapless flower.\nMistakes were made but we learned from them we debated over which way to make the birds and zombies turn and the time went really fast.\nToby was surprised to find that this counted as programming.\n\"I thought coding was just a lot of people tapping in letter and numbers until they got it right \" he said.\nNext steps\nAnd yet I felt it was a bit too easy. I wanted to make the coding connection to real life more tangible. So as we had about 15 minutes of our Hour of Code left we went further.\nThis time we used the MIT App Inventor to build a basic program that would run on the tablets they own.\nThe app inventor uses the same \"drag the block\" method to build a program and following the instructions we had soon created an app that turned anything typed in text into speech.\nThe App Inventor uses the same block dragging system as the Hour of Code exercises\nWe got it working on Cal's tablet and soon they were getting that gadget to call out lots of phrases. Almost inevitably as they are 10 years old a lot of these phrases involved the words \"willy\" and \"bum\".\nBut they had a lot of fun with it and it brought home to them how straight-forward coding can be. In just over an hour they went from being pretty much novices to creating an Android app - a basic one that trades on the expertise of the people that built the coding tools but it was an accomplishment nonetheless.\nDid they catch the coding bug as a result?\nMaybe later in the day they were programming each other after one of their regular wrestling matches left Toby lying exhausted on the floor. Suddenly Cal called out commands such as \"roll left\" and Toby started obeying even to the point of crashing into the sofa when too many roll commands were given.\nThen Toby had his turn and did the same they even worked out that they had to compensate for the changes in left and right as they rolled.\nSo I think that hour started something. Both with them and with me. Building that Android app made me realise that it is straight-forward. That my lack of formal qualifications do not matter as much as I thought. And maybe that's the point of the hour. Making people realise that it is not scary and difficult. You just have to find an hour and give it a try. You can even do it in your onesie.\nThis page is best viewed in an up-to-date web browser with style sheets (CSS) enabled. While you will be able to view the content of this page in your current browser you will not be able to get the full visual experience. Please consider upgrading your browser software or enabling style sheets (CSS) if you are able to do so.\n"
      }
     ],
     "prompt_number": 13
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": "Tokenizing"
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Now that we have clean text, let us tokenize it into a list of words.\n\nWe will use nltk tokenizer to do this.  Make sure you have nltk installed, and that you invoke nltk.download() to download the datasets that come with it.\n\nThen let us try the tokenizer."
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "import nltk\n\ntokens = nltk.word_tokenize(clean_html2(html))\n\nprint(\"We found %s tokens\" % (len(tokens)))",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "We found 1154 tokens\n"
      }
     ],
     "prompt_number": 15
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "The output of justext is organized in paragraphs.  We converted them as one line of text each."
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "paragraphs = clean_html2(html).split(\"\\n\")\np0 = paragraphs[0]\nprint(nltk.word_tokenize(p0))",
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": "[u'I', u\"'m\", u'putting', u'my', u'twin', u'10-year-old', u'boys', u'Toby', u'and', u'Callum', u'through', u'the', u'Hour', u'of', u'Code', u'-', u'a', u'campaign', u'that', u'seeks', u'to', u'ignite', u'an', u'interest', u'in', u'programming', u'-', u'the', u'part', u'we', u\"'re\", u'doing', u'using', u'specially', u'created', u'web-based', u'exercises', u'.']\n"
      }
     ],
     "prompt_number": 16
    },
    {
     "cell_type": "markdown",
     "metadata": {},
     "source": "Note how the strings are returned as Unicode strings in Python.\n\nNote how abbreviations in English are tokenized (\"I'm\" becomes [\"I\", \"'m\"])."
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": "",
     "language": "python",
     "metadata": {},
     "outputs": []
    }
   ],
   "metadata": {}
  }
 ]
}